'''
Tribal Civilization - TribeInfo Module
2013 - Aliens Universal Wide 
by Benji Asperheim

'''

# START ----------------- Import Modules -----------
#!/usr/bin/python
#! /usr/bin/env python3

import sys, glob, random
from pygame import *
from pygame.locals import *
from decimal import *
import pygame.mixer
import re           # <-- this bit of code is needed to make a stand alone app with cx_freeze
includes = ["re"]   # <-- this bit of code is needed to make a stand alone app with cx_freeze
import pygame._view # <-- this bit of code is needed to make a stand alone app with cx_freeze
import pickle, os

sys.path.append("C:\Tribes")
clock = pygame.time.Clock()

# LOAD OBJECTS --------- Initiate PyGame Module and the "mixer" module
pygame.mixer.pre_init(44100, 16, 2, 4096) #frequency, size, channels, buffersize
pygame.init() #turn all of pygame on.

# START -- Determines location on Windows' Desktop to open Pygame Window
x = 50
y = 50
os.environ['SDL_VIDEO_WINDOW_POS'] = "%d,%d" % (x,y)

# START --------------- Window Display Modes
window = pygame.display.set_mode((1700, 1000))
#window = pygame.display.set_mode((1366,768))

# START ---------------- Color Objects ---------------------------
grey = (60,60,60)
white = (255,255,255)
black = (0,0,0)

red = (255, 0, 0)
darkRED = (70, 0, 0)
lightRED = (255, 100, 100)
pink = (253, 15, 28)

green = (0, 255, 0)
darkGRN = (0, 80, 0)
lightGRN = (100, 255, 100)

blue = (0, 0, 255)
darkBLU = (0, 0, 70)
lightBLU = (200, 200, 255)

brown = (69, 63, 4)
darkBRN = (40, 37, 2)
lightBRN = (237, 201, 175)


lightgrey = (180, 180, 180)
darkgrey = (25, 25, 25)
yellow = (255, 255, 224)
        
MapLocaX = 820
MapLocaY = 60
SecLocaX = 820
SecLocaY = 60

resLocaX = -330
resLocaY = 0
infLocaX = 100
infLocaY = 100

BuildWork = {}
BuildCost = {}
for num in range(1, 24):
    BuildWork[num] = 0
    BuildCost[num] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

# Sector Attribute Variables
ranFROST = random.randint(500,1000)
secTerra = {}
secOwn = {}
secRoad = {}
secWater = {}
secMineral = {}
secHealth = {}
secHappy = {}
secHerb = {}
secPop = {}
secMaxPop = {}
secBuilding = {}
secStorage = {}
secHousing = {}
ZoomTerra = {}
ZoomWater = {}
ZoomMineral = {}
ZoomHerb = {}
ZoomTrees = {}
BuildLabor = {}
ZoomBuild = {}
EnemyBuild = {}
ZoomWait = {}
ZoomConstruct = {}
ZoomLabor = {}
zoom_sector = {}
secDescribe = {}
secRange = {}
secSpeed = {}
IrrigateCheck = {}
secExplored = {}
OldResources = {}
NewResources = {}
CropPotential = {}

# Resource Building Cost Variables
GrainCost = {}
MeatCost = {}
ForageCost = {}
HerbCost = {}
PotteryCost = {}
AdobeCost = {}
GoldCost = {}
CopperCost = {}
BronzeCost = {}
CrystalCost = {}
StoneCost = {}
ClayCost = {}
WoodCost = {}

for keyerror in range(0, 26): # <--- Building costs for all 25 buildings
    GrainCost[keyerror] = 0
    MeatCost[keyerror] = 0
    ForageCost[keyerror] = 0
    HerbCost[keyerror] = 0
    PotteryCost[keyerror] = 0
    AdobeCost[keyerror] = 0
    GoldCost[keyerror] = 0
    CopperCost[keyerror] = 0
    BronzeCost[keyerror] = 0
    CrystalCost[keyerror] = 0
    StoneCost[keyerror] = 0
    ClayCost[keyerror] = 0
    WoodCost[keyerror] = 0
    
GrainCost[1] = 5

MeatCost[2] = 3
ClayCost[2] = 3
WoodCost[2] = 3

MeatCost[3] = 5
WoodCost[3] = 5

AdobeCost[4] = 20
WoodCost[4] = 10

MeatCost[6] = 3
StoneCost[6] = 3
WoodCost[6] = 3

AdobeCost[7] = 20
GoldCost[7] = 5
StoneCost[7] = 20
WoodCost[7] = 10

MeatCost[8] = 0 #40
PotteryCost[8] = 0 #10
StoneCost[8] = 0 #10
WoodCost[8] = 0 #20

MeatCost[9] = 0 #20
GoldCost[9] = 0 #20
CrystalCost[9] = 0 #10
StoneCost[9] = 0 #50
WoodCost[9] = 0 #20

MeatCost[10] = 5
HerbCost[10] = 5
PotteryCost[10] = 2
CrystalCost[10] = 5
WoodCost[10] = 5

GrainCost[11] = 10
WoodCost[11] = 5

ForageCost[12] = 10
StoneCost[12] = 2
WoodCost[12] = 5

AdobeCost[13] = 15
StoneCost[13] = 20
WoodCost[13] = 5

StoneCost[14] = 20
WoodCost[14] = 5

PotteryCost[15] = 10
StoneCost[15] = 5
WoodCost[15] = 10

ClayCost[16] = 5
WoodCost[16] = 10

AdobeCost[17] = 10
ClayCost[17] = 5
WoodCost[17] = 5

AdobeCost[18] = 5
StoneCost[18] = 10
ClayCost[18] = 5
WoodCost[18] = 5

MeatCost[19] = 5
WoodCost[19] = 20

WoodCost[20] = 5
AdobeCost[20] = 5
BronzeCost[20] = 10
StoneCost[20] = 10

MeatCost[21] = 5
CopperCost[21] = 5
StoneCost[21] = 5
WoodCost[21] = 10

HerbCost[22] = 50
PotteryCost[22] = 20
AdobeCost[22] = 100
GoldCost[22] = 50
CrystalCost[22] = 20
StoneCost[22] = 20

AdobeCost[23] = 500
GoldCost[23] = 200
BronzeCost[23] = 50
CrystalCost[23] = 50
StoneCost[23] = 200
WoodCost[23] = 50

GrainCost[25] = 5

# Resource1 - Variables
ownGrain = {}
ownMeat = {}
ownForage = {}
ownHerb = {}
ownPottery = {}
ownAdobe = {}
ownTools = {}

movGrain = {}
movMeat = {}
movForage = {}
movHerb = {}
movPottery = {}
movAdobe = {}
movPop = {}

waitGrain = {}
waitMeat = {}
waitForage = {}
waitHerb = {}
waitPottery = {}
waitAdobe = {}

# Resource2 - Variables
ownGold = {}
ownCopper = {}
ownBronze = {}
ownCrystal = {}
ownStone = {}
ownClay = {}
ownWood = {}

movGold = {}
movCopper = {}
movBronze = {}
movCrystal = {}
movStone = {}
movClay = {}
movWood = {}
movTools = {}

waitGold = {}
waitCopper = {}
waitBronze = {}
waitCrystal = {}
waitStone = {}
waitClay = {}
waitWood = {}
waitPop = {}
waitTools = {}

RangeCount = {}
BuildBoxes = {}
ConvoyBlu = {}
ConvoyRed = {}
ConvoyNeu = {}
ConvoyTurns = {}

# --- Pickle Variables ---
own_file = {}
sec_file = {}
loca_file = {}
mov_file = {}
wait_file = {}

own_file[1] = "\ownGR.p"
own_file[2] = "\ownME.p"
own_file[3] = "\ownFO.p"
own_file[4] = "\ownHE.p"
own_file[5] = "\ownPO.p"
own_file[6] = "\ownAD.p"
own_file[7] = "\ownGO.p"
own_file[8] = "\ownCO.p"
own_file[9] = "\ownBR.p"
own_file[10] = "\ownCR.p"
own_file[11] = "\ownST.p"
own_file[12] = "\ownCL.p"
own_file[13] = "\ownWO.p"
own_file[14] = "\ownTOOL.p"
own_file[15] = "\oldRES.p"
own_file[16] = "\ownRES.p"
own_file[17] = "\CROPpot.p"

mov_file[1] = "\movGR.p"
mov_file[2] = "\movME.p"
mov_file[3] = "\movFO.p"
mov_file[4] = "\movHE.p"
mov_file[5] = "\movPO.p"
mov_file[6] = "\movAD.p"
mov_file[7] = "\movGO.p"
mov_file[8] = "\movCO.p"
mov_file[9] = "\movBR.p"
mov_file[10] = "\movCR.p"
mov_file[11] = "\movST.p"
mov_file[12] = "\movCL.p"
mov_file[13] = "\movWO.p"
mov_file[14] = "\movPOP.p"
mov_file[15] = "\movTOOL.p"

wait_file[1] = "\waitGR.p"
wait_file[2] = "\waitME.p"
wait_file[3] = "\waitFO.p"
wait_file[4] = "\waitHE.p"
wait_file[5] = "\waitPO.p"
wait_file[6] = "\waitAD.p"
wait_file[7] = "\waitGO.p"
wait_file[8] = "\waitCO.p"
wait_file[9] = "\waitBR.p"
wait_file[10] = "\waitCR.p"
wait_file[11] = "\waitST.p"
wait_file[12] = "\waitCL.p"
wait_file[13] = "\waitWO.p"
wait_file[14] = "\waitPOP.p"
wait_file[15] = "\waitTOOL.p"
wait_file[16] = "\waitZoom.p"

sec_file[1] = "\secTER.p"
sec_file[2] = "\secROA.p"
sec_file[3] = "\secWAT.p"
sec_file[4] = "\secMIN.p"
sec_file[5] = "\secHEA.p"
sec_file[6] = "\secHER.p"
sec_file[7] = "\secZOT.p"
sec_file[8] = "\secZOB.p"
sec_file[9] = "\secZOS.p"
sec_file[10] = "\secVIE.p"
sec_file[11] = "\secDES.p"
sec_file[12] = "\secOWN.p"
sec_file[13] = "\secPOP.p"
sec_file[14] = "\secMAX.p"
sec_file[15] = "\moons.p"
sec_file[16] = "\zoomTREES.p"
sec_file[17] = "\secBUILD.p"
sec_file[18] = "\construct.p"
sec_file[19] = "\zoomWATER.p"
sec_file[20] = "\zoomMINER.p"
sec_file[21] = "\zoomLABOR.p"
sec_file[22] = "\zoomHERB.p"
sec_file[23] = "\moonphase.p"
sec_file[24] = "\secHAPPY.p"
sec_file[25] = "\labor.p"
sec_file[26] = "\secExplore.p"
sec_file[27] = "\enemyBUILD.p"

loca_file[1] = "\start"
loca_file[2] = "\mapX"
loca_file[3] = "\mapY"
loca_file[4] = "\secX"
loca_file[5] = "\secY"
loca_file[6] = "\infX"
loca_file[7] = "\infY"
loca_file[8] = "\selX"
loca_file[9] = "\selY"
loca_file[10] = "\staX"
loca_file[11] = "\staY"
loca_file[12] = "\convoyB"

SelectX = 1
SelectY = 1
SectorX = 1
SectorY = 1

StartX = random.randint(60, 90)
StartY = random.randint(60, 90)
StartSector = (StartY * 150) + StartX

# START ---------------- Other Objects --------------------------
scroll_speed = 5

# START ---------------- Fonts ---------------------------------
fontSSS = 15
fontSS = 20
fontS = 25
fontSM = 30
fontM1 = 35
fontM = 40
fontML = 55
fontL = 80

font1=pygame.font.Font("c:\Tribes/font/quadrtic.ttf", fontM)
font2=pygame.font.Font("c:\Tribes/font/metal5.ttf", fontS)
font3=pygame.font.Font("c:\Tribes/font/metal5.ttf", fontSS)
font4=pygame.font.Font("c:\Tribes/font/metal5.ttf", fontSSS)
font5=pygame.font.Font("c:\Tribes/font/metal5.ttf", fontM1)
font6=pygame.font.Font("c:\Tribes/font/quadrtic.ttf", fontS)
font7=pygame.font.Font("c:\Tribes/font/quadrtic.ttf", fontSM)
font8=pygame.font.Font("c:\Tribes/font/quadrtic.ttf", fontM)
font9=pygame.font.Font("c:\Tribes/font/metal5.ttf", fontSM)
font10=pygame.font.Font("c:\Tribes/font/quadrtic.ttf", fontML)
font11=pygame.font.Font("c:\Tribes/font/quadrtic.ttf", fontSS)

msg_terra1 = font1.render("Plains biome", 1,(black))
msg_terra2 = font1.render("Forest biome", 1,(black))
msg_terra3 = font1.render("Desert biome", 1,(black))
msg_terra4 = font1.render("Mountain biome", 1,(black))
msg_terra5 = font1.render("Water biome", 1,(black))
msg_terra6 = font1.render("Tundra biome", 1,(black))
msg_terra7 = font1.render("Island biome", 1,(black))

msg_terra10 = font1.render("Wetland biome", 1,(black))
msg_terra20 = font1.render("Marsh biome", 1,(black))
msg_terra30 = font1.render("Oasis biome", 1,(black))
msg_terra40 = font1.render("Mountain Falls", 1,(black))
msg_terra60 = font1.render("Rock-Tundra", 1,(black))

#text_gold = font1.render(str(gold), 1,(black))
#text_crys = font1.render(str(crystal), 1,(black))
#text_herb = font1.render(str(herbs), 1,(black))
#text_heal = font1.render(str(health), 1,(black))

# START --------------- Objects for the Oracle Messages ------------------------
msg_gold1 = font4.render("'Teocuitlatl' is Náhuatl", 1,(white))
msg_gold2 = font4.render("for gold (literally it", 1,(white))
msg_gold3 = font4.render("means 'wonderful waste').    ", 1,(white))
msg_gold4 = font4.render("", 1,(white))
msg_gold5 = font3.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_copp1 = font4.render("Copper can be made into", 1,(white))
msg_copp2 = font4.render("a bronze alloy to make", 1,(white))
msg_copp3 = font4.render("stronger weapons and tools.", 1,(white))
msg_copp4 = font4.render("", 1,(white))
msg_copp5 = font3.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_bronze1 = font4.render("Fashion bronze weapons", 1,(white))
msg_bronze2 = font4.render("and tools using a furnace.", 1,(white))
msg_bronze3 = font4.render("", 1,(white))
msg_bronze4 = font4.render("                          ", 1,(white))
msg_bronze5 = font3.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_crys1 = font4.render("The Cherokee would place", 1,(white))
msg_crys2 = font4.render("seven large crystals in a", 1,(white))
msg_crys3 = font4.render("stream, and submerge the", 1,(white))
msg_crys4 = font4.render("people for cleansing.", 1,(white))
msg_crys5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_stone1 = font4.render("Stone is essential for large", 1,(white))
msg_stone2 = font4.render("infrastructure and stone.", 1,(white))
msg_stone3 = font4.render("Drag workers onto the map and", 1,(white))
msg_stone4 = font4.render("make them quarry.", 1,(white))
msg_stone5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_food1 = font4.render("This is your total food", 1,(white))
msg_food2 = font4.render("supply. The more variety", 1,(white))
msg_food3 = font4.render("you have, the happier and", 1,(white))
msg_food4 = font4.render("healthier people will be.", 1,(white))
msg_food5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_grain1 = font4.render("Grow grains and vegetables", 1,(white))
msg_grain2 = font4.render("by placing workers on a farm.", 1,(white))
msg_grain3 = font4.render("Wild rice farms also produce", 1,(white))
msg_grain4 = font4.render("grains.", 1,(white))
msg_grain5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_meat1 = font4.render("Place your workers on a", 1,(white))
msg_meat2 = font4.render("hunting camp and make them", 1,(white))
msg_meat3 = font4.render("hunt for game. Bronze weapons", 1,(white))
msg_meat4 = font4.render("are more efficient.", 1,(white))
msg_meat5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_clay1 = font4.render("Harvest clay in wet earth,", 1,(white))
msg_clay2 = font4.render("and make it into adobe", 1,(white))
msg_clay3 = font4.render("bricks or pottery.", 1,(white))
msg_clay4 = font4.render("", 1,(white))
msg_clay5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_wood1 = font4.render("Wood is used for pottery and", 1,(white))
msg_wood2 = font4.render("melting bronze alloy. It is", 1,(white))
msg_wood3 = font4.render("essential for cooking, and", 1,(white))
msg_wood4 = font4.render("as a building material also.", 1,(white))
msg_wood5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_forage1 = font4.render("Drag your workers onto an", 1,(white))
msg_forage2 = font4.render("empty square and make them", 1,(white))
msg_forage3 = font4.render("forage for food. It's not", 1,(white))
msg_forage4 = font4.render("very efficient, but it's food.", 1,(white))
msg_forage5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_herb1 = font4.render("Shaman use medicinal herbs for", 1,(white))
msg_herb2 = font4.render("healing and cleansing.", 1,(white))
msg_herb3 = font4.render("Make workers forage for herbs", 1,(white))
msg_herb4 = font4.render("on empty land.", 1,(white))
msg_herb5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_pot1 = font4.render("Pottery is made from clay. It", 1,(white))
msg_pot2 = font4.render("is used to store food and to", 1,(white))
msg_pot3 = font4.render("increase living standards.", 1,(white))
msg_pot4 = font4.render("", 1,(white))
msg_pot5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_adobe1 = font4.render("Adobe brick is made from", 1,(white))
msg_adobe2 = font4.render("fired clay. The bricks help", 1,(white))
msg_adobe3 = font4.render("to make better infrastructure.", 1,(white))
msg_adobe4 = font4.render("", 1,(lightgrey))
msg_adobe5 = font4.render("Press 'r' to toggle resources.", 1,(lightgrey))

msg_heal1 = font3.render("Good food, water, and healing-plants", 1,(black))
msg_heal2 = font3.render("Didanawisgi is the Cherokee word for medicine man.", 1,(black))

msg_sect1 = font3.render("This is a close-up view of a village.", 1,(black))
msg_sect2 = font3.render("To zoom-out you can click here, or just press [ESC].", 1,(black))

msg_red1 = font3.render("'ticualanini' is the Náhuatl word for 'irritable'.", 1,(black))
msg_red2 = font3.render("Literally: 'you are in the habit of becoming angry'.", 1,(black))
msg_neu1 = font3.render("The Hurons called The Neutrals 'Attawandaron'.", 1,(black))
msg_neu2 = font3.render("It meant 'people whose speech is a little different'", 1,(black))
msg_blu1 = font3.render("'nocenyeliz' is Aztec (Náhuatl) for 'my family'.", 1,(black))

tribeRED = font4.render("Ticualanini Tribe", 1,(red))
tribeBLU = font4.render("Nocenyeliz Tribe", 1,(blue))
tribeNEU = font4.render("Attawandaron Tribe", 1,(brown))

msg_loc = 120
