'''
Tribal Civilization - Main
2013 - Aliens Universal Wide
by Benji Asperheim

'''

# --- START ---------------- IMPORT objects from MODULES ----------------------
#! /usr/bin/env python3
from TribeInfo import * # <-- IMPORTS objects and variables from "TribalInfo.py"
from TribePics import * # <-- IMPORTS objects that store blit/picture information

# --- START --- Format the game window
pygame.display.set_icon(icon)
pygame.display.set_caption("Tribal Civilization")
pygame.key.set_repeat(500, 50)

ScreenModes = 0
SecLocaY = 60
SecLocaX = 720
MapLocaX = 800

try:
    screen_mode = pygame.display.set_mode((1280,720),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode
except pygame.error:
    screen_mode = pygame.display.set_mode((1366,768),pygame.RESIZABLE)  # <--- Larger Rez Laptop Mode

#SecLocaY = 60
#SecLocaX = 780
#MapLocaX = 800

'''
screen_mode = pygame.display.set_mode((1280,720), pygame.RESIZABLE)  # <--- Netbook Fullscreen Mode
screen_mode = pygame.display.set_mode((1024,768),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode
screen_mode = pygame.display.set_mode((1366,768),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode                   
'''

# START ---------------------- Loading screen while Terrain Generates -------------------------
LoadToggle = False
NewMap = True
Viewed = 0
while NewMap:
    window.blit(background,(1, 1))
    window.blit(boxLOADING,(400, 100))
    ranPic = random.randint(1,7)
    if ranPic == 1:
        window.blit(infoDES,(310, 310))
    if ranPic == 2:
        window.blit(infoMON,(310, 310))
    if ranPic == 3:
        window.blit(infoGOLD,(310, 310))
    if ranPic == 4:
        window.blit(infoPLA,(310, 310))
    if ranPic == 5:
        window.blit(infoFOR,(310, 310))
        window.blit(infoPYRAMID2,(315, 310))
    if ranPic == 6:
        window.blit(infoDESw,(310, 310))
    if ranPic == 7:
        window.blit(infoMONw,(310, 310))
        
    window.blit(boxINFOlarge,(300, 300))
    pygame.display.flip()
    window.fill(black)

    # START ---------------------- Starting Objects and Variables -------------------------
    Viewed = 1
    MoonCycle = 1
    MoonPhase = 1
    counter = 0
    LastKey = 0

# --- KEYERROR PROTECTION -- Assigns values to arrays beforehand to avoid future keyerrors    
    for keyerror in range(-6, 50):
        ZoomWater[keyerror] = 0
        ZoomMineral[keyerror] = 0
        ZoomHerb[keyerror] = 0
        ZoomTerra[keyerror] = 0
        ZoomTrees[keyerror] = 0
        ZoomLabor[keyerror] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] # <-- 20 different labor tasks
        BuildLabor[keyerror] = 0
        ZoomWait[keyerror] = -1
        ZoomBuild[keyerror] = -1
        EnemyBuild[keyerror] = 0
        ZoomConstruct[keyerror] = -1
        zoom_sector[keyerror] = 0
        IrrigateCheck[keyerror] = 0
        CropPotential[keyerror] = 0

    for keyerror in range(-400, 22800): 
    # Resource1 Ownership Variables
        ownGrain[keyerror] = 0
        ownMeat[keyerror] = 0
        ownForage[keyerror] = 0
        ownHerb[keyerror] = 0
        ownPottery[keyerror] = 0
        ownAdobe[keyerror] = 0
        movGrain[keyerror] = 0
        movMeat[keyerror] = 0
        movForage[keyerror] = 0
        movHerb[keyerror] = 0
        movPottery[keyerror] = 0
        movAdobe[keyerror] = 0
        waitGrain[keyerror] = 0
        waitMeat[keyerror] = 0
        waitForage[keyerror] = 0
        waitHerb[keyerror] = 0
        waitPottery[keyerror] = 0
        waitAdobe[keyerror] = 0

    # Resource2 Ownership Variables
        ownGold[keyerror] = 0
        ownCopper[keyerror] = 0
        ownBronze[keyerror] = 0
        ownCrystal[keyerror] = 0
        ownStone[keyerror] = 0
        ownClay[keyerror] = 0
        ownWood[keyerror] = 0
        ownTools[keyerror] = 0
        movGold[keyerror] = 0
        movCopper[keyerror] = 0
        movBronze[keyerror] = 0
        movCrystal[keyerror] = 0
        movStone[keyerror] = 0
        movClay[keyerror] = 0
        movWood[keyerror] = 0
        movPop[keyerror] = [0, 0, 0] #0 is Sector's Population, #1 is Sector's Health, #2 is Sector's Happiness 
        movTools[keyerror] = 0
        waitGold[keyerror] = 0
        waitCopper[keyerror] = 0
        waitBronze[keyerror] = 0
        waitCrystal[keyerror] = 0
        waitStone[keyerror] = 0
        waitClay[keyerror] = 0
        waitWood[keyerror] = 0
        waitPop[keyerror] = 0
        waitTools[keyerror] = 0
        OldResources[keyerror] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
        NewResources[keyerror] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

    # Sector Attribute Variables to Avoid Keyerrors
        secBuilding[keyerror] = [0, 0, 0]  # <--Building types for drawing Mini buildings to 50 x 50 LARGE MAP
        secRoad[keyerror] = 0
        secWater[keyerror] = 0
        secMineral[keyerror] = 0
        secHealth[keyerror] = 0
        secHerb[keyerror] = 0
        secPop[keyerror] = 0
        secMaxPop[keyerror] = 0
        zoom_sector[keyerror] = 0
        secDescribe[keyerror] = 0
        secOwn[keyerror] = 0
        secRange[keyerror] = 21
        secSpeed[keyerror] = 0
        secHappy[keyerror] = 0
        secExplored[keyerror] = 1
        secHousing[keyerror] = 0
        secStorage[keyerror] = 0

        RangeCount[keyerror] = 0
        ConvoyBlu[keyerror] = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1] # <--- 30 + 1 values        
        ConvoyTurns[keyerror] = -1
        
        ranFROST = random.randint(500,1500)
        ranTerra = random.randint(1,1000)
        
        if keyerror < ranFROST:   # <-- beyond the 'poles' of the map only 'Tundra' is possible
            secTerra[keyerror] = 6
        elif keyerror > (22500-ranFROST): # <-- 6 = Random value for "frost biome". Only possible at north/south ends of map
            secTerra[keyerror] = 6
        elif ranTerra in range(0, 250):   # <-- 1 = Random value for "plains biome"
            secTerra[keyerror] = 1
        elif ranTerra in range(250, 380):   # <-- 2 = Random value for "forest biome"
            secTerra[keyerror] = 2
        elif ranTerra in range(380, 600):   # <-- 3 = Random value for "desert biome"
            secTerra[keyerror] = 3
        elif ranTerra in range(600, 720):   # <-- 4 = Random value for "mountain biome"
            secTerra[keyerror] = 4
        elif ranTerra in range(720, 1001):  # <-- 5 = Random value for "water biome"
            secTerra[keyerror] = 5
        else:
            secTerra[keyerror] = 1


    # --- TERRAIN/BIOME RANDOM GENERATOR --- This next bit of code "stretches" out the biomes to cover a larger area
    TerraChance = 42         # <------ The smaller this number, the larger and more spread out the various biomes will be
    tCount = 1
    TerraLoop = True
    while TerraLoop:
        ranLuck = random.randint(1,100)
        if secTerra[tCount+1] == secTerra[tCount] and ranLuck/2 > TerraChance:
            secTerra[tCount + 2] = secTerra[tCount]
            secTerra[tCount + 3] = secTerra[tCount]
        elif secTerra[tCount+1] != secTerra[tCount] and ranLuck/4 > TerraChance:
            secTerra[tCount + 1] = secTerra[tCount]
            secTerra[tCount + 2] = secTerra[tCount]

        if secTerra[tCount-1] == secTerra[tCount] and ranLuck/2 > TerraChance:
            secTerra[tCount - 2] = secTerra[tCount]
            secTerra[tCount - 3] = secTerra[tCount]
        elif secTerra[tCount-1] != secTerra[tCount] and ranLuck/4 > TerraChance:
            secTerra[tCount - 1] = secTerra[tCount]
            secTerra[tCount - 2] = secTerra[tCount]
            
        if secTerra[tCount+150] == secTerra[tCount] and ranLuck > TerraChance:
            secTerra[tCount + 148] = secTerra[tCount]
            secTerra[tCount + 149] = secTerra[tCount]
            secTerra[tCount + 151] = secTerra[tCount]
            secTerra[tCount + 152] = secTerra[tCount]
        elif secTerra[tCount+150] != secTerra[tCount] and ranLuck/2 > TerraChance:
            secTerra[tCount + 149] = secTerra[tCount]
            secTerra[tCount + 150] = secTerra[tCount]
            secTerra[tCount + 151] = secTerra[tCount]

        if secTerra[tCount-150] == secTerra[tCount] and ranLuck > TerraChance:
            secTerra[tCount - 148] = secTerra[tCount]
            secTerra[tCount - 149] = secTerra[tCount]
            secTerra[tCount - 151] = secTerra[tCount]
            secTerra[tCount - 152] = secTerra[tCount]
        elif secTerra[tCount-150] != secTerra[tCount] and ranLuck/2 > TerraChance:
            secTerra[tCount - 149] = secTerra[tCount]
            secTerra[tCount - 150] = secTerra[tCount]
            secTerra[tCount - 151] = secTerra[tCount]
        
        if tCount < 1:
            secTerra[tCount] = 0
            
        if tCount > 22500:
            secTerra[tCount] = 0
            
        tCount+=1
        if tCount > 22500:
            TerraLoop = False

    # --- RESOURCES RANDOM GENERATOR ---
    StartGame = True
    ResourceLoop = True
    resource = 0

    while ResourceLoop:
    # --- RESOURCES RANDOM GENERATOR --- Randomly determines the terrain type and terrain attributes
        ranWater = random.randint(5, 40)
        ranMineral = random.randint(10, 15)
        ranHerb = random.randint(1, 8)
        ForestChance = random.randint(1, 100)
        secWater[resource] = ranWater
        secMineral[resource] = ranMineral
        
        if secTerra[resource] == 1:      # <----- Conditions if sector is PLAINS biome
            secWater[resource] = int(ranWater*0.9)
            secMineral[resource] = int(ranMineral*0.3)
            secHerb[resource] = int(ranHerb*0.7)
            
        elif secTerra[resource] == 2:      # <----- Conditions if sector is FOREST biome
            secWater[resource] = int(ranWater*1.1)
            secMineral[resource] = int(ranMineral*0.5)
            secHerb[resource] = int(ranHerb*1.5)
            
        elif secTerra[resource] == 3:      # <----- Conditions if sector is DESERT biome
            ranOasis = random.randint(-100, 100)
            secWater[resource] = int(ranWater*0.2)
            secMineral[resource] = int(ranMineral*0.9)
            secHerb[resource] = int(ranHerb*1.8)
            if ranOasis > 95:
                secWater[resource] += int(ranWater*1.2)
            if secWater[resource] > 20:
                secHerb[resource] += int(ranHerb*2)
            
        elif secTerra[resource] == 4:      # <----- Conditions if sector is MOUNTAIN biome
            secWater[resource] = int(ranWater*0.8)
            secMineral[resource] = int(ranMineral*2.5)
            secHerb[resource] = int(ranHerb*1.2)
            
        elif secTerra[resource] == 5:      # <----- Conditions if sector is WATER biome
            secWater[resource] = int(ranWater*2.4)
            secMineral[resource] = 0
            secHerb[resource] = int(ranHerb*0.2)
            
        elif secTerra[resource] == 6:      # <----- Conditions if sector is FROST biome
            secWater[resource] = int(ranWater*0.1)
            secMineral[resource] = int(ranMineral*2)
            secHerb[resource] = int(ranHerb*0.1)
            ranMOUNTAIN = random.randint(1,1000)
            if ranMOUNTAIN > 900:
                secMineral[resource] += int(ranMOUNTAIN*.03)
                
        elif secTerra[resource] == 7:      # <----- Conditions if sector is ISLAND biome
            secWater[resource] = int(ranWater*1.9)
            secMineral[resource] = int(ranMineral*.2)
            secHerb[resource] = int(ranHerb*1.3)
        if secTerra[resource] == 5 and secWater[resource] < 15:
            secTerra[resource] = 7

        if resource > 0:
            if secTerra[resource-150] == 5:
                secWater[resource] += int(ranWater*.1)
                if ForestChance > 30 and secTerra[resource-150] != 5:
                    secTerra[resource-150] = 2
        if resource < 22500:
            if secTerra[resource+150] == 5:
                secWater[resource] += int(ranWater*.1)
                if ForestChance > 80 and secTerra[resource+150] != 5:
                    secTerra[resource+150] = 2

        if secTerra[resource-1] == 5:
            secWater[resource] += int(ranWater*.1)
            if ForestChance > 60 and secTerra[resource-1] != 5:
                secTerra[resource+1] = 2
        if secTerra[resource+1] == 5:
            secWater[resource] += int(ranWater*.1)
            if ForestChance > 60 and secTerra[resource+1] != 5:
                secTerra[resource+1] = 2

        if secTerra[resource] == 1:
            secSpeed[resource] = 4     # <-- Movement speed in 'plains' biome
        if secTerra[resource] == 2:
            secSpeed[resource] = 6     # <-- Movement speed in 'forest' biome
        if secTerra[resource] == 3:
            secSpeed[resource] = 5     # <-- Movement speed in 'desert' biome
        if secTerra[resource] == 4:
            secSpeed[resource] = 8     # <-- Movement speed in 'mountain' biome
        if secTerra[resource] == 5:
            secSpeed[resource] = 0     # <-- Movement speed in 'water' biome
        if secTerra[resource] == 6:
            secSpeed[resource] = 6     # <-- Movement speed in 'frost' biome
        if secTerra[resource] == 7:
            secSpeed[resource] = 2     # <-- Movement speed in 'island' biome

        ranResource = random.randint(-300, 1) # <---------------- Starts sectors off with random Pyramids
        if ranResource > 0 and (secTerra[resource] != 5) and (secTerra[resource] != 7):
            secBuilding[resource][0] = 23 
            
        ranEnemy = random.randint(-400, 1) # <----- Enemy Tribes
        if (resource > 6000 and resource < 13000):
            if ranEnemy > 0 and (secTerra[resource] != 5) and (secTerra[resource] != 7):
                secOwn[resource] = 2

        resource += 1
        if resource > 22700:
            ResourceLoop = False

# --- START - Start Sector Loop to determine where the start sector is
    StartSectorLoop = True
    StartX = 49
    StartY = 65   # <------- Starts player at Sector #9800
    while StartSectorLoop:            
        StartX += 1
        if StartX > 149:
            StartY += 1
            StartX = 1
        if StartY > 149:
            StartY = 1
        StartSector = (StartY * 150) + StartX
        if secTerra[StartSector] != 5 and secWater[StartSector] > 20:
            StartSectorLoop = False

    Clicked = StartSector
    ClickedX = StartX-10
    ClickedY = StartY-5
    Selector = 1
    TempSector = StartSector
    BoxSector = StartSector
     
# --- START --- Starting resources for player
    ranPop = random.randint(15, 20)
    ranMeat = random.randint(70, 80)
    ranGrain = random.randint(70, 80)
    ranForage = random.randint(70, 80)
    ranPottery = random.randint(70, 80)
    ranClay = random.randint(70, 80)
    ranWood = random.randint(70, 80)
    ranStone = random.randint(70, 80)
    
    for test in range(StartSector, StartSector+1):
        if secTerra[test] != 5:
            secPop[test] = ranPop
            secHappy[test] = 100
            secHealth[test] = 100
            
            ownGrain[test] = 20
            ownPottery[test] = 20
            ownForage[test] = 20
            ownMeat[test] = 20
            ownClay[test] = 20
            ownWood[test] = 20

    secOwn[StartSector] = 1

# --- START ---------------------- Variables -------------------------
    StatTimer = 5
    ClickTimer = 0
    ResourceTimer = 0
    
    BoxZoomSector = 0
    ZoomSector = 0
    ZoomClick = 0
    ZoomClickX = 0
    ZoomClickY = 0
    ZoomX = 0
    ZoomY = 0
    ZoomLocaX = 0
    ZoomLocaY = 0
    SectX = 0
    SectY = 0
    range_clicks = 0
    old_sector = 0
    new_sector = 0
    reset = 0
    move = 0

    frames = 0
    ticky2 = 0
    slow_frames = 0
    slower_frames = 0
    click_number = 0
    TickPause = 0
    RowCheck = -20
    SecCheck = StartSector

    ConvoyToggle = False
    supply_route = 0

    BoxSector = 1
    MiniBoxSector = BoxSector
    RightClick = StartSector
    sector = 1
    SaveFile = 1
    mouseX = 550
    mouseY = 250
    CursorX = 0
    CursorY = 0
    ClickX = 0
    ClickY = 0
    MiniLocX = 0
    MiniLocY = 0
    MiniX = StartX
    MiniY = StartY
    mouse.set_pos(550, 250) # <-- Set mouse cursor position to middle of map

    BuildBox = False
    LaborBox = False
    SectorZoom = False
    MapToggle = False
    UnitToggle = False
    ResToggle1 = False
    ResToggle2 = False

    MoveReset = True
    MoveLoop = False
    MenuLoop = False
    SaveToggle = False
    HomeToggle = False

    MineralToggle = False
    WaterToggle = False
    HealthToggle = False
    HerbToggle = False
    HappyToggle = False
    InfoToggle = False
    MoonCycleStart = False
    
    MiniClick = False
    EscapeToggle = False

    MoveResource = 0
    
    ScrollX = 300
    ScrollY = resLocaY+18
    ScrollClick = 0
    ScrollSelect = [0, 0, 0, 0]
    Storage = 0

    LaborScroll = resLocaY + 440
    LaborClick = -1
    local_labor = 0
    labors = 0
    local_workers = 0
    TotalWorkers = 0
    IdleWorkers = 0
    
    local_count = 0
    laboring = 0

    MainLoop = True
    NewMap = False                        # <-------- Terrain and Resource Generator loop ends here.
    FoodBonus = 0
    HungryPeople = 0
    SattPeople = 0
    FullPeople = 0
    
# <------------------MAIN LOOP!
# --- MAIN LOOP BEGINS---------- Starts MainLoop and checks for certain conditions
    while MainLoop:
        if Clicked < 0:
            Clicked = 0
        if Clicked > 22500:
            Clicked = 22500
        LocalGoods = 0
        AvailablePottery = 0
        AvailableStorage = 0
                   
        #try:
        #    soundObj = pygame.mixer.Sound('sound\woosh.wav')
        #    soundObj.play()
        #except pygame.error:

        resMouseX = mouseX - resLocaX   # <--- X Mouse location for resources in resource box
        resMouseY = mouseY - resLocaY   # <--- Y Mouse location for resources in resource box
        if range_clicks > 0:
            EscapeToggle = False
        if supply_route > 40:
            supply_route = 0
        if SectorZoom == False:
            BuildBox = False
            LaborBox = False
        if BuildBox == True:
            if ScrollClick > 0:          # <--------- "z" key saves keystroke                
                LastKey = ScrollClick
            LaborClick = -1        
            ResToggle1 = False
            ResToggle2 = False
            LaborBox = False
            MapToggle = False
            EscapeToggle = False
        elif LaborBox == True:
            ResToggle1 = False
            ResToggle2 = False
            BuildBox = False
            MapToggle = False
            EscapeToggle = False      
        else:
            ScrollSelect = [0, 0, 0, 0]
            ScrollClick = 0
        if ScrollClick > 0 and ScrollClick != 9:
            pygame.mouse.set_visible(False)
        else:
            pygame.mouse.set_visible(True)       
            
# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Conditions for new Turn or MoonCycle
        route_num = 0
        while MoonCycleStart:
            MoonPhase += 1
            if MoonPhase == 5:
                MoonPhase = 1
                MoonCycle += 1
                
# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Calculate housing and population
            for count in range(-200, 22700):
                secHousing[count] = 0
                secStorage[count] = 0
                if secPop[count] > 0:
                    for resources in range(0, 14):
                        OldResources[count][resources] = 0
                    OldResources[count][0] += ownGrain[count]
                    OldResources[count][1] += ownMeat[count]
                    OldResources[count][2] += ownForage[count]
                    OldResources[count][3] += ownHerb[count]
                    OldResources[count][4] += ownPottery[count]
                    OldResources[count][5] += ownAdobe[count]
                    OldResources[count][6] += ownGold[count]
                    OldResources[count][7] += ownCopper[count]
                    OldResources[count][8] += ownBronze[count]
                    OldResources[count][9] += ownCrystal[count]
                    OldResources[count][10] += ownStone[count]
                    OldResources[count][11] += ownClay[count]
                    OldResources[count][12] += ownWood[count]
                    OldResources[count][13] += secPop[count]
                    ZoomPosition = 0
                    for terra in range(zoom_sector[count], zoom_sector[count]+36):
                        ZoomPosition += 1
                        if ZoomBuild[terra] in range(2, 8):
                            secHousing[count] += int(ZoomBuild[terra]*2)
                            secStorage[count] += int(ZoomBuild[terra]*10)
                        elif ZoomBuild[terra] in range(8, 10):
                            secStorage[count] += int(ZoomBuild[terra]*15)
                        elif ZoomBuild[terra] == 10 or ZoomBuild[terra] == 12: 
                            secStorage[count] += int(ZoomBuild[terra]*3)
                        elif ZoomBuild[terra] == 15:
                            secStorage[count] += int(ZoomBuild[terra]*30)                            
                    
                        if ZoomPosition in range(8,37) and ZoomBuild[terra-1] == 2 and ZoomBuild[terra] == 2 and ZoomBuild[terra-6] == 2 and ZoomBuild[terra-7] == 2:
                            secHousing[count] +=2
                            secStorage[count] += 20
                        elif (ZoomPosition in range(1,30) and ZoomBuild[terra] == 3) and (ZoomBuild[terra+1] == 3 and ZoomBuild[terra+6] == 3 and ZoomBuild[terra+7] == 3):
                            secHousing[count] += 4
                            secStorage[count] += 30
                        elif ZoomPosition in range(2,36) and ZoomBuild[terra-1] == 4 and ZoomBuild[terra] == 4:
                            secHousing[count] += 5
                            secStorage[count] += 40
                        elif ZoomPosition in range(8,37) and ZoomBuild[terra-1] == 3 and ZoomBuild[terra] == 3 and ZoomBuild[terra-6] == 3 and ZoomBuild[terra-7] == 3:
                            secHousing[count] += 4
                            secStorage[count] += 30                     
                    Homeless = secPop[count] - secHousing[count]   # <-- Calculate homeless population
                    if Homeless > 0:
                        secHappy[count] -= int(Homeless/2)  # <-- People will be unhappy if there are homeless
                        secPop[count] = secHousing[count]   # <-- kill off homeless population
                    if secPop[count] > secHousing[count]:
                        secPop[count] = secHousing[count]
                    if secPop[count] > 50:
                        secHappy[count] -= int(secPop[count]/50)   # <-- Higher population (crowded population) make for unhappy people
 
# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Food and Starvation Levels
                    if secPop[count] > 0:
                        print ("Sector: ", count)
                        FoodBonus = 0     # <-- Start off with 0 food bonus level
                        HungryPeople = secPop[count]
                        while HungryPeople > 0:
                            if (ownForage[count] > 1 and HungryPeople > 0): # <-- 2 Forage needed
                                ownForage[count] -= 2
                                HungryPeople -= 1
                            if (ownMeat[count] > 0 and HungryPeople > 0):  # <-- 1 meat needed per person
                                ownMeat[count] -= 1
                                HungryPeople -= 1
                            if (ownGrain[count] > 2 and HungryPeople > 0): # <-- 3 grain needed per person
                                ownGrain[count] -= 3
                                HungryPeople -= 1
                            if (ownMeat[count] < 1 and ownForage[count] < 2 and ownGrain[count] < 3) and (HungryPeople > 0):
                                ownMeat[count] = 0
                                ownForage[count] = 0
                                ownGrain[count] = 0
                                secPop[count] -= HungryPeople  # <-- Kill off starving people
                                secHappy[count] -= HungryPeople # <-- Happiness goes down if people starve..
                                secHealth[count] -= HungryPeople # <-- Health goes down if people starve..
                                print ("Hungry: ", HungryPeople)
                                HungryPeople = 0
                        if (ownMeat[count] > 0 or ownForage[count] > 0 or ownGrain[count] > 0):
                            FoodBonus += 1
                            print ("FoodBonus: ", FoodBonus)

                            if (ownForage[count] > 1) and (ownGrain[count] > 2 or ownMeat[count] > 0):
                                SattPeople = int(secPop[count]/2)
                                while SattPeople > 0:
                                    if (ownForage[count] > 1 and SattPeople > 0): # <-- 2 Forage needed
                                        ownForage[count] -= 2
                                        SattPeople -= 1
                                    if (ownMeat[count] > 0 and SattPeople > 0):  # <-- 1 meat needed per person
                                        ownMeat[count] -= 1
                                        SattPeople -= 1
                                    if (ownGrain[count] > 2 and SattPeople > 0): # <-- 3 grain needed per person
                                        ownGrain[count] -= 3
                                        SattPeople -= 1
                                    if (ownForage[count] < 2 and (ownMeat[count] < 1 or ownGrain[count] < 3)):
                                        print ("Satt: ", SattPeople)
                                        SattPeople = 0
                                if (ownForage[count] > 1 and (ownMeat[count] > 0 or ownGrain[count] > 2)):
                                    FoodBonus += 1
                                    print ("2nd FoodBonus: ", FoodBonus)
                                    
                                    if (ownMeat[count] > 0 and ownForage[count] > 1 and ownGrain[count] > 2):
                                        FullPeople = int(secPop[count]/4)
                                        while FullPeople > 0:
                                            if (ownForage[count] > 1 and FullPeople > 0): # <-- 2 Forage needed
                                                ownForage[count] -= 2
                                                FullPeople -= 1
                                            if (ownMeat[count] > 0 and FullPeople > 0):  # <-- 1 meat needed per person
                                                ownMeat[count] -= 1
                                                FullPeople -= 1
                                            if (ownGrain[count] > 2 and FullPeople > 0): # <-- 3 grain needed per person
                                                ownGrain[count] -= 3
                                                FullPeople -= 1
                                            if (ownMeat[count] < 1 and (ownForage[count] < 2 or ownGrain[count] < 3)) and (FullPeople > 0):
                                                print ("Full: ", FullPeople)
                                                FullPeople = 0
                                        if (ownMeat[count] > 0 and ownForage[count] > 1 and ownGrain[count] > 2):
                                            FoodBonus += 1
                                            print ("3rd FoodBonus: ", FoodBonus)
                        print (" ")                                
                            
# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Birth and Death Rates
                        BirthRate = 0
                        Births = 0
                        Deaths = 0
                        Starvation = 0
                        if secHealth[count] > 95:
                            BirthRate = .2
                        elif secHealth[count] > 80:
                            BirthRate = .1
                        elif secHealth[count] > 50:
                            BirthRate = 0
                            secHappy[count] -= 1
                        elif secHealth[count] > 30:
                            BirthRate = -.1
                            secHappy[count] -= 2
                        elif secHealth[count] > 10:
                            BirthRate = -.2
                            secHappy[count] -= 4
                            
                        if secHappy[count] > 95:
                            BirthRate += .2
                            secHealth[count] += 5
                        elif secHappy[count] > 80:
                            BirthRate += .1
                            secHealth[count] += 2
                        elif secHappy[count] > 50:
                            BirthRate += 0
                            secHealth[count] -= 1
                        elif secHappy[count] > 30:
                            BirthRate += -.2
                            secHealth[count] -= 2
                        elif secHappy[count] > 10:
                            BirthRate += -.4
                            secHealth[count] -= 4
                    
                        if (int(secPop[count] * BirthRate) == 0) and (BirthRate > 0):
                            Births = 1
                        elif (int(secPop[count] * BirthRate) == 0) and (BirthRate < 0):
                            Births = -1
                        else:
                            Births = int(secPop[count]*BirthRate)
                        
                        Starvation = 0
                        if FoodBonus < 1:
                            FoodBonus = 0
                            Starvation = .6  # <-- BAD
                            secHappy[count] -= 2
                            secHealth[count] += 2
                        elif FoodBonus == 1:
                            Starvation = -.1  # <-- OK                            
                        elif FoodBonus == 2:
                            Starvation = -.3 # <-- GOOD
                            secHappy[count] += 1
                            secHealth[count] += 1
                        elif FoodBonus == 3:
                            Starvation = -.6  # <-- GREAT!
                            secHappy[count] += 3
                            secHealth[count] += 1
    
                        if (int(secPop[count] * Starvation) == 0) and (Starvation > 0):
                            Deaths = 1
                        elif (int(secPop[count] * Starvation) == 0) and (Starvation < 0):
                            Deaths = -1
                        else:
                            Deaths = int(secPop[count]*Starvation)
                            
                        secHealth[count] -= int(Starvation * 10)
                        secHappy[count] -= int(Deaths/5)
                        
                        if int(Deaths) == 0:
                            Deaths = 1
                        secPop[count] -= int(Deaths)
                        
                        if int(Births) == 0:
                            Births = 0
                        secPop[count] += int(Births)
                        
                        if FoodBonus < 1:
                            FoodBonus = 0
                            secHappy[count] -= 3
                            secHealth[count] -= 8
                        if FoodBonus == 1:
                            secHappy[count] -= 2
                            secHealth[count] -= 4
                        if FoodBonus == 2:
                            secHappy[count] += 3
                            secHealth[count] += 5
                        if FoodBonus == 3:
                            secHappy[count] += 5
                            secHealth[count] += 8
                        secHappy[count] -= 2
                        secHealth[count] -= 2
                        
                    else:
                        secPop[count] = 0
                        secHappy[count] = 0
                        secHealth[count] = 0
                        
                    if secPop[count] > secHousing[count]:
                        secPop[count] = secHousing[count]

 # --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Calculate POTTERY and STORAGE
                    AvailableStorage = 0                           
                    LocalGoods = 0
                    TotalFood = int((ownGrain[count]/5) + (ownMeat[count]/2) + (ownForage[count]/4))
                    AvailablePottery = ownPottery[count] - TotalFood                
                    LocalGoods += int(ownHerb[count]/4) + int(ownPottery[count]*2) + ownAdobe[count]
                    LocalGoods += ownGold[count] + ownCopper[count] + ownBronze[count] + ownCrystal[count]
                    LocalGoods += int(ownStone[count]*10) + ownClay[count] + int(ownWood[count]*3)
                    
                    if AvailablePottery < 0:
                        if ownPottery[count] < 1:
                            ownPottery[count] = 1
                        if AvailablePottery < 0:
                            GoodsBreakDown = int(TotalFood/ownPottery[count])
                            LostFood = int((GoodsBreakDown * 10)/3)
                            if LostFood < 1:
                                LostFood = 1
                            if LostFood > ownGrain[count]:
                                ownGrain[count] = 0
                            else:
                                ownGrain[count] -= LostFood
                                
                            if LostFood > ownMeat[count]:
                                ownMeat[count] = 0
                            else:
                                ownMeat[count] -= LostFood
    
                            if LostFood > ownForage[count]:
                                ownForage[count] = 0
                            else:
                                ownForage[count] -= LostFood
    
                    if LocalGoods > 0:
                        AvailableStorage = int(secStorage[count] - LocalGoods)                    
                        if AvailableStorage < 0:
                            if secStorage[count] < 1:
                                secStorage[count] = 1
                            GoodsBreakDown = int(-1 * (1 - secStorage[count] / LocalGoods) / 2)
                            if ownPottery[count] > 0:
                                if int(ownPottery[count] * .2) < 1:
                                    LostPottery = 1
                                else:
                                    LostPottery = int(ownPottery[count] * .2)
                                ownPottery[count] -= LostPottery

# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Now add up the fruit of the people's labor for the turn
                    if (secPop[count] < 1 and secOwn[count] < 2):
                        secPop[count] = 0
                        secOwn[count] = 0
                    else:
                        BRONZEtools = ownBronze[count]
                        COPPERtools = ownCopper[count]
                        for terra in range(zoom_sector[count], zoom_sector[count]+36):
                            for labor_num in range(0, 23):
                                labors = 0
                                labors = ZoomLabor[terra][labor_num]
                                
                                if (labor_num == 6) and (ZoomBuild[terra] == 11 or ZoomBuild[terra] == 25):  # <-- Farming labor
                                    if MoonPhase == 2:
                                        CropPotential[terra] = labors
                                    if MoonPhase == 3 and (labors < 3):
                                        CropPotential[terra] = int(labors*5)
                                    if MoonPhase == 4 and (labors < 3):
                                        CropPotential[terra] = int(labors*5)
                                    if MoonPhase == 1:
                                        if CropPotential[terra] > labors:
                                            CropPotential[terra] = labors   
                                        if ZoomWater[terra] < 31:
                                            WaterCount = int(ZoomWater[terra])
                                        elif ZoomWater[terra] < 1:
                                            WaterCount = 0
                                        elif ZoomWater[terra] > 30:
                                            WaterCount = int(30-(ZoomWater[terra]/8))

                                        if ZoomTerra[terra] == 1:
                                            CropPotential[terra] = int(CropPotential[terra]*1.5)  # <-- FARMING bonus for PLAINS :)
                                        if ZoomTerra[terra] == 3 or ZoomTerra[terra] == 7:
                                            CropPotential[terra] = int(CropPotential[terra]*0.7)  # <-- FARMS do poorly in DESERT :(
                                        if ZoomTerra[terra] == 4:
                                            CropPotential[terra] = int(CropPotential[terra]*0.8)  # <-- FARMS do poorly in MOUNTAINS :(
                                        if ZoomTerra[terra] == 6:
                                            CropPotential[terra] = int(CropPotential[terra]*0.3)  # <-- FARMS do poorly in FROST biome :(
                                            
                                        if ZoomBuild[terra] == 25:   # <-- If the FARM is IRRIGATED..
                                            WaterCount = int(WaterCount * 1.5)
                                            
                                        #WaterCount = int(WaterCount / 2)      
                                        ownGrain[count] += int(WaterCount * CropPotential[terra])
                                        CropPotential[terra] = 10   # <-- Reset the CROP POTENTIAL for the NEW SEASON

                                
                                if labors > 0:    # <--- Copper and Bronze allow workers to work more efficiently
                                    ranHappy = random.randint(50, 70) # <-- happiness below this random number will drop productivity 
                                    ranHealth = random.randint(50, 70) # <-- health below this random number will drop productivity
                                    HappyVar = secHappy[count]/ranHappy
                                    HealthVar = secHealth[count]/ranHealth
                                    usedBRONZE = 0
                                    usedCOPPER = 0    
                                    if (labor_num < 7) or (labor_num in range(10, 13)) or (labor_num in range(21, 23)): # <-- These labor tasks get the copper/bronze labor bonus
                                        NOtools = labors
                                        print (" ")
                                        print ("SECTOR: ", count, " for labor ", labor_num)
                                        if BRONZEtools < 1:
                                            BRONZEtools = 0
                                        elif BRONZEtools < NOtools:
                                            usedBRONZE += BRONZEtools
                                            NOtools -= BRONZEtools
                                            BRONZEtools = 0
                                        elif BRONZEtools >= NOtools:
                                            usedBRONZE += NOtools
                                            BRONZEtools -= NOtools 
                                            NOtools = 0
                                        RanBreakDown = random.randint(10, 30)
                                        RanBreakDown = (RanBreakDown / 100)
                                        ownBronze[count] -= int(usedBRONZE * RanBreakDown)
                                        print ("Old Labor: ", labors)
                                        print ("Bronze: ", BRONZEtools, " and Used Bronze: ", usedBRONZE, " NO tools: ", NOtools) 

                                        '''
                                        if NOtools > 0:
                                            if COPPERtools < 1:
                                                COPPERtools = 0    
                                            elif COPPERtools < NOtools:
                                                usedCOPPER += COPPERtools
                                                NOtools -= COPPERtools
                                                COPPERtools = 0
                                            elif COPPERtools >= NOtools:
                                                usedCOPPER += NOtools
                                                COPPERtools -= NOtools 
                                                NOtools = 0
                                            RanBreakDown = random.randint(5, 20)
                                            RanBreakDown = (RanBreakDown / 100)
                                            ownCopper[count] -= int(usedCOPPER * RanBreakDown)
                                        labors += int(usedBRONZE*2)  # <-- Bronze tools make workers more efficient
                                        labors += int(usedCOPPER*1.5)  # <-- Copper tools make workers more efficient
                                        print ("Copper Tools: ", COPPERtools, " usedCOPPER ", usedCOPPER)
                                        print ("New Labor: ", labors)
                                        print (" ")
                                        '''
                                        
                                    if labor_num == 0:     # <-- Forage labor
                                        ownForage[count] += int(labors * (ZoomWater[terra] / 20) * HappyVar * HealthVar)
                                        ownGrain[count] += int(labors * (ZoomWater[terra] / 80) * HappyVar * HealthVar)
                                        ownMeat[count] += int(labors * (ZoomTrees[terra]/30) * HappyVar * HealthVar) # <-- hunting
                                        
                                    elif labor_num == 1:   # <-- Mineral labor: Gold, Copper, and Crystal
                                        ownGold[count] += int(labors * (ZoomMineral[terra] / 80) * HappyVar * HealthVar)
                                        ownCopper[count] += int(labors * (ZoomMineral[terra] / 70) * HappyVar * HealthVar)
                                        ownCrystal[count] += int(labors * (ZoomMineral[terra] / 60) * HappyVar * HealthVar)
                                                                                                                                                                              
                                    elif labor_num == 2:   # <-- Stone quarry labor
                                        ownStone[count] += int(labors * (ZoomMineral[terra] / 50) * HappyVar * HealthVar)
    
                                    elif labor_num == 3:   # <-- Clay labor
                                        ownClay[count] += int(labors * (ZoomWater[terra] / 60) * HappyVar * HealthVar)
                                        ownClay[count] += int(labors * (ZoomMineral[terra] / 80) * HappyVar * HealthVar)
    
                                    elif labor_num == 4:   # <-- Wood labor
                                        ownWood[count] += int(labors * (ZoomTrees[terra] / 20) * HappyVar * HealthVar)
                                        
                                    elif labor_num == 5:   # <-- Fishing labor
                                        if ZoomWater[terra] > 35:
                                            WaterCount = int(ZoomWater[terra]-(ZoomWater[terra]-40)/1.5)
                                        else:
                                            WaterCount = ZoomWater[terra]
                                        ownMeat[count] += int(labors * (WaterCount / 30) * HappyVar * HealthVar)
                                        
                                    elif labor_num == 8:   # <-- Shamanic Healing 
                                        ranHeal = random.randint(3, 6)
                                        workers = labors
                                        if ownCrystal[count] < labors:
                                            workers = ownCrystal[count]
                                        secHealth[count] += int(workers*ranHeal)
                                        ownCrystal[count] -= int(workers/2)   # <-- costs crystals to heal
                                        secHappy[count] += int(workers-1)
            
                                        ranHeal = random.randint(2, 4)
                                        workers = labors
                                        if ownHerb[count] < (labors*2):
                                            workers = int(ownHerb[count]/2)
                                        secHealth[count] += int((workers*ranHeal)/2)  # <-- health
                                        ownHerb[count] -= int(workers*2)
                                        secHappy[count] += int(workers-1)    # <-- costs herbs to make happy
                                        
                                    elif labor_num == 10:  # <-- Hunting Tipi: HUNT for meat
                                        if int(labors/4) < 1 and (labors > 0):
                                            woodCOST = 1
                                        else:
                                            woodCOST = int(labors/4)

                                        if ownWood[count] < int(labors/4):
                                            labors = int(ownWood[count]*4) # <-- requires 1 wood for every 4 hunters hunting food
                                        if ownWood[count]< 1:
                                            labors = 0
                                            woodCOST = 0
                                        
                                        ownWood[count] -= woodCOST    
                                        ownMeat[count] += int(labors * (ZoomTrees[terra]/3) * HappyVar * HealthVar) # <-- hunting
                                        ownMeat[count] += int(labors * (ZoomWater[terra]/40) * HappyVar * HealthVar) # <-- hunting                                        

                                    elif labor_num == 11:  # <-- Bronze Tools/Weapons
                                        if int(ownCopper[count]/2) < labors:
                                            labors = int(ownCopper[count]/2)
                                        if labors < 2:
                                            woodCOST = 1
                                        else:
                                            woodCOST = int(labors*2)
                                        
                                        if ownWood[count] < labors*2:
                                            labors = int(ownWood[count]/2) # <-- requires 2 wood to make 1 bronze tool
                                        if ownWood[count]< 1:
                                            labors = 0
                                            woodCOST = 0

                                        ownWood[count] -= woodCOST                                              
                                        ownCopper[count] -= int(labors*2)
                                        ownBronze[count] += int(labors*4) # <-- Bronze Tools
                                        
                                    elif labor_num == 12:
                                        if ownClay[count] < labors:  # <------- CLAY: Make POTTERY
                                            labors = ownClay[count]
                                        if ownWood[count] < labors:
                                            labors = ownWood[count]
                                            woodCOST = labors
                                        elif labors <= ownWood[count]:
                                            woodCOST = labors                                     
                                        
                                        if ownWood[count] < 1:   # <--- Costs 1 wood per labor
                                            labors = 0
                                            woodCOST = 0

                                        ownWood[count] -= woodCOST 
                                        ownPottery[count] += int(labors*4)  # <-- 1 unit of CLAY produces 4 POTTERY
                                        ownClay[count] -= labors
                                        
                                    elif labor_num == 20:       # <-- labor construction
                                        labors = ZoomLabor[terra][20]
                                        if BuildLabor[terra] > 0:
                                            #print (BuildLabor[terra])
                                            BuildLabor[terra] -= labors     # <-- construction work done..
                                            #print (BuildLabor[terra])
                                            if BuildLabor[terra] < 1:
                                                if ZoomBuild[terra] == 11:  # <-- if it's a farm, then make it irrigated
                                                    ZoomBuild[terra] = 25
                                                else:
                                                    ZoomBuild[terra] = ZoomConstruct[terra] # <-- finish construction on other buildings                                            
                                                ZoomConstruct[terra] = -1
                                                ZoomLabor[terra][20] = 0  # <-- remove all construction labor
                                                
                                    elif labor_num == 21:   # <-- Gathering medicine
                                        ownHerb[count] += int(labors * ((ZoomHerb[terra] / 20) + (ZoomWater[terra]/40)) * HappyVar * HealthVar)
                                        
                                    elif labor_num == 22:   # <-- CLAY: Make adobe bricks
                                        if ownClay[count] < labors*2:
                                            labors = int(ownClay[count]/2)
                                        if labors > ownWood[count]:
                                            labors = ownWood[count]
                                            woodCOST = labors
                                        elif labors <= ownWood[count]:
                                            woodCOST = labors                                        
                                        
                                        if ownWood[count] < 1:   # <--- Costs 1 wood per labor
                                            labors = 0
                                            woodCOST = 0

                                        ownWood[count] -= woodCOST 
                                        ownAdobe[count] += int(labors*3)
                                        ownClay[count] -= labors*2

# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Enemy RED tribe spreads out
                elif (secOwn[count] == 2 or secOwn[count] == 3) and (count > 0 and count < 22500):   # <--- Enemy Tribes spread
                    ranTerraTake = random.randint(1, 10)
                    ranTakeOver = random.randint(-50, -15) # <-- Chance of RED taking a territory
                    new_count = 0
                    if ranTerraTake == 1:
                        new_count = count-1
                    elif ranTerraTake == 2:
                        new_count = count+1
                    elif ranTerraTake == 3:
                        new_count = count-151
                    elif ranTerraTake == 4:
                        new_count = count-150
                    elif ranTerraTake == 5:
                        new_count = count-149
                    elif ranTerraTake == 6:
                        new_count = count+149
                    elif ranTerraTake == 7:
                        new_count = count+150
                    elif ranTerraTake == 8:
                        new_count = count+151
                        
                    ranTakeOver += secWater[new_count]  # <-- The more water, the more likely RED will take it..
                    if secTerra[new_count] == 3:
                        ranTakeOver += 15
                             
                    if new_count != 0 and secOwn[new_count] < 1:                                                
                        if (ranTakeOver > 0 and secTerra[new_count] != 5):
                            secOwn[new_count] = 3

# --- BEGIN NEW TURN --- NEW MOON CYCLE ------- Move Goods Across Map
            for route in range (0, 41):
                if ConvoyBlu[route][0] == ConvoyBlu[route][28]:
                    for num in range(0, 31):
                        ConvoyBlu[route][num] = -1
                        MoveLoop = False
                else:
                    MoveLoop = True
                    num = 0
                while MoveLoop:     # <--- This moves units/goods when player clicks turn button
                    num += 1
                    if ConvoyBlu[route][num] != -1:
                        ConvoyBlu[route][num-1] = ConvoyBlu[route][num]
                        ConvoyBlu[route][num] = -1
                        if num > 19:
                            MoveLoop = False                

            for count in range(-200, 22700):
                if secPop[count] > 0:
                    secOwn[count] == 1
                    
                if waitGrain[count] > 0:
                    waitGrain[count] -= 1
                else:
                    ownGrain[count] += movGrain[count]
                    movGrain[count] = 0

                if waitMeat[count] > 0:
                    waitMeat[count] -= 1
                else:
                    ownMeat[count] += movMeat[count]
                    movMeat[count] = 0

                if waitForage[count] > 0:
                    waitForage[count] -= 1
                else:
                    ownForage[count] += movForage[count]
                    movForage[count] = 0

                if waitPottery[count] > 0:
                    waitPottery[count] -= 1
                else:
                    ownPottery[count] += movPottery[count]
                    movPottery[count] = 0
                    
                if waitAdobe[count] > 0:
                    waitAdobe[count] -= 1
                else:
                    ownAdobe[count] += movAdobe[count]
                    movAdobe[count] = 0
                    
                if waitGold[count] > 0:
                    waitGold[count] -= 1
                else:
                    ownGold[count] += movGold[count]
                    movGold[count] = 0
                    
                if waitCopper[count] > 0:
                    waitCopper[count] -= 1
                else:
                    ownCopper[count] += movCopper[count]
                    movCopper[count] = 0

                if waitBronze[count] > 0:
                    waitBronze[count] -= 1
                else:
                    ownBronze[count] += movBronze[count]
                    movBronze[count] = 0

                if waitCrystal[count] > 0:
                    waitCrystal[count] -= 1
                else:
                    ownCrystal[count] += movCrystal[count]
                    movCrystal[count] = 0

                if waitStone[count] > 0:
                    waitStone[count] -= 1
                else:
                    ownStone[count] += movStone[count]
                    movStone[count] = 0

                if waitClay[count] > 0:
                    waitClay[count] -= 1
                else:
                    ownClay[count] += movClay[count]
                    movClay[count] = 0
                    
                if waitWood[count] > 0:
                    waitWood[count] -= 1
                else:
                    ownWood[count] += movWood[count]
                    movWood[count] = 0

                if waitPop[count] > 0:
                    waitPop[count] -= 1
                elif waitPop[count] < 1 and movPop[count][0] > 0:
                    if (secPop[count] < 1 and secOwn[count] < 2):
                        secPop[count] = 0
                        secOwn[count] = 0
                        secHealth[count] = movPop[count][1]
                        secHappy[count] = movPop[count][2]
                    else:
                        secHealth[count] = int(((secPop[count] * secHealth[count]) + (movPop[count][0] * movPop[count][1])) / (secPop[count] + movPop[count][0])) 
                        secHappy[count] = int(((secPop[count] * secHappy[count]) + (movPop[count][0] * movPop[count][2])) / (secPop[count] + movPop[count][0]))
                    secPop[count] += movPop[count][0]      # <--- Find the weighted average for the two sectors' population stats..
                    movPop[count][0] = 0   # <-- MoveFrom Sector's Population Reset 
                    movPop[count][1] = 0   # <-- MoveFrom Sector's Health Reset
                    movPop[count][2] = 0   # <-- MoveFrom Sector's Happiness Reset
                    
                for resources in range(0, 14):
                    NewResources[count][resources] = 0
                NewResources[count][0] += ownGrain[count]
                NewResources[count][1] += ownMeat[count]
                NewResources[count][2] += ownForage[count]
                NewResources[count][3] += ownHerb[count]
                NewResources[count][4] += ownPottery[count]
                NewResources[count][5] += ownAdobe[count]
                NewResources[count][6] += ownGold[count]
                NewResources[count][7] += ownCopper[count]
                NewResources[count][8] += ownBronze[count]
                NewResources[count][9] += ownCrystal[count]
                NewResources[count][10] += ownStone[count]
                NewResources[count][11] += ownClay[count]
                NewResources[count][12] += ownWood[count]
                NewResources[count][13] += secPop[count]
                    
            StatTimer = 10    # <-- Runs the stat timer before the new turn begins to check labor, health, happiness, etc..
            MoonCycleStart = False

# --- MAIN LOOP BEGINS --- Begins Main Loop and starts "frames" and "seconds" counters
        (mouseX, mouseY) = pygame.mouse.get_pos()
        #mouse.set_pos(mouseX, mouseY) # <-- Set mouse cursor position to middle of map
        counter = pygame.time.get_ticks()
        seconds = int(counter/1000)
        ticky = int(seconds/seconds)
        frames += int(ticky*4)
        if frames > 100:
            slow_frames += 1
            slower_frames += .25
            frames = 0                    
        if slow_frames > 100:
            StatTimer += 3
            slow_frames = 0
        if frames > 30:
            if StatTimer > 0:      # <--- Labor Counter for checking Labor Statistics
                StatTimer -= 1
            if ResourceTimer > 0:
                ResourceTimer -= 1
            if ClickTimer > 0:
                ClickTimer -= 1
                
        FrameCount = int(slower_frames)
        if slower_frames > 5:
            slower_frames = 1
        
# --- MAIN LOOP BEGINS --- This tells the Sector Check scan which sectors check
        if frames < 50:
            RowCheck += 1
            if RowCheck > 20:
                RowCheck = -20
            SecCheck = Clicked + (RowCheck*150)
            if SecCheck < -100:
                SecCheck = -100
            if SecCheck > 22650:
                SecCheck = 22650

            if RowCheck < -17:
                SecMin = -200
                SecMax = 22700
                total_workers = 0
                total_food_labor = 0             
                TotalWorkers = 0 
                TotalAllFood = 0
                TotalGrain = 0
                TotalMeat = 0
                TotalForage = 0
                TotalHerb = 0
                TotalPottery = 0
                TotalAdobe = 0    
                TotalGold = 0
                TotalCopper = 0
                TotalBronze = 0
                TotalCrystal = 0
                TotalStone = 0
                TotalClay = 0
                TotalWood = 0
                TotalPop = 0
                
            else:
                SecMin = SecCheck-15
                SecMax = SecCheck+15
        
# --- MAIN LOOP BEGINS --- LABOR and StatTimer CHECK
            for count in range(SecMin, SecMax):
                if secTerra[count] == 1:
                    secSpeed[count] = 4     # <-- Movement speed in 'plains' biome
                if secTerra[count] == 2:
                    secSpeed[count] = 6     # <-- Movement speed in 'forest' biome
                if secTerra[count] == 3:
                    secSpeed[count] = 5     # <-- Movement speed in 'desert' biome
                if secTerra[count] == 4:
                    secSpeed[count] = 8     # <-- Movement speed in 'mountain' biome
                if secTerra[count] == 5:
                    secSpeed[count] = 0     # <-- Movement speed in 'water' biome
                if secTerra[count] == 6:
                    secSpeed[count] = 6     # <-- Movement speed in 'frost' biome
                if secTerra[count] == 7:
                    secSpeed[count] = 2     # <-- Movement speed in 'island' biome
                
                if MoveReset == True:                  # <-- If a "range measurement" is starting over, MoveReset will erase the old values
                    secRange[count] = 21
                    RangeCount[count] = 0
                if count > 22698 and MoveReset == True:
                    range_clicks = 0
                    reset = 0
                    MoveResource = 0
                    
                    for routes in range(0, 41):
                        if ConvoyBlu[routes][25] != -2:
                            for ranges in range(0, 31):
                                ConvoyBlu[routes][ranges] = -1
                                
                    MoveReset = False
         
                if secPop[count] < 0:
                    secPop[count] = 0
                if (secPop[count] > 0):
                    secOwn[count] = 1
                    total_workers = 0
                    total_food_labor = 0
                    for terra in range(zoom_sector[count], zoom_sector[count]+36):                                
                        local_workers = 0
                        for num in range(0, 23):
                            if num in range(5, 21) and ZoomBuild[terra] == -1 and ZoomTerra[terra] != 5:
                                ZoomLabor[terra][num] = 0
                            if ZoomLabor[terra][num] > 0:           
                                if (ZoomConstruct[terra] > 0 and num != 20):  # <-- if it's not a construction job..
                                    ZoomLabor[terra][num] = 0
                                if ZoomBuild[terra] in range(2, 8):  # <-- home buildings (#2-7) cannot have any labor
                                    ZoomLabor[terra][num] = 0
                                if ZoomBuild[terra] in range(8, 10) or ZoomBuild[terra] in range(21, 23): # <-- 4x4 building labor
                                    ZoomLabor[terra-1][num] = 0
                                    ZoomLabor[terra-6][num] = 0
                                    ZoomLabor[terra-7][num] = 0
                                    if num in range(0, 5) or num == 21:        # <-- the 4x4 buildings cannot have standard labor jobs
                                        ZoomLabor[terra][num] = 0
                                if ZoomBuild[terra] == 15: # <-- 1x2 STORAGE building labor
                                    ZoomLabor[terra-1][all_jobs] = 0
                                    ZoomLabor[terra][all_jobs] = 0   
                                    if num in range(0, 5) or num == 21:    # <-- the 1x2 storage building cannot have standard labor jobs
                                        ZoomLabor[terra][num] = 0
                                if num == 0 or num == 5: 
                                    total_food_labor += ZoomLabor[terra][num]
                                local_workers += ZoomLabor[terra][num]
                                total_workers += ZoomLabor[terra][num]
                                if local_workers > 10:   # <--- Max Laborers for Mini Sector is...
                                    ZoomLabor[terra][num] -= 1
                                    total_workers -= 1
                                    local_workers -= 1
                                elif total_workers > secPop[count]:
                                    ZoomLabor[terra][num] -= 1
                                    total_workers -= 1
                
                if secPop[count] > 0 and RowCheck < -17:
                    ownGrain[count] = int(ownGrain[count])
                    ownMeat[count] = int(ownMeat[count])
                    ownForage[count] = int(ownForage[count]) 
                    ownHerb[count] = int(ownHerb[count])
                    ownPottery[count] = int(ownPottery[count]) 
                    ownAdobe[count] = int(ownAdobe[count]) 
                    ownGold[count] = int(ownGold[count])
                    ownCopper[count] = int(ownCopper[count])
                    ownBronze[count] = int(ownBronze[count])
                    ownCrystal[count] = int(ownCrystal[count])
                    ownStone[count] = int(ownStone[count])
                    ownClay[count] = int(ownClay[count])
                    ownWood[count] = int(ownWood[count])
                    
                    TotalGrain += int(ownGrain[count] + movGrain[count])
                    TotalMeat += int(ownMeat[count] + movMeat[count])
                    TotalForage += int(ownForage[count] + movForage[count])
                    TotalAllFood += int(ownGrain[count] + movGrain[count]) + int(ownMeat[count] + movMeat[count]) + int(ownForage[count] + movForage[count]) 
                    TotalHerb += int(ownHerb[count] + movHerb[count])
                    TotalPottery += int(ownPottery[count] + movPottery[count])
                    TotalAdobe += int(ownAdobe[count] + movAdobe[count])
                    TotalGold += int(ownGold[count] + movGold[count])
                    TotalCopper += int(ownCopper[count] + movCopper[count])
                    TotalBronze += int(ownBronze[count] + movBronze[count])
                    TotalCrystal += int(ownCrystal[count] + movCrystal[count])
                    TotalStone += int(ownStone[count] + movStone[count])
                    TotalClay += int(ownClay[count] + movClay[count])
                    TotalWood += int(ownWood[count] + movWood[count])
                    TotalPop += int(secPop[count] + movPop[count][0])
                    TotalWorkers += int(total_workers)
                    
                if secHappy[count] < 0:
                    secHappy[count] = 0
                if secHealth[count] < 0:
                    secHealth[count] = 0
                if secHappy[count] > 100:
                    secHappy[count] = 100
                if secHealth[count] > 100:
                    secHealth[count] = 100
                if secPop[count] > 0:
                    secExplored[count] = 1
    
                if secTerra[count] == 5 and secRoad[count] != 2:   # <-- This code says that only stone bridges can be built over water sectors
                    secRoad[count] = 0

# --- MAIN LOOP BEGINS --- Assesses Food and Dry Storage for the Local Sector                
        if SectorZoom == True or ResToggle1 == True or ResToggle2 == True:
            AvailablePottery = ownPottery[Clicked] - int((ownGrain[Clicked]/5) + (ownMeat[Clicked]/2) + (ownForage[Clicked]/4))
            LocalGoods += int(ownHerb[Clicked]/4) + int(ownPottery[Clicked]*2) + ownAdobe[Clicked]
            LocalGoods += ownGold[Clicked] + ownCopper[Clicked] + ownBronze[Clicked] + ownCrystal[Clicked]
            LocalGoods += int(ownStone[Clicked]*10) + ownClay[Clicked] + int(ownWood[Clicked]*3)
            AvailableStorage = int(secStorage[Clicked] - LocalGoods)
            Storage = 0
            
# --- SECTOR ZOOM BOX ANIMATION --- Animates Sector Box
        if Clicked == BoxSector and secPop[Clicked] > 0:   # <--- Warp player to last clicked populated sector
            ClickedX = SelectX
            ClickedY = SelectY
        if SectorZoom == False and MapToggle == False:
            if SecLocaX < 1300:
                SecLocaX += 20
        if SectorZoom == True or MapToggle == True:
            if ScreenModes == 0:
                SecLocaY = 60
                SecLocaX = 750
                MapLocaX = 800
                if SecLocaX > 820:
                    SecLocaX -= 20
            elif ScreenModes == 1:
                SecLocaY = 60
                if SecLocaX > 750:
                    SecLocaX -= 20                
            elif ScreenModes == 2:
                SecLocaY = 100
                if SecLocaX > 480:
                    SecLocaX -= 20
            else:
                if SecLocaX > 820:
                    SecLocaX -= 20
            
# --- MAIN LOOP --- KEYBOARD AND MOUSE EVENTS
        for event in pygame.event.get():
            if (event.type==pygame.QUIT):
                MainLoop = False
            elif (event.type == KEYDOWN):
                if (event.key == K_ESCAPE) and EscapeToggle == True:
                    MenuLoop = True
                    ResToggle1 = False
                    ResToggle2 = False
                    MapToggle = False
                    SectorZoom = False
                    EscapeToggle = True
                    WaterToggle = False
                    MineralToggle = False
                    HappyToggle = False
                    HerbToggle = False
                    HealthToggle = False
                    ZoomSector = 0
                    if MoveReset == False:
                        MoveReset = True                
                    TickPause += 1
                    
                elif (event.key == K_ESCAPE) and EscapeToggle == False:
                    ResToggle1 = False
                    ResToggle2 = False
                    MapToggle = False
                    SectorZoom = False
                    EscapeToggle = True
                    WaterToggle = False
                    MineralToggle = False
                    HappyToggle = False
                    HerbToggle = False
                    HealthToggle = False
                    ZoomSector = 0
                    if MoveReset == False:
                        MoveReset = True
                        
                if (event.key == K_z): # <--------- "z" key saves keystroke                
                    if LastKey > 0 and ClickTimer == 0:
                        ScrollClick = LastKey
                        ClickTimer = 10
                    
                if (event.key == K_F11):                       # <--------- Changes screen mode
                    ScreenModes += 1
                    if ScreenModes > 3:
                        ScreenModes = 0
                    if ScreenModes == 0:
                        screen_mode = pygame.display.set_mode((1600,900), pygame.FULLSCREEN)  # <--- Larger Rez Laptop Mode
                        #except pygame.error:
                            #screen_mode = pygame.display.set_mode((1366,768),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode    
                        SecLocaX = 780
                        MapLocaX = 800
    
                    elif ScreenModes == 1:
                        try:
                            screen_mode = pygame.display.set_mode((1280,720),pygame.FULLSCREEN)  # <--- Netbook Fullscreen Mode
                        except pygame.error:
                            screen_mode = pygame.display.set_mode((1366,768),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode
                    elif ScreenModes == 2:
                        screen_mode = pygame.display.set_mode((1024,768),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode
                        SecLocaX = 480
                        MapLocaX = 500
                    elif ScreenModes == 3:
                        try:
                            screen_mode = pygame.display.set_mode((1600,900),pygame.FULLSCREEN)  # <--- Netbook Fullscreen Mode
                        except pygame.error:
                            screen_mode = pygame.display.set_mode((1366,768),pygame.RESIZABLE)  # <--- Larger Laptop Fullscreen Mode                   

                if pygame.key.get_pressed()[K_LEFT]:
                    SelectX -= 1
                if pygame.key.get_pressed()[K_RIGHT]:
                    SelectX += 1
                if pygame.key.get_pressed()[K_UP]:
                    if (SelectY > 1):
                        SelectY -= 1
                if pygame.key.get_pressed()[K_DOWN]:
                    if (SelectY < 150):
                        SelectY += 1
                if (event.key == K_m):        # <--- "m" key toggles the mini map on and off
                    if MapToggle == False:
                        MapToggle = True
                        SectorZoom = False
                        EscapeToggle = False
                    else:
                        MapToggle = False
                        
                if (event.key == K_r):        # <--- "r" key toggles "resources info" on and off
                    if (ResToggle1 == False and ResToggle2 == False):
                        ResToggle1 = True
                        LaborBox = False
                        BuildBox = False
                    elif ResToggle2 == True:
                        ResToggle1 = False
                        ResToggle2 = False
                    elif ResToggle1 == True:
                        ResToggle2 = True
                        ResToggle1 = False

                #if (event.key == K_t):        # <--- "t" key ends turn
                    #MoonCycleStart = True
                    #StatTimer = 10

                if (event.key == K_1):         # <--- "1" key toggles "water" resource on and off
                    if WaterToggle == False:
                        WaterToggle = True
                        HerbToggle = False
                        MineralToggle = False
                        HealthToggle = False
                        HappyToggle = False
                    else:
                        WaterToggle = False
                        
                if (event.key == K_2):         # <--- "2" key toggles "mineral" resource on and off
                    if MineralToggle == False:
                        MineralToggle = True
                        HerbToggle = False
                        WaterToggle = False
                        HealthToggle = False
                        HappyToggle = False
                    else:
                        MineralToggle = False

                if (event.key == K_3):         # <--- "3" key toggles "medicinal herbs" condition on and off
                    if HerbToggle == False:
                        HerbToggle = True
                        HealthToggle = False
                        MineralToggle = False
                        WaterToggle = False
                        HappyToggle = False
                    else:
                        HerbToggle = False

                if (event.key == K_4):         # <--- "4" key toggles sector's "health" condition on and off
                    if HealthToggle == False:
                        HealthToggle = True
                        HerbToggle = False
                        MineralToggle = False
                        WaterToggle = False
                        HappyToggle = False
                    else:
                        HealthToggle = False
                        
                if (event.key == K_5):         # <--- "5" key toggles sector's "happiness" condition on and off
                    if HappyToggle == False:
                        HealthToggle = False
                        HerbToggle = False
                        MineralToggle = False
                        WaterToggle = False
                        HappyToggle = True
                    else:
                        HappyToggle = False

                if (event.key == K_h) and ClickTimer == 0:         # <--- "h" key orients player's screen back to "home" sector
                    ClickTimer = 100
                    HomeToggle = True
                    
                if (event.key == K_s):         # <--- "s" key toggles "sector box" on/off
                    if SectorZoom == True:
                        BuildBox = False
                        LaborBox = False
                        SectorZoom = False
                        ResToggle1 = False
                        ResToggle2 = False
                        MapToggle = False
                    else:
                        SectorZoom = True
                        BuildBox = False
                        LaborBox = False
                        MapToggle = False

                if (event.key == K_i):         # <--- "i" key toggles "information box" on/off
                    if InfoToggle == True:
                        InfoToggle = False
                    else:
                        InfoToggle = True
                        
                if (event.key == K_d):         # <--- "c" key cancels or destroys buildings
                    if BuildBox == True:
                        ScrollClick = 24

# --- TRAVEL RANGE --- RESOURCE TRANSFER MOVE --- Left and Right Click -- Moves goods to nearby sector at player request
            if pygame.mouse.get_pressed()[0]:
                if MoveResource > 0:
                    MoveResource = 0
                if (ResToggle1 == True or ResToggle2 == True) and (resMouseX > resLocaX+335):  # <-- Erase the GOODS movement path if player clicks right of the RESOURCE box
                    MoveReset = True   # <-- This erases the BLUE boxes representing GOODS movement
                elif (ResToggle1 == False and ResToggle2 == False) and (resMouseX - resLocaX > 740):  # <-- Erase the GOODS movement path if player clicks right of the RESOURCE box
                    MoveReset = True   # <-- This erases the BLUE boxes representing GOODS movement

                MoveFrom = RangeCount[0]
                if (range_clicks > 0) and (secOwn[MoveFrom] == 1 and secPop[MoveFrom] > 0):
                    if (ResToggle1 == True) and (resMouseX > resLocaX+15 and resMouseX < resLocaX + 82) and MenuLoop == False:
                        if (resMouseY > resLocaY+96 and resMouseY < resLocaY + 156) and ownGrain[MoveFrom] > 0:
                            MoveResource = 1
                        elif (resMouseY > resLocaY+170 and resMouseY < resLocaY + 235) and ownMeat[MoveFrom] > 0:
                            MoveResource = 2
                        elif (resMouseY > resLocaY+248 and resMouseY < resLocaY + 311) and ownForage[MoveFrom] > 0:
                            MoveResource = 3
                        elif (resMouseY > resLocaY+323 and resMouseY < resLocaY + 388) and ownHerb[MoveFrom] > 0:
                            MoveResource = 4
                        elif (resMouseY > resLocaY+400 and resMouseY < resLocaY + 465) and ownPottery[MoveFrom] > 0:
                            MoveResource = 5
                        elif (resMouseY > resLocaY+476 and resMouseY < resLocaY + 543) and ownAdobe[MoveFrom] > 0:
                            MoveResource = 6
                        elif (resMouseY > resLocaY+554 and resMouseY < resLocaY + 635) and secPop[MoveFrom] > 0:
                            MoveResource = 14
                        else:
                            MoveResource = 0
                    if (ResToggle2 == True) and (resMouseX > resLocaX+15 and resMouseX < resLocaX + 82) and MenuLoop == False:
                        if (resMouseY > resLocaY+15 and resMouseY < resLocaY + 80) and ownGold[MoveFrom] > 0:
                            MoveResource = 7
                        elif (resMouseY > resLocaY+96 and resMouseY < resLocaY + 156) and ownCopper[MoveFrom] > 0:
                            MoveResource = 8
                        elif (resMouseY > resLocaY+170 and resMouseY < resLocaY + 235) and ownBronze[MoveFrom] > 0:
                            MoveResource = 9
                        elif (resMouseY > resLocaY+248 and resMouseY < resLocaY + 311) and ownCrystal[MoveFrom] > 0:
                            MoveResource = 10
                        elif (resMouseY > resLocaY+323 and resMouseY < resLocaY + 388) and ownStone[MoveFrom] > 0:
                            MoveResource = 11
                        elif (resMouseY > resLocaY+400 and resMouseY < resLocaY + 465) and ownClay[MoveFrom] > 0:
                            MoveResource = 12
                        elif (resMouseY > resLocaY+476 and resMouseY < resLocaY + 543) and ownWood[MoveFrom] > 0:
                            MoveResource = 13
                        elif (resMouseY > resLocaY+554 and resMouseY < resLocaY + 635) and secPop[MoveFrom] > 0:
                            MoveResource = 14
                        else:
                            MoveResource = 0
        
            if pygame.mouse.get_pressed()[2] and (MoveResource > 0) and (secRange[BoxSector] == new_sector) and (secPop[MoveFrom] > 0):
                StatTimer = 5
                if (secRange[BoxSector] < 21) and (BoxSector != MoveFrom) and (secPop[MoveFrom] > 0):
                    ConvoyBlu[supply_route][25] = -2    # <---- Spot #25--this value of "-2" locks in the supply route to memory
                    ConvoyBlu[supply_route][26] = MoveFrom # <-- #26 --> Goods are moving from this sector
                    ConvoyBlu[supply_route][28] = BoxSector  # <--- Spot #28 in the array represents the "final destination" sector for the goods
                    for turning in range(0, 23):
                        ConvoyBlu[supply_route][turning] = ConvoyTurns[turning]   # <-- Spot #26--this makes sure that the goods move come next turn
                else:
                    for num in range(0, 31):
                        ConvoyBlu[supply_route][num] = -1
                if (MoveResource == 1) and ownGrain[MoveFrom] > 9:
                    if (waitGrain[BoxSector] == range_clicks) or (waitGrain[BoxSector] == 0) or (waitGrain[BoxSector] == secRange[BoxSector]):
                        ownGrain[MoveFrom] -= 10
                        secPop[MoveFrom] -= 1
                        
                        movGrain[BoxSector] += 10
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitGrain[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 1          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 2) and ownMeat[MoveFrom] > 4:
                    if (waitMeat[BoxSector] == range_clicks or waitMeat[BoxSector] == 0 or waitMeat[BoxSector] == secRange[BoxSector]):
                        ownMeat[MoveFrom] -= 5
                        secPop[MoveFrom] -= 1
                        
                        movMeat[BoxSector] += 5
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitMeat[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 2          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 3) and ownForage[MoveFrom] > 9:
                    if (waitForage[BoxSector] == range_clicks or waitForage[BoxSector] == 0 or waitForage[BoxSector] == secRange[BoxSector]):
                        ownForage[MoveFrom] -= 10
                        secPop[MoveFrom] -= 1
                        
                        movForage[BoxSector] += 10
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitForage[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 3          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 4) and ownHerb[MoveFrom] > 9:
                    if (waitHerb[BoxSector] == range_clicks or waitHerb[BoxSector] == 0 or waitHerb[BoxSector] == secRange[BoxSector]):
                        ownHerb[MoveFrom] -= 10
                        secPop[MoveFrom] -= 1
                        
                        movHerb[BoxSector] += 10
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]
                        
                        waitHerb[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 4          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 5) and ownPottery[MoveFrom] > 2:
                    if (waitPottery[BoxSector] == range_clicks or waitPottery[BoxSector] == 0 or waitPottery[BoxSector] == secRange[BoxSector]):
                        ownPottery[MoveFrom] -= 3
                        secPop[MoveFrom] -= 1
                        
                        movPottery[BoxSector] += 3
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitPottery[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 5          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 6) and ownAdobe[MoveFrom] > 1:
                    if (waitAdobe[BoxSector] == range_clicks or waitAdobe[BoxSector] == 0 or waitAdobe[BoxSector] == secRange[BoxSector]):
                        ownAdobe[MoveFrom] -= 2
                        secPop[MoveFrom] -= 1
                        
                        movAdobe[BoxSector] += 2
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitAdobe[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 6          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 7) and ownGold[MoveFrom] > 0:
                    if (waitGold[BoxSector] == range_clicks or waitGold[BoxSector] == 0 or waitGold[BoxSector] == secRange[BoxSector]):
                        ownGold[MoveFrom] -= 1
                        secPop[MoveFrom] -= 1
                        
                        movGold[BoxSector] += 1                        
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitGold[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 7          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 8) and ownCopper[MoveFrom] > 4:
                    if (waitCopper[BoxSector] == range_clicks or waitCopper[BoxSector] == 0 or waitCopper[BoxSector] == secRange[BoxSector]):
                        ownCopper[MoveFrom] -= 5
                        secPop[MoveFrom] -= 1
                        
                        movCopper[BoxSector] += 5                        
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitCopper[BoxSector] = secRange[BoxSector] #
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 8          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 9) and ownBronze[MoveFrom] > 2:
                    if (waitBronze[BoxSector] == range_clicks or waitBronze[BoxSector] == 0 or waitBronze[BoxSector] == secRange[BoxSector]):
                        ownBronze[MoveFrom] -= 3
                        secPop[MoveFrom] -= 1
                        
                        movBronze[BoxSector] += 3
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitBronze[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 9          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 10) and ownCrystal[MoveFrom] > 4:
                    if (waitCrystal[BoxSector] == range_clicks or waitCrystal[BoxSector] == 0 or waitCrystal[BoxSector] == secRange[BoxSector]):
                        ownCrystal[MoveFrom] -= 5
                        secPop[MoveFrom] -= 1
                        
                        movCrystal[BoxSector] += 5
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitCrystal[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 10          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 11) and ownStone[MoveFrom] > 0:
                    if (waitStone[BoxSector] == range_clicks or waitStone[BoxSector] == 0 or waitStone[BoxSector] == secRange[BoxSector]):
                        ownStone[MoveFrom] -= 1
                        secPop[MoveFrom] -= 1
                        
                        movStone[BoxSector] += 1
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitStone[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 11          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 12) and ownClay[MoveFrom] > 4:
                    if (waitClay[BoxSector] == range_clicks or waitClay[BoxSector] == 0 or waitClay[BoxSector] == secRange[BoxSector]):
                        ownClay[MoveFrom] -= 5
                        secPop[MoveFrom] -= 1
                        
                        movClay[BoxSector] += 5                        
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitClay[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 12          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 13) and ownWood[MoveFrom] > 4:
                    if (waitWood[BoxSector] == range_clicks or waitWood[BoxSector] == 0 or waitWood[BoxSector] == secRange[BoxSector]):
                        ownWood[MoveFrom] -= 5
                        secPop[MoveFrom] -= 1
                        
                        movWood[BoxSector] += 5                        
                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]
                     
                        waitWood[BoxSector] = secRange[BoxSector]
                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 13          # <--- Spot #27 in the array represents the type of "goods"
                if (MoveResource == 14) and secPop[MoveFrom] > 0:
                    if (secPop[BoxSector] == range_clicks or secPop[BoxSector] == 0 or secPop[BoxSector] == secRange[BoxSector]):
                        secPop[MoveFrom] -= 1

                        movPop[BoxSector][0] += 1
                        movPop[BoxSector][1] = secHealth[MoveFrom]
                        movPop[BoxSector][2] = secHappy[MoveFrom]

                        waitPop[BoxSector] = secRange[BoxSector]
                        ConvoyBlu[supply_route][27] = 14          # <--- Spot #27 in the array represents the type of "goods"

# --- TRAVEL RANGE --- Right Mouse Click
            if pygame.mouse.get_pressed()[2] and (SectorZoom == True) and ((mouseX < SecLocaX or mouseX > SecLocaX+550) or (mouseY < SecLocaY or mouseY > SecLocaY+500)):
                SectorZoom = False
            elif pygame.mouse.get_pressed()[2] and (secPop[BoxSector] > 0 or range_clicks > 0) and (MoveResource == 0) and (MoveReset == False) and (SectorZoom == False):
                if ResToggle2 != True and (BuildBox == False or LaborBox == False): 
                    ResToggle1 = True
                if (mouseX > resLocaX and mouseX < resLocaX + 350) and (mouseY > resLocaY and mouseY < resLocaY + 600) and (ResToggle1 == True or ResToggle2 == True):
                    Clicked != BoxSector
                else:
                    if range_clicks == 0 and mouseX > 80:
                        if ConvoyBlu[supply_route][25] != -2:
                            for num in range(0, 31):
                                ConvoyBlu[supply_route][num] = -1
                                ConvoyTurns[num] = -1
                        else:
                            #MoveReset = True
                            supply_route += 1
                        Clicked = BoxSector
                        ZoomSector = 0
                        for count in range(-200, 22700):
                            secRange[count] = 21
                        secRange[BoxSector] = 0
                        RangeCount[0] = BoxSector
                        range_clicks = 1
                    elif range_clicks > 0:
                        if range_clicks == 1:
                            for num in range(0,31): 
                                ConvoyBlu[supply_route][num] = -1
                        RangeCount[range_clicks] = BoxSector
                        Ranges = [-151, -150, -149, -1, 1, 149, 150, 151, 1]
                        for num in range(0, 8):
                            move = Ranges[num]
                            old_sector = range_clicks-1
                            old_range = secRange[RangeCount[range_clicks-1]]
                            if (BoxSector == RangeCount[old_sector] + move): #and (secTerra[BoxSector] != 5 or secRoad[BoxSector] == 2 or secWater[BoxSector] < 27):
                                secRange[BoxSector] = int(secSpeed[BoxSector]/3 - secRoad[BoxSector]/2 + old_range)
                                for count in range(4, 124, 4):
                                    if range_clicks == count:
                                        secRange[BoxSector] += 1
                                range_clicks += 1
                                new_sector = secRange[BoxSector]
                        ConvoyBlu[supply_route][secRange[BoxSector]] = BoxSector   # <-- Keeps track of the moving goods
                        ConvoyTurns[secRange[BoxSector]] = BoxSector

                        if secRange[BoxSector] > 21:
                            MoveReset = True
                            supply_route -= 1
                            
    # --- MAIN LOOP --- Animates Resource Box --- Left Click
            if pygame.mouse.get_pressed()[0]:
                if SectorZoom == True or ResToggle1 == True or ResToggle2 == True:
                    if (mouseX > 329 and mouseX < 430) and (mouseY > 5 and mouseY < 52) and (ClickTimer < 1):
                        MoonCycleStart = True
                        ClickTimer = 10         # <-------- NEW MOON: CLICK NEXT TURN BUTTON

                if (ResToggle2 == True or ResToggle1 == True) and (resMouseX > resLocaX + 83 and resMouseX < resLocaX + 350):
                    ClickTimer = 10
                    if ResToggle1 == True:
                        ResourceTimer += 2
                        ResToggle2 = True
                        ResToggle1 = False
                    elif ResToggle2 == True and ResourceTimer == 0:
                        ResToggle2 = False
                        ResToggle1 = False
                if (ResToggle1 == False and ResToggle2 == False and BuildBox == False and LaborBox == False) and (mouseX < 80) and (ClickTimer < 1):
                    ClickTimer = 30
                    if mouseY < 78:             # <-- if player clicks MENU tab on SIDE of SCREEN
                        MenuLoop = True
                    elif mouseY in range(80, 157):    # <-- if player clicks SECTOR tab on SIDE of SCREEN
                        SelectX = ClickedX            # <--- Warp player to last clicked populated sector
                        SelectY = ClickedY
                        if SectorZoom == False:
                            SectorZoom = True
                            MapToggle = False
                        elif SectorZoom == True:
                            SectorZoom = False
                            MapToggle = False
                    elif mouseY in range(158, 235):  # <-- if player clicks RESOURCE1 tab on SIDE of SCREEN
                        SelectX = ClickedX            # <--- Warp player to last clicked populated sector
                        SelectY = ClickedY                        
                        if ResToggle1 == False:
                            ResToggle1 = True
                        elif ResToggle1 == True:
                            ResToggle1 = False
                    elif mouseY in range(236, 315):  # <-- if player clicks RESOURCE2 tab on SIDE of SCREEN
                        SelectX = ClickedX            # <--- Warp player to last clicked populated sector
                        SelectY = ClickedY                        
                        if ResToggle2 == False:
                            ResToggle2 = True
                        elif ResToggle2 == True:
                            ResToggle2 = False
                    elif mouseY in range(315, 392): # <-- if player clicks MAP tab on SIDE of SCREEN
                        if MapToggle == False:
                            MapToggle = True
                            SectorZoom = False
                        elif MapToggle == True:
                            MapToggle = False
                            SectorZoom = False
                    elif mouseY in range(392, 471): # <-- if player clicks UNIT/WARRIOR tab on SIDE of SCREEN
                        if UnitToggle == True:
                            UnitToggle = False
                        elif UnitToggle == False:
                            UnitToggle = True

    # --- MAIN LOOP --- Side Buttons on Sector Zoom Box --- Left Click
                if (SectorZoom == True and mouseX-SecLocaX in range(-5, 53)) and (ClickTimer < 1) and (secExplored[Clicked] == 1):
                    ClickTimer = 30
                    if mouseY-SecLocaY in range(130, 175):                        
                        if WaterToggle == False:
                            WaterToggle = True
                            MineralToggle = False
                            HerbToggle = False
                            HealthToggle = False
                            HappyToggle = False
                        elif WaterToggle == True:
                            WaterToggle = False
                    elif mouseY-SecLocaY in range(184, 227):                        
                        if MineralToggle == False:
                            MineralToggle = True
                            WaterToggle = False
                            HerbToggle = False
                            HealthToggle = False
                            HappyToggle = False
                        elif MineralToggle == True:
                            MineralToggle = False
                    elif mouseY-SecLocaY in range(232, 284):                        
                        if HerbToggle == False:
                            HerbToggle = True
                            WaterToggle = False
                            MineralToggle = False
                            HealthToggle = False
                            HappyToggle = False
                        elif HerbToggle == True:
                            HerbToggle = False
                    elif mouseY-SecLocaY in range(283, 330):                        
                        if HealthToggle == False:
                            HealthToggle = True
                            WaterToggle = False
                            MineralToggle = False
                            HerbToggle = False
                            HappyToggle = False                            
                        elif HealthToggle == True:
                            HealthToggle = False
                    elif mouseY-SecLocaY in range(331, 380):                        
                        if HappyToggle == False:
                            WaterToggle = False
                            MineralToggle = False
                            HerbToggle = False
                            HealthToggle = False                            
                            HappyToggle = True
                        elif HappyToggle == True:
                            HappyToggle = False
                #else:
                    #WaterToggle = False
                    #MineralToggle = False
                    #HerbToggle = False
                    #HealthToggle = False
                    #HappyToggle = False

    # --- MAIN LOOP --- Left Click
            if pygame.mouse.get_pressed()[0] and MenuLoop == False and range_clicks == 0 and BuildBox == False: # <----- Left mouse click operations
                if MiniClick == True and MapToggle == True:
                    if (mouseX > MapLocaX+20 and mouseX < MapLocaX+500) and (mouseY > MapLocaY and mouseY < MapLocaX+500):
                        SelectX += MiniSelectX
                        SelectY += MiniSelectY
                        MiniClick = False
                        Clicked != BoxSector
                    else:
                        MiniSelectX = SelectX
                        MiniSelectY = SelectY
                        MiniBoxSector = BoxSector
                    
    # --- MAIN LOOP --- LEFT CLICK WITH BOXES OPEN --- Left Mouse Click inside and outside the boxes
            if pygame.mouse.get_pressed()[0] and (mouseY > 55):
                if MenuLoop == False and range_clicks == 0:
                    if mouseX < 80:
                        Clicked != BoxSector
                    if (ResToggle1 == True or ResToggle2 == True or BuildBox == True or LaborBox == True) and (mouseX > resLocaX and mouseX < resLocaX+340) and (mouseY > resLocaY and mouseY < resLocaY+557):
                        Clicked != BoxSector 
                    if MapToggle == False or ((mouseX < MapLocaX-10 or mouseX > MapLocaX+500) and (mouseY < MapLocaY or mouseY > MapLocaY+500)):
                        MiniBoxSector = BoxSector
                    if MapToggle == True and (mouseX < MapLocaX+20 or mouseX > MapLocaX+500) and (mouseY < MapLocaY or mouseY > MapLocaX+500):
                        MiniBoxSector = BoxSector
                        MapToggle = False
                    elif MapToggle == True and (mouseX > MapLocaX-10 and mouseX < MapLocaX+500) and (mouseY > MapLocaY and mouseY < MapLocaX+500):
                        SectorZoom = False
                    elif (ResToggle1 == True or ResToggle2 == True or BuildBox == True or LaborBox == True) and (mouseX > resLocaX and mouseX < resLocaX + 350) and (mouseY > resLocaY and mouseY < resLocaY + 640):
                        Clicked != BoxSector
                    elif MoveResource > 0 or mouseX > 1325 or mouseX < 30 or mouseY < 30 or mouseY > 668:
                        Clicked != BoxSector
                    elif SectorZoom == True and (mouseX > SecLocaX-50 and mouseX < SecLocaX+520) and (mouseY > SecLocaY-20) and (mouseY < SecLocaY+500):
                        Clicked != BoxSector
                    else:
                        if Clicked == BoxSector:
                            SectorZoom = True
                            MapToggle = False
                            SelectX = SectorX
                            SelectY = SectorY 
                        else:
                            ClickX = SelectX
                            ClickY = SelectY
                            if mouseX > 80:
                                Clicked = BoxSector
                            ZoomSector = 0
                            # --- If player clicks outside of the scroll box, this will reset the scroll box's objects
                            BuildBox = False
                            LaborBox = False
                            ScrollClick = 0
                            ScrollSelect = [0, 0, 0, 0]

                    if MapToggle == True and (mouseX < MapLocaX-10 or mouseX > MapLocaX+500) and (mouseY < MapLocaY or mouseY > MapLocaY+500):
                        MapToggle = False
                        SectorZoom = True       
                    else:
                        for count in range(-200, 22700):
                            secRange[count] = 21
                            RangeCount[count] = 0
                elif MenuLoop == True:
                    Clicked != BoxSector
                 
    # --- MAIN LOOP --- MOUSE SCROLL --- Determines the Mouse Location and Mouse Map Scroll
        if (BuildBox == False and LaborBox == False and ResToggle1 == False and ResToggle2 == False): 
            if (mouseX < SecLocaX+20 or mouseX > SecLocaX+563) or (mouseY < SecLocaY-50 or mouseY > SecLocaY+500) or (SectorZoom == False):                
                if mouseX < 10 and (ResToggle1 == False and ResToggle2 == False):
                    TickPause += 1
                    SelectX -= 1     
                if mouseX > 1270:
                    TickPause += 1
                    SelectX += 1
                if mouseY < 5:
                    TickPause += 1
                    SelectY -= 1
                if mouseY > 700 and mouseY < 750 and SelectY < 150:
                    TickPause += 1
                    SelectY += 1
        if SelectY < 1:
            SelectY = 1    
        if SelectX < 1:
            SelectX = 150                
        if SelectX > 150:
            SelectX = 1
        if SelectY > 137:
            SelectY = 137
        if BoxSector > 22500:
            SelectY = 150
            BoxSector = 22500

# --- MAIN LOOP --- At the beginning of the game this will orient the player's screen to the start location
        if StartGame == True:
            SelectX = StartX-10
            SelectY = StartY-5
            StartGame = False

# --- MAIN LOOP --- HomeToggle -- Brings player back to StartSector
        if HomeToggle == True:
            if SelectX < StartX-10:
                SelectX += 1        
            if SelectX > StartX-10:
                SelectX -= 1                
            if SelectY < StartY-5:
                SelectY += 1
            if SelectY > StartY-5:
                SelectY -= 1
        if (SelectX == StartX-10 and SelectY == StartY-5):
            HomeToggle = False
            ClickTimer = 0
        if ClickTimer == 0:
            HomeToggle = False

# --- MAIN LOOP --- Mouse Location -- Calculates the current mouse location
        (mouseX, mouseY) = pygame.mouse.get_pos()       
        Selector = SelectX + (SelectY*150)-150
        CursorX = round(mouseX/50)
        CursorY = round(mouseY/50)
        
        if CursorX < 1:
            CursorX = 1
        if CursorY < 1:
            CursorY = 1

    # --- MAIN LOOP --- Cursor location and sectors near the cursor
        if BoxSector < 22501:
            SectorX = SelectX
            SectorY = SelectY
            if mouseX > 700:
                SectorX = int(SelectX + CursorX/5)
            elif mouseX in range (81, 200):
                SectorX = int(SelectX - CursorX/5)
            if mouseY > 500 and mouseX > 80:
                SectorY = int(SelectY + CursorY/5)
            elif mouseY < 200 and mouseY > 50 and mouseX > 80:
                SectorY = int(SelectY - CursorY/5)
            BoxSector = Selector + (CursorX-1) + (CursorY-1)*150  # <--- This is the sector under the mouse cursor
            SelectSectorX = CursorX-1
            SelectSectorY =(CursorY-1)*150
        else:
           BoxSector = 22500

        mouseLoca = (mouseX, mouseY)
            
        if Selector < 2:
            Selector = 1
            
    # --- MAIN LOOP --------------- LOOP for Drawing 50 x 50 Objects on map ------------------------
        TerraRow = 0
        TerraCol = 0
        MapRow = 0
        MapCol = 0 
        mini = 0

    # --- MAIN LOOP --- SMALL SECTOR IMAGES --- Draws the 50 x 50 "grid" objects
        for num in range(0, 338):
            if (Selector + (TerraCol-1) + (TerraRow*150)) < 1:
                Selector = 1
            if (Selector + (TerraCol-1) + (TerraRow*150)) < 22500:
                if TerraCol < 26:
                    TerraCol += 1
                else:
                    TerraCol = 1
                    TerraRow += 1

            sector = Selector + (TerraCol-1) + (TerraRow*150)
            ranTerra = random.randint(1,1000)
            locX = TerraCol*50 - 30
            locY = TerraRow*50 + 20
            
            if sector < 1 or sector > 22500:
                window.blit(gridFROST,(locX, locY))    
            
            if (secTerra[sector] == 1) and secWater[sector] in range(0, 21):
                window.blit(gridPL1,(locX, locY))
            elif (secTerra[sector] == 1) and secWater[sector] in range(20,30):
                window.blit(gridPL2,(locX, locY))
            elif (secTerra[sector] == 1) and secWater[sector] in range(29, 40):
                window.blit(gridPL3,(locX, locY))
            elif (secTerra[sector] == 1) and secWater[sector] > 39:
                if frames < 40:
                    window.blit(gridPLW,(locX, locY))
                elif frames < 70:
                    window.blit(gridPLW1,(locX, locY))
                elif frames < 101:
                    window.blit(gridPLW2,(locX, locY))
                    
            if (secTerra[sector] == 2) and secWater[sector] in range(0, 30):
                window.blit(gridFOR1,(locX, locY))
            elif (secTerra[sector] == 2) and secWater[sector] in range(29,40):
                window.blit(gridFOR2,(locX, locY))
            elif (secTerra[sector] == 2) and secWater[sector] in range(39, 56):
                window.blit(gridFOR3,(locX, locY))
            elif (secTerra[sector] == 2) and secWater[sector] > 55:
                if frames < 20:
                    window.blit(gridFORW,(locX, locY))
                elif frames < 50:
                    window.blit(gridFORW1,(locX, locY))
                elif frames < 101:
                    window.blit(gridFORW2,(locX, locY))    
                
            if (secTerra[sector] == 3) and secWater[sector] in range(0, 10):
                window.blit(gridDES1,(locX, locY))
            elif (secTerra[sector] == 3) and secWater[sector] in range(9,15):
                window.blit(gridDES2,(locX, locY))
            elif (secTerra[sector] == 3) and secWater[sector] in range(14, 21):
                window.blit(gridDES3,(locX, locY))
            elif (secTerra[sector] == 3) and secWater[sector] > 20:
                if frames < 30:
                    window.blit(gridDESW,(locX, locY))
                elif frames < 60:
                    window.blit(gridDESW1,(locX, locY))
                elif frames < 101:
                    window.blit(gridDESW2,(locX, locY))                

            if (secTerra[sector] == 4) and secWater[sector] in range(0, 22):
                window.blit(gridMON1,(locX, locY))
            elif (secTerra[sector] == 4) and secWater[sector] in range(21,31):
                window.blit(gridMON2,(locX, locY))
            elif (secTerra[sector] == 4) and secWater[sector] in range(30, 35):
                window.blit(gridMON3,(locX, locY))
            elif (secTerra[sector] == 4) and secWater[sector] > 34:
                if frames < 35:
                    window.blit(gridMONW,(locX, locY))
                elif frames < 65:
                    window.blit(gridMONW1,(locX, locY))
                elif frames < 101:
                    window.blit(gridMONW2,(locX, locY))

            if (secTerra[sector] == 5 or secTerra[sector] == 7) and frames < 30:
                window.blit(gridWAT2,(locX, locY))
            elif (secTerra[sector] == 5 or secTerra[sector] == 7) and frames < 70:
                window.blit(gridWAT3,(locX, locY))
            elif (secTerra[sector] == 5 or secTerra[sector] == 7) and frames > 69:
                window.blit(gridWAT4,(locX, locY))
            if (secTerra[sector] == 5 and secWater[sector] < 20):
                window.blit(gridISLANDS,(locX, locY))
            elif (secTerra[sector] == 5 and secWater[sector] < 23):
                window.blit(gridISLANDS2,(locX, locY))
            elif (secTerra[sector] == 5 and secWater[sector] < 27):
                window.blit(gridISLANDS3,(locX, locY))
            if (secTerra[sector] == 7):
                window.blit(gridISLAND,(locX, locY))


            if (secTerra[sector] == 6) and secMineral[sector] < 40:
                window.blit(gridFROST,(locX, locY))
            elif (secTerra[sector] == 6) and secMineral[sector] > 39:
                window.blit(gridFROSTmon,(locX, locY))                
                
            if (secOwn[sector] == 1):
                window.blit(boxBLU2,(locX, locY))
            elif (secOwn[sector] == 3 or secOwn[sector] == 2):
                window.blit(boxRED2,(locX, locY))

    # --- MAIN LOOP --- DRAW DIRT ROADS --- Draws 50 x 50 dirt roads to sector map
            if secRoad[sector] == 1:
                if secRoad[sector-150] >0 and secRoad[sector+150] >0 and secRoad[sector+1] >0 and secRoad[sector-1] >0:  # (N-S-E-W)
                    window.blit(build.road[6],(locX, locY))
                elif secRoad[sector+150] >0 and secRoad[sector+1] >0 and secRoad[sector-1] > 0:    # <-- Dirt road (S-E-W)
                    window.blit(build.road[10],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+150] >0 and secRoad[sector+1] >0:   # <-- Dirt road (N-S-E)
                    window.blit(build.road[5],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+1] >0 and secRoad[sector-1] >0:     # <-- Dirt road (N-E-W)
                    window.blit(build.road[4],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+150] >0 and secRoad[sector-1] >0:   # <-- Dirt road (N-S-W)
                    window.blit(build.road[7],(locX, locY))
                elif secRoad[sector+150] >0 and secRoad[sector-1]:                            # <-- Dirt road (S-W)
                    window.blit(build.road[11],(locX, locY))
                elif secRoad[sector+150] >0 and secRoad[sector+1]:                               # <-- Dirt road (S-E)
                    window.blit(build.road[9],(locX, locY))                            
                elif secRoad[sector-150] >0 and secRoad[sector-1] > 0:                           # <-- Dirt road (N-W)
                    window.blit(build.road[8],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+1] >0:                          # <-- Dirt road (N-E)
                    window.blit(build.road[3],(locX, locY))
                elif secRoad[sector] >0 and secRoad[sector-1] == 0 and secRoad[sector+1] == 0:     # <-- Dirt road (N-S)
                    window.blit(build.road[1],(locX, locY))
                elif secRoad[sector-1] >0:                                               # <-- Dirt road (W)
                    window.blit(build.road[2],(locX, locY))
                elif secRoad[sector+1] >0:                                               # <-- Dirt road (E)
                    window.blit(build.road[2],(locX, locY))
                elif secRoad[sector+1] >0 and secRoad[sector-1] >0:                            # <-- Dirt road (E-W)
                    window.blit(build.road[2],(locX, locY))

    # --- MAIN LOOP --- DRAW STONE ROADS --- Draws the 50 x 50 stone roads to sector map
            if secRoad[sector] == 2:
                if secRoad[sector-150] >0 and secRoad[sector+150] >0 and secRoad[sector+1] >0 and secRoad[sector-1] >0:  # (N-S-E-W)
                    window.blit(build.road[26],(locX, locY))
                elif secRoad[sector+150] >0 and secRoad[sector+1] >0 and secRoad[sector-1] > 0:    # <-- Stone road (S-E-W)
                    window.blit(build.road[30],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+150] >0 and secRoad[sector+1] >0:   # <-- Stone road (N-S-E)
                    window.blit(build.road[25],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+1] >0 and secRoad[sector-1] >0:     # <-- Stone road (N-E-W)
                    window.blit(build.road[24],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+150] >0 and secRoad[sector-1] >0:   # <-- Stone road (N-S-W)
                    window.blit(build.road[27],(locX, locY))
                elif secRoad[sector+150] >0 and secRoad[sector-1]:                            # <-- Stone road (S-W)
                    window.blit(build.road[31],(locX, locY))
                elif secRoad[sector+150] >0 and secRoad[sector+1]:                               # <-- Stone road (S-E)
                    window.blit(build.road[29],(locX, locY))                            
                elif secRoad[sector-150] >0 and secRoad[sector-1] > 0:                           # <-- Stone road (N-W)
                    window.blit(build.road[28],(locX, locY))
                elif secRoad[sector-150] >0 and secRoad[sector+1] >0:                          # <-- Stone road (N-E)
                    window.blit(build.road[23],(locX, locY))
                elif secRoad[sector] >0 and secRoad[sector-1] == 0 and secRoad[sector+1] == 0:     # <-- Stone road (N-S)
                    window.blit(build.road[21],(locX, locY))
                elif secRoad[sector-1] >0:                                               # <-- Stone road (W)
                    window.blit(build.road[22],(locX, locY))
                elif secRoad[sector+1] >0:                                               # <-- Stone road (E)
                    window.blit(build.road[22],(locX, locY))
                elif secRoad[sector+1] >0 and secRoad[sector-1] >0:                            # <-- Stone road (E-W)
                    window.blit(build.road[22],(locX, locY))

    # --- MAIN LOOP --- DRAW OBJECTS FOR 50 x 50 MAP ---
            window.blit(boxBLU,(CursorX*50-30, CursorY*50-30)) # ----------> Blits Selector Box <------------
            #if sector in range(SecMin, SecMax):
                #window.blit(check,(locX, locY+5))
            
            if secBuilding[sector][0] > 0:
                build_num = secBuilding[sector][0]
                window.blit(build.grid[build_num],(locX-5, locY))          
            if secBuilding[sector][1] > 0:
                build_num = secBuilding[sector][1]
                window.blit(build.grid[build_num],(locX-5, locY+13))
            if secBuilding[sector][2] > 0:
                build_num = secBuilding[sector][2]
                window.blit(build.grid[build_num],(locX+25, locY+22))
             
            for routes in range(0, 41):
                if ConvoyBlu[routes][0] == sector:                  # <--- This "0" represents where the sprite will be on the next turn
                    window.blit(movePACKblu,(locX, locY))
                #if ConvoyBlu[routes][0] != -1:
                    #print (ConvoyBlu[routes][0])
                #if ConvoyBlu[routes][1] == sector:                  # <--- This "0" represents where the sprite will be on the next turn
                    #window.blit(movePACKblu,(locX, locY))
                '''
                if ConvoyBlu[routes][0] > 0 and Clicked == ConvoyBlu[routes][0]:
                    for movement in range(1, 26):
                        if ConvoyBlu[routes][movement] == sector:
                            test_info = font8.render(str(movement), 1,(black))
                            window.blit(test_info,(locX+5, locY+5))
                            '''

            if ResToggle1 == True:
                if ownGrain[sector] > 0:
                    window.blit(smallGRAIN,(locX, locY-5))
                if (ownMeat[sector] > 0) and (secTerra[sector] != 5):
                    window.blit(smallMEAT,(locX, locY))
                elif (ownMeat[sector] > 0) and (secTerra[sector] == 5):
                    window.blit(smallFISH,(locX, locY))
                if ownForage[sector] > 0:
                    window.blit(smallFORAGE,(locX, locY+5))
                if ownHerb[sector] > 0:
                    window.blit(smallHERB,(locX, locY+10))
                if ownPottery[sector] > 0:
                    window.blit(smallPOTTERY,(locX, locY+15))
                if ownAdobe[sector] > 0:
                    window.blit(smallADOBE,(locX, locY+23))
                if secPop[sector] > 0:
                    window.blit(smallPOP,(locX+25, locY))

            if ResToggle2 == True:
                if ownGold[sector] > 0:
                    window.blit(smallGOLD,(locX, locY-5))
                if ownCopper[sector] > 0:
                    window.blit(smallCOPPER,(locX, locY))
                if ownBronze[sector] > 0:
                    window.blit(smallBRONZE,(locX, locY+10))
                if ownCrystal[sector] > 0:
                    window.blit(smallCRYSTAL,(locX, locY+15))
                if ownStone[sector] > 0:
                    window.blit(smallSTONE,(locX, locY+20))
                if ownClay[sector] > 0:
                    window.blit(smallCLAY,(locX, locY+25))
                if ownWood[sector] > 0:
                    window.blit(smallWOOD,(locX, locY+30))
            if secPop[sector] > 0:
                window.blit(smallPOP,(locX+25, locY))
            if sector == StartSector:                    # <---- Draws Totem Token at Start Sector
                window.blit(build.bau[1],(locX, locY))
            if secOwn[sector] == 2:
                window.blit(build.bau[2],(locX, locY))   # <---- Draws Enemy Token at Start Sector

            if movPop[sector][0]:   # <--- Blits icon for goods' final destination
                window.blit(gridGOODS,(locX, locY))

# --- MAIN LOOP --- DRAW 50 x 50 OBJECTS --- Draws lines from Sector Box to "Clicked" sector
            if sector == Clicked:
                window.blit(boxSelect,(locX, locY))    
            if (sector-150) == Clicked and (SectorZoom == True or MapToggle == True) and InfoToggle == True:
                    pygame.draw.line(window, white, (locX+50, locY-45), (SecLocaX+10, SecLocaY+1))
                    pygame.draw.line(window, black, (locX+50, locY-40), (SecLocaX+540, SecLocaY+75))
                    pygame.draw.line(window, lightgrey, (locX+50, locY-35), (SecLocaX+10, SecLocaY+150))
                    pygame.draw.line(window, grey, (locX+50, locY-30), (SecLocaX+540, SecLocaY+225))
                    pygame.draw.line(window, black, (locX+50, locY-25), (SecLocaX+10, SecLocaY+300))
                    pygame.draw.line(window, white, (locX+50, locY-20), (SecLocaX+540, SecLocaY+375))
                    pygame.draw.line(window, lightgrey, (locX+50, locY-15), (SecLocaX+10, SecLocaY+450))
                    pygame.draw.line(window, black, (locX+50, locY-10), (SecLocaX+540, SecLocaY+500))
                    
# --- MAIN LOOP --- Resource Information Numbers - Water
            if WaterToggle == True:
                if secExplored[sector] > 0:
                    text_popup = font2.render(str(secWater[sector]), 1,(darkBLU))
                    window.blit(text_popup,(locX+5, locY))

# --- MAIN LOOP --- Resource Information Numbers - Minerals
            if MineralToggle == True:
                if secExplored[sector] > 0:
                    text_popup = font2.render(str(secMineral[sector]), 1,(darkBRN))
                    window.blit(text_popup,(locX+5, locY)) 

# --- MAIN LOOP --- Resource Information Numbers - Minerals
            if HerbToggle == True:
                if secExplored[sector] > 0:
                    text_popup = font2.render(str(secHerb[sector]), 1,(black))
                    window.blit(text_popup,(locX+5, locY))                  
                    
# --- MAIN LOOP --- Resource Information Numbers - Health Toggle
            if HealthToggle == True:
                if secPop[sector] > 0:
                    text_popup = font2.render(str(secHealth[sector]), 1,(red))
                    window.blit(text_popup,(locX+5, locY))
                    
                if secPop[BoxSector] > 0:
                    if secHealth[BoxSector] in range(0, 41):
                        window.blit(boxHEALTH3,(mouseX-150, mouseY+30))
                        msg_health = font1.render("Health is poor.", 1,(black))
                    elif secHealth[BoxSector] in range(40, 71):
                        window.blit(boxHEALTH2,(mouseX-150, mouseY+30))
                        msg_health = font1.render("Health is fair.", 1,(black))
                    elif secHealth[BoxSector] in range(70, 101):
                        window.blit(boxHEALTH1,(mouseX-150, mouseY+30))
                        msg_health = font1.render("Health is good!", 1,(black))

                    text_loca = font1.render("Sector #" + str(BoxSector), 1,(black))
                    window.blit(text_loca,(mouseX - 125, mouseY + 50))
                    window.blit(msg_health,(mouseX - 125, mouseY + 80))
                    text_popup = font2.render(str(secHealth[BoxSector]) + "%", 1,(black))
                    window.blit(text_popup,(mouseX+125, mouseY+65))

# --- MAIN LOOP --- Resource Information Numbers - Happiness Toggle                   
            elif HappyToggle == True:
                if secPop[sector] > 0:
                    text_popup = font2.render(str(secHappy[sector]), 1,(pink))
                    window.blit(text_popup,(locX+5, locY))
                    
                if secPop[BoxSector] > 0:
                    if secHappy[BoxSector] > 80:
                        window.blit(boxHAPPY1,(mouseX-150, mouseY+30))
                        msg_happy = font1.render("We're jubilant!", 1,(black))
                    elif secHealth[BoxSector] > 50:
                        window.blit(boxHAPPY2,(mouseX-150, mouseY+30))
                        msg_happy = font1.render("We are OK..", 1,(black))
                    elif secHealth[BoxSector] > -1:
                        window.blit(boxHAPPY3,(mouseX-150, mouseY+30))
                        msg_happy = font1.render("We're depressed.", 1,(black))

                    text_loca = font1.render("Sector #" + str(BoxSector), 1,(black))
                    window.blit(text_loca,(mouseX - 125, mouseY + 50))
                    window.blit(msg_happy,(mouseX - 125, mouseY + 80))
                        
# --- MAIN LOOP --- Resource Information Numbers - DRAW RESOURCE INFORMATION NUMBERS --- Movement Range Distance          
            #if secRange[sector] == 0:
                #text_popup = font2.render("0", 1,(black))
                #window.blit(text_popup,(locX+5, locY))                   
            if secRange[sector] in range(10, 13):
                window.blit(range3,(locX, locY))
            elif secRange[sector] in range(7, 10):
                window.blit(range3,(locX, locY))
            elif secRange[sector] in range(4, 7):
                window.blit(range2,(locX, locY))
            elif secRange[sector] in range(1, 4):
                window.blit(range1,(locX, locY))
            elif secRange[sector] == 0:
                window.blit(range0,(locX, locY))
            if (secRange[sector] < 21 and secRange[sector] > -1): #and (secTerra[sector] != 5 or secRoad[sector] == 2):
                text_popup = font2.render(str(secRange[sector]), 1,(black))
                window.blit(text_popup,(locX+5, locY))
                    
    # --- MAIN LOOP --- DRAW MORE OBJECTS FOR 50 x 50 SECTORS --- Draws instructional boxes to screen
        if InfoToggle == True and (ResToggle1 == False and ResToggle2 == False and BuildBox == False and LaborBox == False):    
            if mouseY > 650 and InfoToggle == True:
                text_popup = font2.render(str("Press [ESC] to close boxes"), 1,(black))
                text_popup2 = font2.render(str("or to open up the menu."), 1,(black))
                window.blit(boxLONG,(mouseX-200, mouseY-650))
                window.blit(text_popup,(mouseX-176, mouseY-620))
                window.blit(text_popup2,(mouseX-175, mouseY-590))
            if mouseY < 75 and InfoToggle == True:
                text_popup = font2.render(str("Press 'h' to go to start."), 1,(black))
                text_popup2 = font2.render(str("Press 'm' for map toggle."), 1,(black))
                window.blit(boxLONG,(mouseX-200, mouseY+540))
                window.blit(text_popup,(mouseX-175, mouseY+560))
                window.blit(text_popup2,(mouseX-175, mouseY+600))                            
            if InfoToggle == True:
                if secTerra[BoxSector] == 1 and secWater[BoxSector] > 39:
                    window.blit(infoPLA,(resLocaX+30, resLocaY+30))
                elif secTerra[BoxSector] == 1:
                    window.blit(infoPLA,(resLocaX+30, resLocaY+30))
                if secTerra[BoxSector] == 2 and secWater[BoxSector] > 55:
                    window.blit(infoFORw,(resLocaX+30, resLocaY+30))
                elif secTerra[BoxSector] == 2:
                    window.blit(infoFOR,(resLocaX+30, resLocaY+30))
                if secTerra[BoxSector] == 3 and secWater[BoxSector] > 20:
                    window.blit(infoDESw,(resLocaX+30, resLocaY+30))
                elif secTerra[BoxSector] == 3:
                    window.blit(infoDES,(resLocaX+30, resLocaY+30))
                if secTerra[BoxSector] == 4 and secWater[BoxSector] > 34:
                    window.blit(infoMONw,(resLocaX+30, resLocaY+30))
                elif secTerra[BoxSector] == 4:
                    window.blit(infoMON,(resLocaX+30, resLocaY+30))
                window.blit(boxINFOlarge,(resLocaX+20, resLocaY+20))
                
    # --- MAIN LOOP ---------- Blits borders and information on the Window Screen
        window.blit(border_yellow2,(0,-10))
        window.blit(border_yellow2,(675,-10))
        
        window.blit(border_yellow1,(-10,2))
        window.blit(border_yellow1,(1320,20))
        
        window.blit(border_yellow2,(-5,670))
        window.blit(border_yellow2,(675,670))

    # --- MAIN LOOP --- MINIMAP --- Draws the smaller 10 x 10 MINI MAP sector boxes
        if (MapToggle == True):
            MapLocaX = SecLocaX+10
            MapLocaY = SecLocaY-40
            
            window.blit(SectorBorder,(MapLocaX-10, MapLocaY-20))
            mini = Selector - 2715  # <--- This tells the minimap which sectors to draw and centers it
            for minicount in range(0, 2500):
                if MapCol < 50:
                    mini += 1
                    MapCol += 1
                else:
                    MapCol = 1
                    MapRow += 1
                    mini += 101           

                minisector = Selector + (MapCol-1) + (MapRow*50)
                MiniLocX = MapCol*10 + MapLocaX
                MiniLocY = MapRow*10 + MapLocaY

# --- MAIN LOOP --- MINIMAP --- Draws the smaller 10 x 10 MINI MAP objects
                if mini > 0 and mini < 22501:
                    if (secTerra[mini] == 1):
                        window.blit(mapPL1,(MiniLocX, MiniLocY))
                    if (secTerra[mini] == 2):
                        window.blit(mapFOR1,(MiniLocX, MiniLocY))
                    if (secTerra[mini] == 3) or (secTerra[mini] == 7):
                        window.blit(mapDES1,(MiniLocX, MiniLocY))
                    if (secTerra[mini] == 4):
                        window.blit(mapMON1,(MiniLocX, MiniLocY))
                    if (secTerra[mini] == 5):
                        window.blit(mapWAT,(MiniLocX, MiniLocY))
                    if (secTerra[mini] == 6):
                        window.blit(mapFROST,(MiniLocX, MiniLocY))

                    if (secRoad[mini] == 1):
                        window.blit(mapROAD1,(MiniLocX, MiniLocY))
                    if (secRoad[mini] == 2):
                        window.blit(mapROAD2,(MiniLocX, MiniLocY))

                    if (secBuilding[mini][0] == 23):
                        window.blit(mapPYRAMID,(MiniLocX, MiniLocY))
                    if (secOwn[mini] == 1 or secPop[mini] > 0):
                        window.blit(mapBLUE,(MiniLocX, MiniLocY))
                    if (secOwn[mini] == 2 or secOwn[mini] == 3):
                        window.blit(mapRED,(MiniLocX, MiniLocY))
                    if mini in range(SecMin, SecMax):
                        window.blit(miniCHECK,(MiniLocX, MiniLocY))

                if mini < 1 or mini > 22500:
                    window.blit(mapFROST,(MiniLocX, MiniLocY))
    
    # --- MINI MAP --- Draws Selector Boxes for the Mini Map
        MiniBoxSector = MiniX + (MiniY*150) + (Selector-2715)  # <-- This matches real sector with mini-map sector
        if MapToggle == True and (mouseX > MapLocaX) and (mouseX < MapLocaX+520):
            if pygame.mouse.get_pressed()[0] and (mouseY-MapLocaY) in range(-15, 80):
                if (mouseX-MapLocaX) in range(-7, 50) and ClickTimer < 1:
                    ClickTimer = 100
                    HomeToggle = True                # <--- If player clicks on semi-transparent totem screen goes to start sector
            MiniX = int(round(mouseX - MapLocaX)/10)
            MiniY = int(round(mouseY - MapLocaY+10)/10)
            MiniSelectX = MiniX-25
            MiniSelectY = MiniY-24

            if InfoToggle == True:
                window.blit(semiBAR,(MapLocaX+10, MapLocaY)) # <--- Blits semi transparent bar at top of map
                if (BoxSector - StartSector > 500) or (StartSector - BoxSector > 500):
                    text_popup = font2.render("Press 'h' to return to start..", 1,(black))
                    window.blit(text_popup,(MapLocaX+15, MapLocaY+10))
                elif SectorZoom == True:
                    text_popup = font2.render("Press 'm' to close the map.", 1,(black))
                    window.blit(text_popup,(MapLocaX+15, MapLocaY+10))
            if (MapToggle == True) and (mouseX > MapLocaX) and (mouseX < MapLocaX+510) and (mouseY > MapLocaY) and (mouseY < MapLocaY+510):
                if MiniX > 0 and MiniY > 0:
                    window.blit(boxSELmini,(MiniX*10+MapLocaX, MiniY*10+MapLocaY))
                    MiniClick = True
            elif (mouseX < MapLocaX+20) or (mouseX > MapLocaX+500) or (mouseY < MapLocaY) or (mouseY > MapLocaX+500):
                if mouseX > 80:
                    MiniClick = False
                    MiniX = SelectX
                    MiniY = SelectY
                    MiniBoxSector = BoxSector
                    Clicked = BoxSector
                    ZoomSector = 0

        pygame.draw.polygon(window, black, ((1355, 0), (1355, 770), (1370, 770), (1370, 0))) # <-- black edge
        if MapToggle == True:
            window.blit(boxMINI,(MiniLocX-355, MiniLocY-310)) # <---- Blits area box within mini-map
            window.blit(TOTEMtransparent,(MapLocaX-35, MapLocaY-20)) # <---- Semi-transparent Totem
        
    # --- END OF MAIN LOOP --- START ZOOMED SECTOR BOX ---
        if (SectorZoom == True or SecLocaX < 1200) and (MapToggle == False) and (MenuLoop == False) and (secExplored[Clicked] == 1): 
            EscapeToggle = False
            ZoomX = SecLocaX+(SectX*75)
            ZoomY = SecLocaY+(SectY*75)
            ZoomLocaX = int(ZoomX/75)-10
            ZoomLocaY = int(ZoomY/75)+1 
            
    # --- END OF MAIN LOOP --- ZOOMED SECTOR BOX --- Blits a box with an "ESC" message to help the player
            if mouseY > 500 and InfoToggle == True:
                text_popup = font2.render(str("Press [ESC] to close boxes"), 1,(black))
                text_popup2 = font2.render(str("Press it again for menu"), 1,(black))
                window.blit(boxLONG,(mouseX-200, mouseY-580))
                window.blit(text_popup,(mouseX-175, mouseY-560))
                window.blit(text_popup2,(mouseX-175, mouseY-520))
            if mouseY < 100 and InfoToggle == True:
                text_popup = font2.render(str("Press 'h' to go to start"), 1,(black))
                text_popup2 = font2.render(str("Press 'm' to toggle the map"), 1,(black))
                window.blit(boxLONG,(mouseX-200, mouseY+520))
                window.blit(text_popup,(mouseX-175, mouseY+540))
                window.blit(text_popup2,(mouseX-175, mouseY+580))
                                
#--- ZOOMED SECTOR BOX --- Randomly generates TERRAIN, WATER, and TREES for newly clicked sectors
            if zoom_sector[Clicked] == 0 and Clicked != 0:
                if Viewed == 1:     # <--- START OF THE GAME: If a sector has never been clicked on before..
                    for num in range(0,3):
                        if secBuilding[Clicked][num] > 0:  # <-- If the land has a building on it, then DO NOTHING..
                            DoNothing = 0
                        else:
                            secBuilding[Clicked][num] = 0   # <---- ..Otherwise reset grid building numbers if there is no PYRAMID
                    for keyerror in range(zoom_sector[Clicked]-36, zoom_sector[Clicked]+1): # <--- This prevents PRESENT NEW sector keyerrors
                        ZoomWater[keyerror] = 0
                        ZoomMineral[keyerror] = 0
                        ZoomHerb[keyerror] = 0
                        ZoomTerra[keyerror] = 0
                        ZoomTrees[keyerror] = 0
                        ZoomLabor[keyerror] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] # <-- 20 different labor tasks
                        ZoomWait[keyerror] = -1
                        ZoomBuild[keyerror] = -1
                        ZoomConstruct[keyerror] = -1
                        BuildLabor[keyerror] = 0
                        IrrigateCheck[keyerror] = 0
                        EnemyBuild[keyerror] = 0
                        CropPotential[keyerror] = 0      
                 
                zoom_sector[Clicked] += Viewed
                Viewed += 36
                for keyerror in range(zoom_sector[Clicked], zoom_sector[Clicked]+72): # <--- This prevents FUTURE NEW sector keyerrors
                    ZoomWater[keyerror] = 0
                    ZoomMineral[keyerror] = 0
                    ZoomHerb[keyerror] = 0
                    ZoomTerra[keyerror] = 0
                    ZoomTrees[keyerror] = 0
                    ZoomLabor[keyerror] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] # <-- 20 different labor tasks
                    ZoomWait[keyerror] = -1
                    ZoomBuild[keyerror] = -1
                    ZoomConstruct[keyerror] = -1
                    BuildLabor[keyerror] = 0
                    IrrigateCheck[keyerror] = 0
                    EnemyBuild[keyerror] = 0

                for terra in range(zoom_sector[Clicked], zoom_sector[Clicked]+36):
                    ranTerra = random.randint(20, 100)  # <--- Random TERRAIN Generator
                    water_amount = secWater[Clicked]
                    if secTerra[Clicked] == 7:       # <--- If biome == ISLAND, give it a better chance to generate land
                        water_amount = 70
                    if secTerra[Clicked] == 2:       # <--- If biome == FOREST, give it a better chance to generate land
                        water_amount -= 10                    
                    if (secTerra[Clicked] == 3) and secWater[Clicked] < 21: # <-- If dry DESERT, then give chance for more water
                        water_amount += 10
                    elif (secTerra[Clicked] == 3) and secWater[Clicked] > 30:
                        water_amount -= 5
                    elif (secTerra[Clicked] == 3) and secWater[Clicked] > 40: # <-- Reduce water in wet deserts
                        water_amount -= 10
                    elif (secTerra[Clicked] == 2) and secWater[Clicked] < 56: # <-- Reduce water in drier forests
                        water_amount -=10
                    if secTerra[Clicked] == 5 and ranTerra-70 > water_amount:
                        ZoomTerra[terra] = 7            # <--- Better chance of making land if the water amount is lower.
                    elif ranTerra < water_amount:      
                        ZoomTerra[terra] = 5            # <--- Otherwise the square will just be water..
                    else:
                        ZoomTerra[terra] = secTerra[Clicked]
                                                            
                    if ZoomTerra[terra] != 5:
                        ranTree = random.randint(-100, 70) # <--- Random TREE generator
                        ranTree += (secWater[Clicked]*2)    # <--- The more water, the better chance for trees
                        if secTerra[Clicked] == 1:
                            ranTree -= 50
                        if secTerra[Clicked] == 2:  # <--- If FOREST terrain then make more trees
                            ranTree += 30
                        if secTerra[Clicked] == 3 and secWater[Clicked] > 20:  # <--- If OASIS terrain then make FEWER trees
                            ranTree -= 30
                        if secTerra[Clicked] == 3 and secWater[Clicked] in range(10, 21):  # <--- If SOMEWHAT DRY DESERT terrain then make MORE CACTI
                            ranTree += 10
                        if terra > 7:
                            if (ZoomTerra[terra-1] == 5 or ZoomTerra[terra-7] == 5 or ZoomTerra[terra-6] == 5 or ZoomTerra[terra-5] == 5) and (ZoomTerra[terra] != 5):
                                ranTree += 10
                            else:
                                ranTree -= 10

                        if ranTree < 40:                # <--- Random TREE Generator
                            ZoomTrees[terra] = 0
                        elif ranTree < 50:
                            ZoomTrees[terra] = 1
                        elif ranTree < 60:
                            ZoomTrees[terra] = 2
                        elif ranTree < 70:
                            ZoomTrees[terra] = 3
                        elif ranTree < 80:
                            ZoomTrees[terra] = 4
                        elif ranTree < 90:
                            ZoomTrees[terra] = 5
                        elif ranTree > 89:
                            ZoomTrees[terra] = 6
                        else:
                            ZoomTrees[terra] = 0
                    else:
                        ZoomTrees[terra] = 0
    
                    ranDry = random.randint(2, 5)   # <--- Random DRYNESS for WATER Generator
                    ranWet = random.randint(-20, 5)
                    ranMin = random.randint(-20, 5) # <--- Random MINERALS Generator
                    ranHerb = random.randint(-10, 5)
                    sector_water = secWater[Clicked]
                    sector_miner = secMineral[Clicked]
                    ZoomWater[terra] += int(sector_water*2 / ranDry)
                    ZoomWater[terra] += int(ZoomTrees[terra] * 2)
                    ZoomWater[terra] += int(ranWet)
                    ZoomMineral[terra] += int(ranMin + (sector_miner * 1.2))  # <--- Random MINERALS Generator
                    ZoomHerb[terra] += ranHerb + (int(ZoomWater[terra]/6) + int(secHerb[Clicked]*2)) - 10
                                       
                for terra in range(zoom_sector[Clicked], zoom_sector[Clicked]+36): # <--- Random WATER Generator for new MINI-SECTORS
                    ZoomPos = (terra - zoom_sector[Clicked]) + 1
                    ZoomPosY = int((ZoomPos-.1)/6)+1
                    ZoomPosX = ZoomPos-(ZoomPosY-1)*6
                    if ZoomTerra[terra] != 5:
                        IrrigateCheck[terra] = 0
                        if ZoomTerra[terra-6] == 5 and ZoomPosY > 1:
                            ZoomWater[terra] += int(ZoomWater[terra-6]*.25)
                            IrrigateCheck[terra] = 1
                        if ZoomTerra[terra-5] == 5 and (ZoomPosY > 1 and ZoomPosX < 6):
                            ZoomWater[terra] += int(ZoomWater[terra-5]*.25)
                            IrrigateCheck[terra] = 1
                        if ZoomTerra[terra+1] == 5 and ZoomPosX < 6:
                            ZoomWater[terra] += int(ZoomWater[terra+1]*.25)
                            IrrigateCheck[terra] = 2
                        if ZoomTerra[terra+7] == 5 and (ZoomPosX < 6 and ZoomPosY < 6):
                            ZoomWater[terra] += int(ZoomWater[terra+7]*.25)
                            IrrigateCheck[terra] = 1
                        if ZoomTerra[terra+6] == 5 and ZoomPosY < 6:
                            ZoomWater[terra] += int(ZoomWater[terra+6]*.25)
                            IrrigateCheck[terra] = 1
                        if ZoomTerra[terra+5] == 5 and (ZoomPosX > 1 and ZoomPosY < 6):
                            ZoomWater[terra] += int(ZoomWater[terra+5]*.25)
                            IrrigateCheck[terra] = 1
                        if ZoomTerra[terra-1] == 5 and (ZoomPosX > 1):
                            ZoomWater[terra] += int(ZoomWater[terra+1]*.25)
                            IrrigateCheck[terra] = 2
                        if ZoomTerra[terra-7] == 5 and (ZoomPosY > 1 and ZoomPosX > 1):
                            ZoomWater[terra] += int(ZoomWater[terra-7]*.25)
                            IrrigateCheck[terra] = 1

                    if ZoomWater[terra] < 1:
                        ZoomWater[terra] = 0
                    if ZoomTerra[terra] == 5 or ZoomHerb[terra] < 1:
                        ZoomHerb[terra] = 0
                    if ZoomTerra[terra] == 5 or ZoomMineral[terra] < 0:
                        ZoomMineral[terra] = 0
                    if ZoomWater[terra] > 30 and ZoomTerra[terra] == 3:
                        ZoomWater[terra] = int(ZoomWater[terra] / 4)
                    if (ZoomWater[terra] < 20) and (ZoomTerra[terra] == 5):
                        ranWater = random.randint(20, 40)
                        ZoomWater[terra] += ranWater
                    if ZoomWater[terra] > 60 and ZoomTerra[terra] != 5:
                        ZoomWater[terra] = int(ZoomWater[terra] / 1.5)
                                    
                if secBuilding[Clicked][0] == 23:   # <--- If the sector already starts with a PYRAMID..
                    Build = zoom_sector[Clicked]
                    ranX = random.randint(0, 2)
                    for num in range(Build+ranX, Build+4+ranX):
                        ZoomTerra[num] = secTerra[Clicked]
                    for num in range(Build+6+ranX, Build+10+ranX):
                        ZoomTerra[num] = secTerra[Clicked] 
                    for num in range(Build+12+ranX, Build+16+ranX):
                        ZoomTerra[num] = secTerra[Clicked]
                    ZoomBuild[Build+15+ranX] = 23
                    EnemyBuild[Build+15+ranX] = 0

#--- ZOOMED SECTOR BOX --- Generates Buildings for Enemy RED sectors when player clicks on an NEW SECTOR
            SecCheck = zoom_sector[Clicked]
            if EnemyBuild[SecCheck] == 0:
                for terra in range(zoom_sector[Clicked], zoom_sector[Clicked]+36):
                    if ZoomTerra[terra] != 5 and secWater[Clicked] > 10: # <--- If the sector is owned by RED
                        ranEnemy = random.randint(-50, 1)
                        if secOwn[Clicked] == 2:
                            ranEnemy += 40
                                        
                        if ZoomTrees[terra] > 3 and ranEnemy > 0:
                            EnemyBuild[terra] = 12   # <-- RED hunting
                        elif ranEnemy > -5 and (ZoomWater[terra] < 20 and ZoomTrees[terra] < 2):
                            EnemyBuild[terra] = 3   # <-- RED tipi
                        elif ranEnemy == -5 and (ZoomWater[terra] < 20):
                            EnemyBuild[terra] = 10   # <-- Shamanic Tipi
                        else:
                            EnemyBuild[terra] = -1
                        
                    else:
                        EnemyBuild[terra] = -1
                if secOwn[Clicked] == 2:
                    ZoomTerra[SecCheck+14] = secTerra[Clicked]
                    ZoomTerra[SecCheck+15] = secTerra[Clicked]
                    ZoomTerra[SecCheck+8] = secTerra[Clicked]
                    ZoomTerra[SecCheck+9] = secTerra[Clicked]

                    EnemyBuild[SecCheck+14] = -1
                    EnemyBuild[SecCheck+15] = 8
                    EnemyBuild[SecCheck+8] = -1
                    EnemyBuild[SecCheck+9] = -1                        

#--- ZOOMED SECTOR BOX --- Mouse Click inside sector box
            if (mouseX-SecLocaX > 75) and (mouseX-SecLocaX < 520) and (mouseY-SecLocaY > 10) and (mouseY-SecLocaY < 451):                 
                BoxZoomSector = zoom_sector[Clicked] + int(round(mouseX-SecLocaX)/75) - 1 + (int(round(mouseY-SecLocaY)/75)*6)
            else:
                BoxZoomSector = 0   # <-- The ZoomSector that the mouse is hovering over

            if pygame.mouse.get_pressed()[0]: # <----- Left Mouse click                
                if (secOwn[Clicked] == 1) and (mouseX-SecLocaX > 75) and (mouseX-SecLocaX < 520) and (mouseY-SecLocaY > 10) and (mouseY-SecLocaY < 451) and MapToggle == False:
                    TempSector = Clicked
                    ZoomSector = zoom_sector[Clicked] + int(round(mouseX-SecLocaX)/75) - 1 + (int(round(mouseY-SecLocaY)/75)*6)
                    ZoomClickX = SecLocaX+(SectX*75)
                    ZoomClickY = SecLocaY+(SectY*75)
                    BuildBox = True
                    LaborBox = False
                    LaborClick = -1  # <-- LaborClick is reset to -1 if player clicks in zoomed sector box
                elif (mouseX-resLocaX > 20) and (mouseX-resLocaX < 355) and (mouseY-resLocaY > 10) and (mouseY-resLocaY < 555):
                    ScrollSelect = [0, 0, 0, 0]
                else:
                    #BuildBox = False
                    #LaborBox = False
                    ScrollSelect = [0, 0, 0, 0]
                    ScrollClick = 0
                    
            elif pygame.mouse.get_pressed()[2]: # <----- Right Mouse click inside sector box
                ScrollClick = 0
                if (mouseX-SecLocaX > 75) and (mouseX-SecLocaX < 520) and (mouseY-SecLocaY > 10) and (mouseY-SecLocaY < 451):
                    TempSector = Clicked
                    ZoomSector = zoom_sector[Clicked] + int(round(mouseX-SecLocaX)/75) - 1 + (int(round(mouseY-SecLocaY)/75)*6)
                    ZoomClickX = SecLocaX+(SectX*75)
                    ZoomClickY = SecLocaY+(SectY*75)
                    LaborBox = True
                    BuildBox = False
                elif (mouseX-resLocaX > 20) and (mouseX-resLocaX < 355) and (mouseY-resLocaY > 10) and (mouseY-resLocaY < 555):
                    ScrollSelect = [0, 0, 0, 0]
                else:
                    #BuildBox = False
                    #LaborBox = False
                    ScrollSelect = [0, 0, 0, 0]
                    ScrollClick = 0

#--- ZOOMED SECTOR BOX --- Draws Background behind the TERRAIN in the sector box                        
            SecCol = 0
            SecRow = 0
            sect = 0
            if secTerra[Clicked] == 5 or secTerra[Clicked] == 7:
                window.blit(SectorWater, (SecLocaX+75, SecLocaY))
            elif secTerra[Clicked] == 3 or secTerra[Clicked] == 4:
                window.blit(SectorBrown, (SecLocaX+75, SecLocaY))
            elif secTerra[Clicked] == 1 or secTerra[Clicked] == 2:
                window.blit(SectorGreen, (SecLocaX+75, SecLocaY))
            elif secTerra[Clicked] == 6:
                window.blit(SectorFrost, (SecLocaX+75, SecLocaY))

            SectorNumber = font1.render(str(Clicked), 1,(black))
            for num in range(0,3):
                secBuilding[Clicked][num] = 0   # <---- Reset grid building numbers

            LocalWorkers = 0      # <-- Reset the worker count
            secHousing[Clicked] = 0 # <-- Reset the HOUSING count
            secStorage[Clicked] = 0 # <-- Reset the STORAGE count
            ForageWork = 0 # <--- Reset worker count
            MineralWork = 0
            StoneWork = 0
            ClayWork = 0
            WoodWork = 0
            FishWork = 0
            FarmWork = 0
            HuntWork = 0
            BronzeWork = 0
            PotteryWork = 0
            HerbWork = 0
            AdobeWork = 0
            for terra in range(zoom_sector[Clicked], zoom_sector[Clicked]+36):
                if SecCol < 6:
                    SecCol += 1
                else:
                    SecCol = 1
                    SecRow += 1
                sect += 1
                buildlocX = SecLocaX + (SecCol*75)
                buildlocY = SecLocaY + (SecRow*75)
                if ZoomBuild[terra] in range (2,8):
                    if ZoomBuild[terra] > secBuilding[Clicked][2]:
                        secBuilding[Clicked][2] = ZoomBuild[terra]
                elif ZoomBuild[terra] in range (8,11) or ZoomBuild[terra] in range (13,15):
                    if ZoomBuild[terra] > secBuilding[Clicked][1]:
                        secBuilding[Clicked][1] = ZoomBuild[terra]
                elif ZoomBuild[terra] in range (21,24):
                    if ZoomBuild[terra] > secBuilding[Clicked][0]:
                        secBuilding[Clicked][0] = ZoomBuild[terra]
                
# --- ZOOMED SECTOR BUILDINGS --- Sector Information & Position Numbers            
                ZoomDraw = ZoomBuild[terra]
                ZoomPos1 = (terra - zoom_sector[Clicked]) + 1
                ZoomPosY = int((ZoomPos1-.1)/6)+1
                ZoomPosX = ZoomPos1-(ZoomPosY-1)*6
                ZoomPosition = ZoomPosX + (ZoomPosY-1)*6
                ZoomMouse = ZoomSector-zoom_sector[Clicked]+1                
                
                ForageWork += ZoomLabor[terra][0]
                MineralWork += ZoomLabor[terra][1]
                StoneWork += ZoomLabor[terra][2]
                ClayWork += ZoomLabor[terra][3]
                WoodWork += ZoomLabor[terra][4]
                FarmWork += ZoomLabor[terra][6]
                HuntWork += ZoomLabor[terra][10] + ZoomLabor[terra][5]
                BronzeWork += ZoomLabor[terra][11]
                PotteryWork += ZoomLabor[terra][12]
                HerbWork += ZoomLabor[terra][21]
                AdobeWork += ZoomLabor[terra][22]

# --- ZOOMED SECTOR BUILDINGS --- For Clicking on Buildings    
                if ZoomSector > 0 and (ZoomBuild[ZoomSector] == 0 and ZoomConstruct[ZoomSector] == -1):
                    if ZoomBuild[ZoomSector+3] == 23 or ZoomConstruct[ZoomSector+3] == 23:
                        ZoomSector += 3
                        ZoomClickX += 225
                    elif ZoomBuild[ZoomSector+2] == 23 or ZoomConstruct[ZoomSector+2] == 23:
                        ZoomSector += 2
                        ZoomClickX += 150
                    elif ZoomBuild[ZoomSector+9] == 23 or ZoomConstruct[ZoomSector+9] == 23:
                        ZoomSector += 9
                        ZoomClickX += 225
                        ZoomClickY += 75
                    elif ZoomBuild[ZoomSector+8] == 23 or ZoomConstruct[ZoomSector+8] == 23:
                        ZoomSector += 8
                        ZoomClickX += 150
                        ZoomClickY += 75
                    elif ZoomBuild[ZoomSector+15] == 23 or ZoomConstruct[ZoomSector+15] == 23:
                        ZoomSector += 15
                        ZoomClickX += 225
                        ZoomClickY += 150
                    elif ZoomBuild[ZoomSector+14] == 23 or ZoomConstruct[ZoomSector+14] == 23:
                        ZoomSector += 14
                        ZoomClickX += 150
                        ZoomClickY += 150
                    elif ZoomBuild[ZoomSector+13] == 23 or ZoomConstruct[ZoomSector+13] == 23:
                        ZoomSector += 13
                        ZoomClickX += 75
                        ZoomClickY += 150
                    elif ZoomBuild[ZoomSector+12] == 23 or ZoomConstruct[ZoomSector+12] == 23:
                        ZoomSector += 12
                        ZoomClickY += 150
                    #elif ZoomConstruct[ZoomSector+1] != -1: #== ZoomConstruct[ZoomSector+1]): #(ZoomBuild[ZoomSector+1] == ZoomBuild[ZoomSector]) or  
                        #ZoomSector += 1
                        #ZoomClickX += 75
                    elif ZoomBuild[ZoomSector+1] in range(8, 10) or ZoomBuild[ZoomSector+1] in range(21, 23) or ZoomBuild[ZoomSector+1] == 15:
                        ZoomSector += 1
                        ZoomClickX += 75
                    elif ZoomConstruct[ZoomSector+1] in range(8, 10) or ZoomConstruct[ZoomSector+1] in range(21, 23) or ZoomConstruct[ZoomSector+1] == 15:
                        ZoomSector += 1
                        ZoomClickX += 75
                    elif ZoomBuild[ZoomSector+6] > 0 or ZoomConstruct[ZoomSector+6] > 0: 
                        ZoomSector += 6
                        ZoomClickY += 75
                    elif ZoomBuild[ZoomSector+7] > 0 or ZoomConstruct[ZoomSector+7] > 0: 
                        ZoomSector += 7
                        ZoomClickX += 75
                        ZoomClickY += 75

                if ZoomSector > zoom_sector[Clicked]+36:
                    ZoomSector = zoom_sector[Clicked]+36
                
                if ZoomBuild[terra] == 23 or ZoomConstruct[terra] == 23:  # ------------->   If there is a pyramid..
                    ZoomTrees[terra] = 0    # <-- If there's a pyramid, then get rid of the trees
                    for Area in range(terra-15, terra-11):   # <-- ..clear the land and make it so it takes up space                                           
                        ZoomBuild[Area] = 0
                        ZoomTrees[Area] = 0
                    for Area in range(terra-9, terra-5):   # <-- ..clear the land and make it so it takes up space                                           
                        ZoomBuild[Area] = 0
                        ZoomTrees[Area] = 0
                    for Area in range(terra-3, terra):   # <-- ..clear the land and then make it so it takes up space                                           
                        ZoomBuild[Area] = 0
                        ZoomTrees[Area] = 0
                    secBuilding[Clicked][0] = 23

#--- ZOOMED SECTOR BOX --- Selector Boxes inside Sector Box
                if ZoomSector > 0 and terra == zoom_sector[Clicked] and (ZoomBuild[ZoomSector] < 0 and ZoomConstruct[ZoomSector] < 0) and (Clicked == TempSector):
                    window.blit(boxSEL2,(ZoomClickX, ZoomClickY)) # ----------> Blits CLICKED SELECTED Box for Zoomed Box<------------                   
                elif ZoomSector > 0 and terra == zoom_sector[Clicked] and (ZoomBuild[ZoomSector] > 0 or ZoomConstruct[ZoomSector] > -1) and (Clicked == TempSector):
                    if ZoomBuild[ZoomSector] == 23 or ZoomConstruct[ZoomSector] == 23:
                        window.blit(boxBLU300,(ZoomClickX-225, ZoomClickY-150)) # ----------> Blits CLICKED SELECTED Box for Zoomed Box<------------
                    elif ZoomBuild[ZoomSector] == 15 or ZoomConstruct[ZoomSector] == 15:
                        window.blit(boxBLU150x75,(ZoomClickX-75, ZoomClickY)) # ----------> Blits CLICKED SELECTED Box for Zoomed Box<------------                    
                    elif ZoomBuild[ZoomSector] in range(8, 10) or ZoomConstruct[ZoomSector] in range(8, 10):
                        window.blit(boxBLU150,(ZoomClickX-75, ZoomClickY-75)) # ----------> Blits CLICKED SELECTED Box for Zoomed Box<------------                    
                    elif ZoomBuild[ZoomSector] in range(21, 23) or ZoomConstruct[ZoomSector] in range(21, 23):
                        window.blit(boxBLU150,(ZoomClickX-75, ZoomClickY-75)) # ----------> Blits CLICKED SELECTED Box for Zoomed Box<------------                 
                    elif ZoomBuild[ZoomSector] > 0 or ZoomConstruct[ZoomSector] > 0:
                        window.blit(boxSEL2,(ZoomClickX, ZoomClickY)) # ----------> Blits CLICKED SELECTED Box for Zoomed Box<------------ 
                if mouseX > SecLocaX + 85 and mouseY > SecLocaY and mouseX < SecLocaX + 520 and mouseY < SecLocaY + 450:
                    SectX = int(round(mouseX-SecLocaX)/75)
                    SectY = int(round(mouseY-SecLocaY)/75)
                    if (ScrollClick == 21 or ScrollClick == 8 or ScrollClick == 22) and (SectX != 1) and (SectY != 0):
                        window.blit(boxSEL150,(SecLocaX+(SectX*75)-75, SecLocaY+(SectY*75)-75)) # ----------> Blits Selector Box for Zoomed Box<------------
                    elif (ScrollClick == 23) and (SectX > 3 and SectY > 1):
                        window.blit(boxSEL300,(SecLocaX+(SectX*75)-225, SecLocaY+(SectY*75)-150)) # ----------> Blits Selector Box for Zoomed Box<------------
                    elif ScrollClick == 15 and (SectX != 1):
                        window.blit(boxSEL150x75,(SecLocaX+(SectX*75)-75, SecLocaY+(SectY*75))) # ----------> Blits Selector Box for Zoomed Box<------------
                    elif (ScrollClick in range(1, 8)) or (ScrollClick in range(10, 15)) or (ScrollClick in range(16, 21)) or ScrollClick == 24:
                        window.blit(boxSEL,(SecLocaX+(SectX*75), SecLocaY+(SectY*75))) # ----------> Blits Selector Box for Zoomed Box<------------
                    elif ScrollClick == 0:
                        pygame.mouse.set_visible(True)
                        #window.blit(boxSEL,(SecLocaX+(SectX*75), SecLocaY+(SectY*75))) # ----------> Blits Selector Box for Zoomed Box<------------  

# --- ZOOMED SECTOR BOX --- Draws the Terrain inside Sector Box 
                if ZoomTerra[terra] == 1:            
                    window.blit(gridPLAlarge, (buildlocX, buildlocY))
                if ZoomTerra[terra] == 2:            
                    window.blit(gridFORlarge, (buildlocX, buildlocY))
                if ZoomTerra[terra] == 3:            
                    window.blit(gridDESlarge, (buildlocX, buildlocY))
                if ZoomTerra[terra] == 4:            
                    window.blit(gridMONlarge, (buildlocX, buildlocY))
                if ZoomTerra[terra] == 5 and frames < 33:            
                    window.blit(gridWATlarge, (buildlocX, buildlocY))
                elif ZoomTerra[terra] == 5 and frames < 65:            
                    window.blit(gridWATlarge1, (buildlocX, buildlocY))
                elif ZoomTerra[terra] == 5 and frames > 64:            
                    window.blit(gridWATlarge2, (buildlocX, buildlocY))
                if ZoomTerra[terra] == 6:            
                    window.blit(gridFROlarge, (buildlocX, buildlocY))
                if ZoomTerra[terra] == 7:
                    window.blit(gridDESlarge, (buildlocX, buildlocY))
                                     
# --- ZOOMED SECTOR TREES --- This draws the FARMS and the SMALLER TREES in the back
                if (ZoomBuild[terra] == 11 or ZoomBuild[terra] == 25) and MoonPhase == 1:
                    window.blit(build.edi[11], (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 FARM behind ALL TREES
                    
                if (ZoomBuild[terra] == 11 or ZoomBuild[terra] == 25) and MoonPhase == 2:
                    window.blit(buildCROPblu2, (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 FARM behind ALL TREES

                if (ZoomBuild[terra] == 11 or ZoomBuild[terra] == 25) and MoonPhase == 3:
                    window.blit(buildCROPblu3, (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 FARM behind ALL TREES

                if (ZoomBuild[terra] == 11 or ZoomBuild[terra] == 25) and MoonPhase == 4:
                    window.blit(buildCROPblu4, (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 FARM behind ALL TREES

                if ZoomBuild[terra] == 25:
                    if frames < 30:
                        window.blit(build.edi[25], (buildlocX, buildlocY))  # <---- Draws the IRRIGATION canals for FARMS
                    elif frames < 60:
                        window.blit(irrigateVER2, (buildlocX, buildlocY))  # <---- Draws the IRRIGATION canals for FARMS
                    else:
                        window.blit(irrigateVER3, (buildlocX, buildlocY))  # <---- Draws the IRRIGATION canals for FARMS
                    
                if ZoomTerra[terra] != 3 and ZoomTerra[terra] != 7 and ZoomTerra[terra] != 6:  # <--- Draws smaller TREES behind the buildings
                    if ZoomTrees[terra] > 0:            
                        window.blit(smallTREE1, (buildlocX-5, buildlocY-15))
                    if ZoomTrees[terra] > 1:
                        window.blit(smallTREE2, (buildlocX+5, buildlocY-15))
                    if ZoomTrees[terra] > 2:
                        window.blit(smallTREE1, (buildlocX+15, buildlocY-15))
                    if ZoomTrees[terra] > 3:
                        window.blit(smallTREE2, (buildlocX+25, buildlocY-15))
                    if ZoomTrees[terra] > 4:
                        window.blit(smallTREE2, (buildlocX+35, buildlocY-15))
                    if ZoomTrees[terra] > 5:
                        window.blit(smallTREE1, (buildlocX+45, buildlocY-15))

                elif (ZoomTerra[terra] == 3 and secWater[Clicked] < 21):          # <--- Draws smaller DESERT plants behind the buildings
                    if ZoomTrees[terra] > 0:     
                        window.blit(smallCACTUS1, (buildlocX-6, buildlocY-15))
                    elif ZoomTrees[terra] > 3:            
                        window.blit(smallCACTUS2, (buildlocX-6, buildlocY-20))
                    if ZoomTrees[terra] > 1:     
                        window.blit(smallCACTUS2, (buildlocX+7, buildlocY-20))
                    if ZoomTrees[terra] > 2:            
                        window.blit(smallCACTUS1, (buildlocX+20, buildlocY-15))
                        
                elif (ZoomTerra[terra] == 3 and secWater[Clicked] > 20) or ZoomTerra[terra] == 7:    # <--- Draws smaller OASIS plants behind the buildings
                    if ZoomTrees[terra] > 0:            
                        window.blit(smallYUCCA, (buildlocX-6, buildlocY-18))
                    elif ZoomTrees[terra] > 4:           
                        window.blit(smallPALM, (buildlocX-6, buildlocY-15))
                    if ZoomTrees[terra] > 1:            
                        window.blit(smallPALM, (buildlocX+7, buildlocY-15))
                    if ZoomTrees[terra] > 2:            
                        window.blit(smallPALM, (buildlocX+20, buildlocY-15))
                    if ZoomTrees[terra] > 3:            
                        window.blit(smallPALM, (buildlocX+32, buildlocY-15))
                    elif ZoomTrees[terra] > 4:            
                        window.blit(smallYUCCA, (buildlocX+32, buildlocY-15))

                elif ZoomTerra[terra] == 6:                           # <--- Draws smaller FROST trees behind the buildings
                    if ZoomTrees[terra] > 0:            
                        window.blit(smallTREEdead, (buildlocX-5, buildlocY-10))
                    if ZoomTrees[terra] > 1:            
                        window.blit(smallTREEfrost, (buildlocX+10, buildlocY-15))
                    if ZoomTrees[terra] > 2:            
                        window.blit(smallTREEfrost, (buildlocX+25, buildlocY-15))
                    if ZoomTrees[terra] > 3:            
                        window.blit(smallTREEdead, (buildlocX+35, buildlocY-10))


# --- ZOOMED SECTOR BUILDINGS --- This draws the RED ENEMY BUILDINGS in the sector box
                if secOwn[Clicked] == 2 or secOwn[Clicked] == 3:
                    if EnemyBuild[terra] == 3:
                        window.blit(buildTIPIred, (buildlocX, buildlocY-20))  # <---- Draws RED tipi
                    elif EnemyBuild[terra] == 8:
                        window.blit(buildVILLAGEred, (buildlocX-75, buildlocY-75))  # <---- Draws MEETING tipi for enemy
                    elif EnemyBuild[terra] == 10:
                        window.blit(build.edi[10], (buildlocX, buildlocY-20))  # <---- Draws SHAMANIC tipi for enemy
                    elif EnemyBuild[terra] == 12:
                        window.blit(buildHUNTred, (buildlocX, buildlocY-20))  # <---- Draws RED hunting tipi

# --- ZOOMED SECTOR BUILDINGS --- This draws the BUILDINGS in the sector box
                if ZoomBuild[terra] == 21 or ZoomBuild[terra] == 8 or ZoomBuild[terra] == 9 or ZoomBuild[terra] == 22:
                    window.blit(build.edi[ZoomDraw], (buildlocX-75, buildlocY-75)) # <---- Draws larger 2 x 2 buildings
                elif ZoomBuild[terra] == 23 and secTerra[Clicked] != 6:
                    window.blit(build.edi[ZoomDraw], (buildlocX-225, buildlocY-170)) # <---- Draws larger 4 x 3 PYRAMID
                elif ZoomBuild[terra] == 23 and secTerra[Clicked] == 6:
                    window.blit(buildPYRAMIDfrost, (buildlocX-225, buildlocY-170)) # <---- Draws larger 4 x 3 FROST PYRAMID                  
                elif ZoomBuild[terra] == 15:
                    window.blit(build.edi[15], (buildlocX-80, buildlocY-40))  # <---- Draws 1 x 2 Storage Lodge
                elif ZoomBuild[terra] == 20:
                    window.blit(build.edi[20], (buildlocX+5, buildlocY-45))  # <---- Draws 1 x 1 Complex Tower
                    
# --- ZOOMED SECTOR BUILDINGS --- DEFENSE WALLS --- This draws the WALL DEFENSES in the sector box
                elif ZoomBuild[terra] in range(16, 19):
                    if ZoomPosX == 1 and (ZoomBuild[terra+1] in range(16, 19)):
                        window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 Horizontal Facing Wall
                    if ZoomPosX == 6 and (ZoomBuild[terra-1] in range(16, 19)):
                        window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 Horizontal Facing Wall
                    if (ZoomPosition > 6 and ZoomBuild[terra-6] in range(16, 19)) or (ZoomPosition < 31 and ZoomBuild[terra+6] in range(16, 19)):
                        if ZoomBuild[terra] == 16:
                            window.blit(buildWOODver, (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 Vertical Facing Wall
                        if ZoomBuild[terra] == 17:
                            window.blit(buildBRICKver, (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 Vertical Facing Wall
                        if ZoomBuild[terra] == 18:
                            window.blit(buildSTONEver, (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 Vertical Facing Wall
                    else:
                        if ZoomBuild[terra] in range(16, 19):              
                            window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws 1 x 1 Horizontal Facing Wall
                        
# --- ZOOMED SECTOR BUILDINGS ---  COMPLEX HOUSING --- This draws and animates COMPLEX 2x2 and 2x1 Housing
                elif ZoomPosition in range(2,36) and ZoomBuild[terra-1] == 4 and ZoomBuild[terra] == 4:
                    window.blit(complexADOBE, (buildlocX-20, buildlocY-40))  # <---- Draws larger 2 x 1 COMPLEX ADOBE HOUSING
                elif ZoomPosition in range(1,35) and ZoomBuild[terra] == 4 and ZoomBuild[terra+1] == 4:
                    ZoomBuild[terra] = 4
                    window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws smaller 1 x 1 buildings 
                elif ZoomPosition in range(8,37) and ZoomBuild[terra-1] == 3 and ZoomBuild[terra] == 3 and ZoomBuild[terra-6] == 3 and ZoomBuild[terra-7] == 3:
                    if frames < 30:
                        window.blit(complexTIPI, (buildlocX-55, buildlocY-75))  # <---- Animates larger 2 x 2 COMPLEX TIPI HOUSING
                    elif frames < 70:
                        window.blit(complexTIPI2, (buildlocX-55, buildlocY-75))  # <---- Animates larger 2 x 2 COMPLEX TIPI HOUSING
                    elif frames > 69:
                        window.blit(complexTIPI3, (buildlocX-55, buildlocY-75))  # <---- Animates larger 2 x 2 COMPLEX TIPI HOUSING 
                elif (ZoomPosition in range(6,37) and ZoomBuild[terra] == 3) and (ZoomBuild[terra-1] == 3 and ZoomBuild[terra-5] == 3 and ZoomBuild[terra-6] == 3):
                    DoNothing = 0
                elif (ZoomPosition in range(1,30) and ZoomBuild[terra] == 3) and (ZoomBuild[terra+1] == 3 and ZoomBuild[terra+6] == 3 and ZoomBuild[terra+7] == 3):
                    if ZoomPosX == 6:
                        ZoomDraw = ZoomBuild[terra]
                        window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws smaller 1 x 1 buildings                    
                elif ZoomPosition in range(8,37) and ZoomBuild[terra-1] == 2 and ZoomBuild[terra] == 2 and ZoomBuild[terra-6] == 2 and ZoomBuild[terra-7] == 2:
                    if frames < 30:
                        window.blit(complexHUT, (buildlocX-75, buildlocY-65))  # <---- Animates larger 2 x 2 COMPLEX WIGWAM HOUSING
                    elif frames < 70:
                        window.blit(complexHUT2, (buildlocX-75, buildlocY-65))  # <---- Animates larger 2 x 2 COMPLEX WIGWAM HOUSING
                    elif frames > 69:
                        window.blit(complexHUT3, (buildlocX-75, buildlocY-65))  # <---- Animates larger 2 x 2 COMPLEX WIGWAM HOUSING                        
                elif (ZoomPosition in range(6,37) and ZoomBuild[terra] == 2) and (ZoomBuild[terra-1] == 2 and ZoomBuild[terra-5] == 2 and ZoomBuild[terra-6] == 2):
                    DoNothing = 0
                elif (ZoomPosition in range(1,30) and ZoomBuild[terra] == 2) and (ZoomBuild[terra+1] == 2 and ZoomBuild[terra+6] == 2 and ZoomBuild[terra+7] == 2):
                    if ZoomPosX == 6:
                        ZoomDraw = ZoomBuild[terra]
                        window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws smaller 1 x 1 buildings
                        
# --- ZOOMED SECTOR BUILDINGS ---  This draws ALL OTHER BUILDINGS in the sector box
                elif ZoomBuild[terra] == 3 and ZoomTrees[terra] > 3:
                    window.blit(buildTIPIwood, (buildlocX, buildlocY-10))  # <---- Draws alternate wood TIPI
                elif ZoomBuild[terra] > 0 and ZoomBuild[terra] != 11 and ZoomBuild[terra] != 25:    # <-- Draws all other buildings (except FARMS)
                    ZoomDraw = ZoomBuild[terra]
                    window.blit(build.edi[ZoomDraw], (buildlocX, buildlocY-20))  # <---- Draws smaller 1 x 1 buildings

# --- ZOOMED SECTOR BUILDINGS ---  This CALCULATES HOUSING AND STORAGE CAPACITY
                if ZoomBuild[terra] in range(2, 8):
                    secHousing[Clicked] += int(ZoomBuild[terra]*2)
                    secStorage[Clicked] += int(ZoomBuild[terra]*10)
                elif ZoomBuild[terra] in range(8, 10):
                    secStorage[Clicked] += int(ZoomBuild[terra]*15)
                elif ZoomBuild[terra] == 10 or ZoomBuild[terra] == 12: 
                    secStorage[Clicked] += int(ZoomBuild[terra]*3)
                elif ZoomBuild[terra] == 15:
                    secStorage[Clicked] += int(ZoomBuild[terra]*30)                            
            
                if ZoomPosition in range(8,37) and ZoomBuild[terra-1] == 2 and ZoomBuild[terra] == 2 and ZoomBuild[terra-6] == 2 and ZoomBuild[terra-7] == 2:
                    secHousing[Clicked] +=2
                    secStorage[Clicked] += 20
                elif (ZoomPosition in range(1,30) and ZoomBuild[terra] == 3) and (ZoomBuild[terra+1] == 3 and ZoomBuild[terra+6] == 3 and ZoomBuild[terra+7] == 3):
                    secHousing[Clicked] += 4
                    secStorage[Clicked] += 30
                elif ZoomPosition in range(2,36) and ZoomBuild[terra-1] == 4 and ZoomBuild[terra] == 4:
                    secHousing[Clicked] += 5
                    secStorage[Clicked] += 40
                elif ZoomPosition in range(8,37) and ZoomBuild[terra-1] == 3 and ZoomBuild[terra] == 3 and ZoomBuild[terra-6] == 3 and ZoomBuild[terra-7] == 3:
                    secHousing[Clicked] += 4
                    secStorage[Clicked] += 30
                    
# --- ZOOMED SECTOR BUILDINGS --- Draws Construction Sites and Calculates How Much Labor is Needed
                if ZoomConstruct[terra] > 0:
                    ZoomDraw = ZoomConstruct[terra]  # <-- if it's construction..
                    
# --- ZOOMED SECTOR BUILDINGS ---  This draws CONSTRUCTION SITES for buildings
                if ZoomConstruct[terra] == 21 or ZoomConstruct[terra] == 8 or ZoomConstruct[terra] == 22:
                    window.blit(construct150, (buildlocX-75, buildlocY-75))  # <---- Draws larger 2 x 2 construction sites
                elif ZoomConstruct[terra] == 23:
                    window.blit(constructPYRAMID, ((buildlocX-225, buildlocY-170)))  # <---- Draws larger 2 x 2 construction sites
                elif ZoomConstruct[terra] == 15:
                    window.blit(constructSTORE, (buildlocX-75, buildlocY-25))  # <---- Draws larger 2 x 2 construction sites
                elif ZoomConstruct[terra] > 0:    # <-- All other buildings
                    window.blit(construct75, (buildlocX, buildlocY))  # <---- Draws smaller 1 x 1 construction sites            
                
                #test_info = font7.render(str(EnemyBuild[terra]), 1,(black))
                #window.blit(test_info,(buildlocX+10, buildlocY+10))
                #test_info = font6.render("y = " + str(ZoomPosY), 1,(black))
                #window.blit(test_info,(buildlocX+10, buildlocY+30))

# --- ZOOMED SECTOR TREES --- This draws the LARGER TREES in the sector box
                if ZoomTerra[terra] != 3 and ZoomTerra[terra] != 7 and ZoomTerra[terra] != 6:  # <--- Draws larger trees in front of buildings
                    if ZoomTrees[terra] > 3:            
                        window.blit(largeTREE2, (buildlocX+53, buildlocY+25))
                    if ZoomTrees[terra] > 4:            
                        window.blit(largeTREE2, (buildlocX-5, buildlocY+25))
                    if ZoomTrees[terra] > 5:
                        window.blit(largeTREE1, (buildlocX-15, buildlocY+25)) 
                elif ZoomTerra[terra] == 7 or (ZoomTerra[terra] == 3 and secWater[Clicked] > 20):  # <-- If terrain is oasis, islands, or sandy beach..
                    if ZoomTrees[terra] > 2:            
                        window.blit(largePALM, (buildlocX+45, buildlocY+31))
                    if ZoomTrees[terra] > 3:
                        window.blit(largePALM, (buildlocX-10, buildlocY+31))
                    elif ZoomTrees[terra] > 4:            
                        window.blit(largeYUCCA, (buildlocX-10, buildlocY+33))
                elif (ZoomTerra[terra] == 3 and secWater[Clicked] < 21):  # <-- However, if terrain is just dry desert..                        
                    if ZoomTrees[terra] > 2:            
                        window.blit(largeCACTUS1, (buildlocX+45, buildlocY+31))
                    elif ZoomTrees[terra] > 3:
                        window.blit(largeCACTUS2, (buildlocX+45, buildlocY+31))
                    if ZoomTrees[terra] > 4:            
                        window.blit(largeCACTUS2, (buildlocX-10, buildlocY+31))
                    elif ZoomTrees[terra] > 5:
                        window.blit(largeCACTUS1, (buildlocX-10, buildlocY+31))
                elif ZoomTerra[terra] == 6:
                    if ZoomTrees[terra] > 2:            
                        window.blit(largeTREEdead, (buildlocX+45, buildlocY+35))
                    elif ZoomTrees[terra] > 3:
                        window.blit(largeTREEfrost, (buildlocX+45, buildlocY+35)) 
                    if ZoomTrees[terra] > 4:            
                        window.blit(largeTREEdead, (buildlocX-10, buildlocY+35))
                    elif ZoomTrees[terra] > 5:
                        window.blit(largeTREEfrost, (buildlocX-10, buildlocY+35))

# --- ZOOMED SECTOR BUILDINGS --- If the building isn't there, then this frees up the space
                if ZoomBuild[terra] in range(21, 23) or ZoomConstruct[terra] in range(21, 23):                
                    ZoomBuild[terra-1] = 0
                    ZoomBuild[terra-6] = 0
                    ZoomBuild[terra-7] = 0
                elif ZoomBuild[terra] == 15 or ZoomConstruct[terra] == 15:
                    ZoomBuild[terra-1] = 0
                elif ZoomBuild[terra] == 8 or ZoomConstruct[terra] == 8 or ZoomBuild[terra] == 9 or ZoomConstruct[terra] == 9:      
                    ZoomBuild[terra-1] = 0
                    ZoomBuild[terra-6] = 0
                    ZoomBuild[terra-7] = 0
                elif ZoomConstruct[terra] > 0:
                    ZoomBuild[terra] = 0
                elif ZoomBuild[terra] > 0:
                    ZoomBuild[terra] = ZoomBuild[terra]
                elif ZoomBuild[terra] == 24 or ZoomConstruct[terra] == 24:
                    ZoomBuild[terra] = -1
                    ZoomConstruct[terra] = -1
                    
# --- ZOOMED SECTOR LABOR INFORMATION --- Checks Labor Amount Stats and Keeps it Accurate
                SingleCount = 0
                for labor_type in range(0, 23):
                    if ZoomLabor[terra][labor_type] < 1:
                        ZoomLabor[terra][labor_type] = 0
                    if (labor_type < 5 or labor_type == 21) and (ZoomBuild[terra] != -1):   # <-- If a building, then no default labor
                        ZoomLabor[terra][labor_type] = 0

# --- ZOOMED SECTOR LABOR INFORMATION --- Counts up ALL of the WORKERS and keeps LABOR ACCURATE
                    if ZoomLabor[terra][labor_type] > 0:
                        SingleCount += ZoomLabor[terra][labor_type]
                        LocalWorkers += ZoomLabor[terra][labor_type]
                        if SingleCount > 10 or (LocalWorkers > secPop[Clicked]): 
                            LocalWorkers -= 1
                            SingleCount -= 1
                            ZoomLabor[terra][labor_type] -= 1

# --- ZOOMED SECTOR LABOR INFORMATION --- Draws Workers on Sector Square
                        if ZoomTerra[terra] == 5:
                            if ZoomLabor[terra][labor_type] > 0:
                                window.blit(workWATER,(buildlocX-3, buildlocY-5))   # <--- If workers are on water..
                        else:
                            if (ZoomLabor[terra][0] > 0) or (ZoomLabor[terra][6] > 0):
                                window.blit(womanFORAGE,(buildlocX+15, buildlocY+28))   # <--- If workers are assigned a task, it will draw them here
                            elif (ZoomLabor[terra][labor_type] > 0) and (labor_type > 19):
                                window.blit(womanBUILD,(buildlocX+15, buildlocY+28))   # <--- If workers are assigned a task, it will draw them here                           
                            elif ZoomLabor[terra][labor_type] > 0:
                                window.blit(workDEFAULT,(buildlocX+15, buildlocY+28))   # <--- If workers are assigned a task, it will draw them here
                    elif ZoomLabor[terra][labor_type] < 1:
                        ZoomLabor[terra][labor_type] = 0            
                IdleWorkers = secPop[Clicked] - LocalWorkers                                          

# --- ZOOMED SECTOR LABOR INFORMATION --- MAX LABOR CHECK
                if ZoomLabor[terra][8] > 3:   # <--- Max of 3 workers for healing
                    ZoomLabor[terra][8] = 3
                    
                if ZoomLabor[terra][11] > 5:   # <--- Max of 5 for BRONZE TOOLS AND WEAPONS
                    ZoomLabor[terra][11] = 5
                if ZoomLabor[terra][11] > (ownCopper[Clicked]/2):
                    ZoomLabor[terra][11] = 5
                    
                if (ZoomLabor[terra][12] + ZoomLabor[terra][22]) > 5: # <-- Max of 5 for POTTERY (12) and ADOBE (22)
                    ZoomLabor[terra][12] -= 1
                    ZoomLabor[terra][22] -= 1
                if ownClay[Clicked] < (ZoomLabor[terra][12] + ZoomLabor[terra][22]):
                     ZoomLabor[terra][12] -= 1
                     ZoomLabor[terra][22] -= 1
                if ownClay[Clicked] < ownWood[Clicked]:
                     ZoomLabor[terra][12] -= 1
                     ZoomLabor[terra][22] -= 1
                if ZoomLabor[terra][22] < 1:
                    ZoomLabor[terra][22] = 0
                if ZoomLabor[terra][12] < 1:
                    ZoomLabor[terra][12] = 0                    
                
                if ZoomLabor[terra][6] > 0:  # <-- Maxes out labor on FARMS if the farm is underdeveloped..
                    if (CropPotential[terra] > 0) and (ZoomLabor[terra][6] > CropPotential[terra]):
                        ZoomLabor[terra][6] -= 1
                    if (MoonPhase == 2 or MoonPhase == 3) and ZoomLabor[terra][6] > 2:
                        ZoomLabor[terra][6] -= 1
                    
                if ZoomLabor[terra][20] > BuildLabor[terra]: # <--- CONSTRUCTION: Maxes out number of builders based on need..
                    ZoomLabor[terra][20] = BuildLabor[terra]

# --- ZOOMED SECTOR INFORMATION --- Water and Minerals
                if (ZoomBuild[terra] < 1 or ZoomConstruct[terra] == 0):                
                    if WaterToggle == True and ZoomWater[terra] > 0:
                        if ZoomWater[terra] > 50:
                            window.blit(waterLEVEL1,(buildlocX, buildlocY))
                            test_info = font10.render(str(ZoomWater[terra]), 1,(white))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))
                        elif ZoomWater[terra] > 40:
                            window.blit(waterLEVEL2,(buildlocX, buildlocY))
                            test_info = font8.render(str(ZoomWater[terra]), 1,(white))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))                                             
                        elif ZoomWater[terra] > 30:
                            window.blit(waterLEVEL3,(buildlocX, buildlocY))
                            test_info = font7.render(str(ZoomWater[terra]), 1,(white))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))  
                        elif ZoomWater[terra] > 20:
                            window.blit(waterLEVEL4,(buildlocX, buildlocY))
                            test_info = font6.render(str(ZoomWater[terra]), 1,(white))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))  
                        elif ZoomWater[terra] > 5:
                            window.blit(waterLEVEL5,(buildlocX, buildlocY))                                                        
                        
                    elif MineralToggle == True and ZoomMineral[terra] > 0:
                        if ZoomMineral[terra] > 40:
                            window.blit(mineralLEVEL1,(buildlocX, buildlocY))
                            test_info = font10.render(str(ZoomMineral[terra]), 1,(darkRED))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))
                        elif ZoomMineral[terra] > 30:
                            window.blit(mineralLEVEL2,(buildlocX, buildlocY))
                            test_info = font8.render(str(ZoomMineral[terra]), 1,(darkRED))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))                                            
                        elif ZoomMineral[terra] > 15:
                            window.blit(mineralLEVEL3,(buildlocX, buildlocY))
                            test_info = font7.render(str(ZoomMineral[terra]), 1,(darkRED))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))      
                        elif ZoomMineral[terra] > 5:
                            window.blit(mineralLEVEL4,(buildlocX, buildlocY))
                            test_info = font6.render(str(ZoomMineral[terra]), 1,(darkRED))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))      
                        elif ZoomMineral[terra] > 0:
                            window.blit(mineralLEVEL5,(buildlocX, buildlocY))
                        
                    elif HerbToggle == True and ZoomHerb[terra] > 0 and (ZoomBuild[terra] == -1 or ZoomBuild[terra] == 0):
                        if ZoomHerb[terra] > 20:
                            window.blit(herbLEVEL1,(buildlocX, buildlocY))
                            test_info = font10.render(str(ZoomHerb[terra]), 1,(black))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))                                              
                        elif ZoomHerb[terra] > 15:
                            window.blit(herbLEVEL2,(buildlocX, buildlocY))
                            test_info = font8.render(str(ZoomHerb[terra]), 1,(black))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))                                              
                        elif ZoomHerb[terra] > 10:
                            window.blit(herbLEVEL3,(buildlocX, buildlocY))
                            test_info = font7.render(str(ZoomHerb[terra]), 1,(black))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))   
                        elif ZoomHerb[terra] > 5:
                            window.blit(herbLEVEL4,(buildlocX, buildlocY))
                            test_info = font6.render(str(ZoomHerb[terra]), 1,(black))
                            window.blit(test_info,(buildlocX+15, buildlocY+15))   
                        elif ZoomHerb[terra] > 0:
                            window.blit(herbLEVEL5,(buildlocX, buildlocY))
                    
                #test_info = font8.render(str(ZoomBuild[terra]) + " " + str(ZoomConstruct[terra]), 1,(white))        
                #window.blit(test_info,(buildlocX+2, buildlocY+2))                                                                  
                #test_info = font8.render(str(SectX) + " " + str(SectY), 1,(white))        
                #window.blit(test_info,(buildlocX+2, buildlocY+20))                                                                  

                            
# --- ZOOMED SECTOR INFORMATION --- Side Information on the LEFT SIDE and TOP of the Zoom Sector Box
            window.blit(SECTORedge, (SecLocaX-32, SecLocaY-18)) # <-- This draws the LEFT EDGE to boxSECTORS    
            if ZoomBuild[ZoomSector] > 0:
                window.blit(boxSQUARE,(SecLocaX-103, SecLocaY-27))
                building_num = ZoomBuild[ZoomSector]
                if building_num == 23:
                    window.blit(infoPYRAMID,(SecLocaX-88, SecLocaY-10))
                elif building_num in range(1, 8) or building_num in range(10, 15) or building_num in range(16, 21):
                    side_pic = build.edi[building_num]
                    adjustment = 0
                    if building_num == 20:
                        adjustment = 15
                    window.blit(side_pic,(SecLocaX-55, SecLocaY-adjustment))
                elif building_num == 25:
                    side_pic = build.edi[11]
                    window.blit(side_pic,(SecLocaX-55, SecLocaY))   # <-- If IRRIGATED farm, just draw a FARM.. 
                else:
                    side_pic = build.edi[building_num]
                    window.blit(side_pic,(SecLocaX-103, SecLocaY-20))
                    
            elif ZoomConstruct[ZoomSector] > 0 and LaborBox == False:
                window.blit(boxSQUARE,(SecLocaX-103, SecLocaY-27))
                building_num = ZoomConstruct[ZoomSector]
                if building_num == 23:
                    window.blit(infoPYRAMID,(SecLocaX-88, SecLocaY-10))
                elif building_num in range(1, 8) or building_num in range(10, 15) or building_num in range(16, 21):
                    side_pic = build.edi[building_num]
                    adjustment = 0
                    if building_num == 20:
                        adjustment = 15
                    window.blit(side_pic,(SecLocaX-55, SecLocaY-adjustment))                                     
                else:
                    side_pic = build.edi[building_num]
                    window.blit(side_pic,(SecLocaX-103, SecLocaY-20))

# --- ZOOMED SECTOR INFORMATION --- Resource Information on the LEFT SIDE of the Zoom Sector Box
            adjustWATER = 0
            adjustMINERAL = 0
            adjustHERB = 0
            adjustHEALTH = 0
            adjustHAPPY = 0
            
            window.blit(waterTOGGLE,(SecLocaX-5, SecLocaY+128))
            window.blit(mineralTOGGLE,(SecLocaX-5, SecLocaY+178))
            window.blit(herbTOGGLE,(SecLocaX-5, SecLocaY+228))
            window.blit(healthTOGGLE,(SecLocaX-5, SecLocaY+278))
            window.blit(happyTOGGLE,(SecLocaX-5, SecLocaY+328))
            
            if WaterToggle == True:
                window.blit(highlightTOGGLE,(SecLocaX-5, SecLocaY+128))
                adjustWATER = -75 
                window.blit(sideWATER,(SecLocaX-103, SecLocaY-27))
                if ZoomWater[BoxZoomSector] > 0:
                    test_info = font5.render(str(ZoomWater[BoxZoomSector]), 1,(darkgrey))
                    window.blit(test_info,(SecLocaX-15, SecLocaY+45))

            if MineralToggle == True:
                window.blit(highlightTOGGLE,(SecLocaX-5, SecLocaY+178))                
                adjustMINERAL = -150
                window.blit(sideMINERALS,(SecLocaX-103, SecLocaY-27))
                if ZoomMineral[BoxZoomSector] > 0:
                    test_info = font5.render(str(ZoomMineral[BoxZoomSector]), 1,(black))
                    window.blit(test_info,(SecLocaX-15, SecLocaY+45))
               
            if HerbToggle == True:
                window.blit(highlightTOGGLE,(SecLocaX-5, SecLocaY+228))
                adjustHERB = -225
                window.blit(sideHERBS,(SecLocaX-103, SecLocaY-27))
                if ZoomHerb[BoxZoomSector] > 0:
                    test_info = font5.render(str(ZoomHerb[BoxZoomSector]), 1,(darkgrey))
                    window.blit(test_info,(SecLocaX-13, SecLocaY+45))
                    
            if HealthToggle == True:
                window.blit(highlightTOGGLE,(SecLocaX-5, SecLocaY+278))

            if HappyToggle == True:
                window.blit(highlightTOGGLE,(SecLocaX-5, SecLocaY+328))
                if secPop[Clicked] > 0:
                    if secHappy[Clicked] > 80:
                        window.blit(sideHAPPY1,(SecLocaX-103, SecLocaY-27))
                    elif secHappy[Clicked] > 50:
                        window.blit(sideHAPPY2,(SecLocaX-103, SecLocaY-27))
                    elif secHappy[Clicked] > -1:
                        window.blit(sideHAPPY3,(SecLocaX-103, SecLocaY-27))
                     
# --- ZOOMED SECTOR INFORMATION --- Resource Information on the TOP of the screen
            LocalGoods = 0
            AvailablePottery = 0
            AvailablePottery = int(ownPottery[Clicked]) - int((ownGrain[Clicked]/5) + (ownMeat[Clicked]/2) + (ownForage[Clicked]/4))
            LocalGoods += int(ownHerb[Clicked]/4) + int(ownPottery[Clicked]*2) + ownAdobe[Clicked]
            LocalGoods += int(ownGold[Clicked] + ownCopper[Clicked] + ownBronze[Clicked] + ownCrystal[Clicked])
            LocalGoods += int(ownStone[Clicked]*10) + ownClay[Clicked] + int(ownWood[Clicked]*3)
            AvailableStorage = int(secStorage[Clicked] - LocalGoods)
    
            if MoonPhase == 1:
                window.blit(sideMOON1,(330, -2))
            if MoonPhase == 2:
                window.blit(sideMOON2,(330, -2))
            if MoonPhase == 3:
                window.blit(sideMOON3,(330, -2))
            if MoonPhase == 4:
                window.blit(sideMOON4,(330, -2))
            box_info = font3.render(str(MoonCycle), 1,(black))
            window.blit(box_info,(382, 12))    

            window.blit(sideSTORAGE,(430, -2))
            if AvailableStorage > -1:
                box_info = font3.render(str(AvailableStorage), 1,(black))
                window.blit(box_info,(485, 12))
            else:
                box_info = font3.render(str(AvailableStorage), 1,(red))
                window.blit(box_info,(478, 12))
    
            window.blit(sidePOTTERY,(540, -2))
            if AvailablePottery > -1:
                box_info = font3.render(str(AvailablePottery), 1,(black))
                window.blit(box_info,(590, 12))
            else:
                box_info = font3.render(str(AvailablePottery), 1,(red))
                window.blit(box_info,(585, 12))
            
            window.blit(sideHOUSING,(650, -2))
            if secPop[Clicked] > secHousing[Clicked]:
                box_info = font3.render(str(secPop[Clicked]) + "/" + str(secHousing[Clicked]), 1,(red))
            else:
                box_info = font3.render(str(secPop[Clicked]) + "/" + str(secHousing[Clicked]), 1,(black))
            window.blit(box_info,(682, 12))
            
            window.blit(sideWORKERS,(760, -2))
            if IdleWorkers > 0:
                box_info = font3.render(str(IdleWorkers), 1,(red))
                window.blit(box_info,(793, 12))
            else:
                box_info = font3.render(str(IdleWorkers), 1,(black))
                window.blit(box_info,(793, 12))

            
# --- ZOOMED SECTOR INFORMATION --- DRAWS SECTOR BOX and other boxes       
            window.blit(boxSECTORS, (SecLocaX+15, SecLocaY-55)) # <-- This draws the Zoomed Sector Box
            window.blit(boxLONGthin,(SecLocaX+120, SecLocaY-70))

# --- ZOOMED SECTOR INFORMATION --- Sector Information on the TOP of the Zoom Sector Box
            if secTerra[Clicked] == 1 and secWater[Clicked] < 40:
                window.blit(msg_terra1,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))

            elif secTerra[Clicked] == 1 and secWater[Clicked] > 39:
                window.blit(msg_terra10,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 2 and secWater[Clicked] < 56:
                window.blit(msg_terra2,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 2 and secWater[Clicked] > 55:
                window.blit(msg_terra20,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 3 and secWater[Clicked] < 21:
                window.blit(msg_terra3,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 3 and secWater[Clicked] > 20:
                window.blit(msg_terra30,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 4 and secWater[Clicked] < 35:
                window.blit(msg_terra4,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 4 and secWater[Clicked] > 34:
                window.blit(msg_terra40,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 5:
                window.blit(msg_terra5,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 6 and secWater[Clicked] < 40:
                window.blit(msg_terra6,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
        
            elif secTerra[Clicked] == 6 and secWater[Clicked] > 39:
                window.blit(msg_terra60,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))
                
            elif secTerra[Clicked] == 7:
                window.blit(msg_terra7,(SecLocaX+150, SecLocaY-55))
                window.blit(SectorNumber,(SecLocaX+415, SecLocaY-55))

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Scrollbar Window for Building Buildings -- Y axis for Scrollbar is from 18 to 455         
            if (BuildBox == True) and (ZoomBuild[ZoomSector] == -1 and ZoomConstruct[ZoomSector] < 1):             
                ResToggle1 = False
                ResToggle2 = False
                window.blit(boxSCROLL,(resLocaX, resLocaY))
                window.blit(scroller,(ScrollX, ScrollY))
                
                if ZoomTerra[ZoomSector] == 5 and secTerra[Clicked] != 6:
                    window.blit(scrollRICE,(resLocaX+15, resLocaY+20))
                    ScrollSelect = [1, 0, 0, 0]                    
                    text_cost = font6.render(str(GrainCost[1]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+50))
                    if GrainCost[1] > ownGrain[Clicked]:
                        need_resource = (GrainCost[1] - ownGrain[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+165, resLocaY+65))

                elif ScrollY-resLocaY < 20 and secTerra[Clicked] == 3:
                    window.blit(scrollHUT,(resLocaX+10, resLocaY+15))
                    window.blit(scrollTIPIblu,(resLocaX+10, resLocaY+145))
                    window.blit(scrollADOBE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [2, 3, 4, 7]
                elif ScrollY-resLocaY < 60 and secTerra[Clicked] == 3:
                    window.blit(scrollTIPIblu,(resLocaX+10, resLocaY+15))
                    window.blit(scrollADOBE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollVILLAGE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [3, 4, 7, 8]
                elif ScrollY-resLocaY < 100 and secTerra[Clicked] == 3:
                    window.blit(scrollADOBE,(resLocaX+10, resLocaY+15))
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollVILLAGE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollMEDICINE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [4, 7, 8, 10]
                elif ScrollY-resLocaY < 20 and secTerra[Clicked] != 3:
                    window.blit(scrollHUT,(resLocaX+10, resLocaY+15))
                    window.blit(scrollTIPIblu,(resLocaX+10, resLocaY+145))
                    window.blit(scrollLONG,(resLocaX+10, resLocaY+280))
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [2, 3, 6, 7]
                elif ScrollY-resLocaY < 60 and secTerra[Clicked] != 3:
                    window.blit(scrollTIPIblu,(resLocaX+10, resLocaY+15))
                    window.blit(scrollLONG,(resLocaX+10, resLocaY+145))
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollVILLAGE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [3, 6, 7, 8]
                elif ScrollY-resLocaY < 100 and secTerra[Clicked] != 3:
                    window.blit(scrollLONG,(resLocaX+10, resLocaY+15))
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollVILLAGE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollMEDICINE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [6, 7, 8, 10]
                elif ScrollY-resLocaY < 140:
                    window.blit(scrollHOUSE,(resLocaX+10, resLocaY+15))
                    window.blit(scrollVILLAGE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollMEDICINE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollFARM,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [7, 8, 10, 11]
                elif ScrollY-resLocaY < 180:
                    window.blit(scrollVILLAGE,(resLocaX+10, resLocaY+15))
                    window.blit(scrollMEDICINE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollFARM,(resLocaX+10, resLocaY+280))
                    window.blit(scrollHUNT,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [8, 10, 11, 12]
                elif ScrollY-resLocaY < 220:
                    window.blit(scrollMEDICINE,(resLocaX+10, resLocaY+15))
                    window.blit(scrollFARM,(resLocaX+10, resLocaY+145))
                    window.blit(scrollHUNT,(resLocaX+10, resLocaY+280))
                    window.blit(scrollFURNACE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [10, 11, 12, 13]
                elif ScrollY-resLocaY < 260:
                    window.blit(scrollFARM,(resLocaX+10, resLocaY+15))
                    window.blit(scrollHUNT,(resLocaX+10, resLocaY+145))
                    window.blit(scrollFURNACE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollPOTT,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [11, 12, 13, 14]
                elif ScrollY-resLocaY < 300:
                    window.blit(scrollHUNT,(resLocaX+10, resLocaY+15))
                    window.blit(scrollFURNACE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollPOTT,(resLocaX+10, resLocaY+280))
                    window.blit(scrollSTORE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [12, 13, 14, 15]
                elif ScrollY-resLocaY < 340:
                    window.blit(scrollFURNACE,(resLocaX+10, resLocaY+15))
                    window.blit(scrollPOTT,(resLocaX+10, resLocaY+145))
                    window.blit(scrollSTORE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollWALL1,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [13, 14, 15, 16]
                elif ScrollY-resLocaY < 380:
                    window.blit(scrollPOTT,(resLocaX+10, resLocaY+15))
                    window.blit(scrollSTORE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollWALL1,(resLocaX+10, resLocaY+280))
                    window.blit(scrollTOWER1,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [14, 15, 16, 19]
                elif ScrollY-resLocaY < 420:
                    window.blit(scrollSTORE,(resLocaX+10, resLocaY+15))
                    window.blit(scrollWALL1,(resLocaX+10, resLocaY+145))
                    window.blit(scrollTOWER1,(resLocaX+10, resLocaY+280))
                    window.blit(scrollLODGE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [15, 16, 19, 21]
                elif ScrollY-resLocaY < 450:
                    window.blit(scrollWALL1,(resLocaX+10, resLocaY+15))
                    window.blit(scrollTOWER1,(resLocaX+10, resLocaY+145))
                    window.blit(scrollLODGE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollTEMPLE,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [16, 19, 21, 22]
                elif ScrollY-resLocaY > 449:
                    window.blit(scrollTOWER1,(resLocaX+10, resLocaY+15))
                    window.blit(scrollLODGE,(resLocaX+10, resLocaY+145))
                    window.blit(scrollTEMPLE,(resLocaX+10, resLocaY+280))
                    window.blit(scrollPYRAMID,(resLocaX+10, resLocaY+410))
                    ScrollSelect = [19, 21, 22, 23]
                    
# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Draws Resource Cost Numbers
                if ZoomTerra[ZoomSector] != 5 and (ScrollY-resLocaY < 20):           
                    text_cost = font6.render(str(MeatCost[2]), 1,(black)) # <--- ScrollY < 20 and Wigwam
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(ClayCost[2]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))
                    text_cost = font6.render(str(WoodCost[2]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+103))
                    if MeatCost[2] > ownMeat[Clicked]: 
                        need_resource = (MeatCost[2] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+58))
                    if ClayCost[2] > ownClay[Clicked]:
                        need_resource = (ClayCost[2] - ownClay[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+89))
                    if WoodCost[2] > ownWood[Clicked]:
                        need_resource = (WoodCost[2] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+116))
                        
                    text_cost = font6.render(str(MeatCost[3]), 1,(black)) # <--- ScrollY < 20 and Tipi
                    window.blit(text_cost,(resLocaX+178, resLocaY+171))
                    text_cost = font6.render(str(WoodCost[3]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+203))                            
                    if MeatCost[3] > ownMeat[Clicked]: 
                        need_resource = (MeatCost[3] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+188))
                    if WoodCost[3] > ownWood[Clicked]:
                        need_resource = (WoodCost[3] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+216))
           
                    if ZoomTerra[ZoomSector] == 3:                      # <--- ScrollY < 20 and #4 Adobe
                        text_cost = font6.render(str(AdobeCost[4]), 1,(black))
                        window.blit(text_cost,(resLocaX+180, resLocaY+305))
                        text_cost = font6.render(str(WoodCost[4]), 1,(black))
                        window.blit(text_cost,(resLocaX+183, resLocaY+342))                            
                        if AdobeCost[4] > ownAdobe[Clicked]:
                            need_resource = (AdobeCost[4] - ownAdobe[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+165, resLocaY+323))
                        if WoodCost[4] > ownWood[Clicked]:
                            need_resource = (WoodCost[4] - ownWood[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+165, resLocaY+360))
                    elif ZoomTerra[ZoomSector] != 3:                # <--- ScrollY < 20 and #6 Longhouse
                        text_cost = font6.render(str(MeatCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+307))
                        text_cost = font6.render(str(StoneCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+340))                            
                        text_cost = font6.render(str(WoodCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+370))
                        if MeatCost[6] > ownMeat[Clicked]:
                            need_resource = (MeatCost[6] - ownMeat[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+323))
                        if StoneCost[6] > ownStone[Clicked]:
                            need_resource = (StoneCost[6] - ownStone[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+354))    
                        if WoodCost[6] > ownWood[Clicked]:
                            need_resource = (WoodCost[6] - ownWood[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+382))

                    text_cost = font6.render(str(AdobeCost[7]), 1,(black)) # <--- ScrollY < 20 and #7 House
                    window.blit(text_cost,(resLocaX+175, resLocaY+435))
                    text_cost = font6.render(str(GoldCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+468))                            
                    text_cost = font6.render(str(StoneCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+499))
                    text_cost = font6.render(str(WoodCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+435))
                    if AdobeCost[7] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[7] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+450))
                    if GoldCost[7] > ownGold[Clicked]:
                        need_resource = (GoldCost[7] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+481))  
                    if StoneCost[7] > ownStone[Clicked]:
                        need_resource = (StoneCost[7] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+513))    
                    if WoodCost[7] > ownWood[Clicked]:
                        need_resource = (WoodCost[7] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+225, resLocaY+450))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 60):
                    text_cost = font6.render(str(MeatCost[3]), 1,(black)) # <--- ScrollY < 60 and Tipi
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(WoodCost[3]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))                            
                    if MeatCost[3] > ownMeat[Clicked]: 
                        need_resource = (MeatCost[3] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+58))
                    if WoodCost[3] > ownWood[Clicked]:
                        need_resource = (WoodCost[3] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+160, resLocaY+89))

                    if ZoomTerra[ZoomSector] == 3:                   # <--- ScrollY < 60 and #4 Adobe
                        text_cost = font6.render(str(AdobeCost[4]), 1,(black))
                        window.blit(text_cost,(resLocaX+180, resLocaY+171))
                        text_cost = font6.render(str(WoodCost[4]), 1,(black))
                        window.blit(text_cost,(resLocaX+183, resLocaY+203))                            
                        if AdobeCost[4] > ownAdobe[Clicked]:
                            need_resource = (AdobeCost[4] - ownAdobe[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+165, resLocaY+188))
                        if WoodCost[4] > ownWood[Clicked]:
                            need_resource = (WoodCost[4] - ownWood[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+165, resLocaY+219))
                    elif ZoomTerra[ZoomSector] != 3:            # <--- ScrollY < 60 and #6 Longhouse
                        text_cost = font6.render(str(MeatCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+171))
                        text_cost = font6.render(str(StoneCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+203))                            
                        text_cost = font6.render(str(WoodCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+233))
                        if MeatCost[6] > ownMeat[Clicked]:
                            need_resource = (MeatCost[6] - ownMeat[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+188))
                        if StoneCost[6] > ownStone[Clicked]:
                            need_resource = (StoneCost[6] - ownStone[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+216))    
                        if WoodCost[6] > ownWood[Clicked]:
                            need_resource = (WoodCost[6] - ownWood[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+245))

                    text_cost = font6.render(str(AdobeCost[7]), 1,(black)) # <--- ScrollY < 60 and #7 House
                    window.blit(text_cost,(resLocaX+175, resLocaY+307))
                    text_cost = font6.render(str(GoldCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+337))                            
                    text_cost = font6.render(str(StoneCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+367))
                    text_cost = font6.render(str(WoodCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+305))
                    if AdobeCost[7] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[7] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+320))
                    if GoldCost[7] > ownGold[Clicked]:
                        need_resource = (GoldCost[7] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+350))  
                    if StoneCost[7] > ownStone[Clicked]:
                        need_resource = (StoneCost[7] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+380))    
                    if WoodCost[7] > ownWood[Clicked]:
                        need_resource = (WoodCost[7] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+320))

                    text_cost = font6.render(str(MeatCost[8]), 1,(black)) # <--- ScrollY < 60 and #8 Meeting Tent
                    window.blit(text_cost,(resLocaX+175, resLocaY+435))
                    text_cost = font6.render(str(PotteryCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+468))                            
                    text_cost = font6.render(str(StoneCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+499))
                    text_cost = font6.render(str(WoodCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+435))
                    if MeatCost[8] > ownMeat[Clicked]:
                        need_resource = (MeatCost[8] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+450))
                    if PotteryCost[8] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[8] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+481))  
                    if StoneCost[8] > ownStone[Clicked]:
                        need_resource = (StoneCost[8] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+513))    
                    if WoodCost[8] > ownWood[Clicked]:
                        need_resource = (WoodCost[8] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+450))
                        
                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 100):
                    if ZoomTerra[ZoomSector] == 3:                   # <--- ScrollY < 100 and #4 Adobe
                        text_cost = font6.render(str(AdobeCost[4]), 1,(black))
                        window.blit(text_cost,(resLocaX+180, resLocaY+42))
                        text_cost = font6.render(str(WoodCost[4]), 1,(black))
                        window.blit(text_cost,(resLocaX+183, resLocaY+75))                            
                        if AdobeCost[4] > ownAdobe[Clicked]:
                            need_resource = (AdobeCost[4] - ownAdobe[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+165, resLocaY+58))
                        if WoodCost[4] > ownWood[Clicked]:
                            need_resource = (WoodCost[4] - ownWood[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+165, resLocaY+89))
                    elif ZoomTerra[ZoomSector] != 3:                 # <--- ScrollY < 100 and #6 Longhouse
                        text_cost = font6.render(str(MeatCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+42))
                        text_cost = font6.render(str(StoneCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+75))                            
                        text_cost = font6.render(str(WoodCost[6]), 1,(black))
                        window.blit(text_cost,(resLocaX+177, resLocaY+104))
                        if MeatCost[6] > ownMeat[Clicked]:
                            need_resource = (MeatCost[6] - ownMeat[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+58))
                        if StoneCost[6] > ownStone[Clicked]:
                            need_resource = (StoneCost[6] - ownStone[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+89))    
                        if WoodCost[6] > ownWood[Clicked]:
                            need_resource = (WoodCost[6] - ownWood[Clicked])
                            text_cost = font11.render("need " + str(need_resource), 1,(red))
                            window.blit(text_cost,(resLocaX+158, resLocaY+117))
                            
                    text_cost = font6.render(str(AdobeCost[7]), 1,(black)) # <--- ScrollY < 100 and #7 House
                    window.blit(text_cost,(resLocaX+175, resLocaY+171))
                    text_cost = font6.render(str(GoldCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+203))                            
                    text_cost = font6.render(str(StoneCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+235))
                    text_cost = font6.render(str(WoodCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+171))
                    if AdobeCost[7] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[7] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+188))
                    if GoldCost[7] > ownGold[Clicked]:
                        need_resource = (GoldCost[7] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+219))  
                    if StoneCost[7] > ownStone[Clicked]:
                        need_resource = (StoneCost[7] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+250))    
                    if WoodCost[7] > ownWood[Clicked]:
                        need_resource = (WoodCost[7] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+188))
                        
                    text_cost = font6.render(str(MeatCost[8]), 1,(black)) # <--- ScrollY < 100 and #8 Meeting Tent
                    window.blit(text_cost,(resLocaX+175, resLocaY+307))
                    text_cost = font6.render(str(PotteryCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+337))                            
                    text_cost = font6.render(str(StoneCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+367))
                    text_cost = font6.render(str(WoodCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+305))
                    if MeatCost[8] > ownMeat[Clicked]:
                        need_resource = (MeatCost[8] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+320))
                    if PotteryCost[8] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[8] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+350))  
                    if StoneCost[8] > ownStone[Clicked]:
                        need_resource = (StoneCost[8] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+380))    
                    if WoodCost[8] > ownWood[Clicked]:
                        need_resource = (WoodCost[8] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+320))
                        
                    text_cost = font6.render(str(MeatCost[10]), 1,(black)) # <--- ScrollY < 100 and #10 Shamanic Tipi
                    window.blit(text_cost,(resLocaX+175, resLocaY+435))
                    text_cost = font6.render(str(HerbCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+468))                            
                    text_cost = font6.render(str(PotteryCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+497))
                    text_cost = font6.render(str(CrystalCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+438))
                    text_cost = font6.render(str(WoodCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+471))
                    if MeatCost[10] > ownMeat[Clicked]:
                        need_resource = (MeatCost[10] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+450))
                    if HerbCost[10] > ownHerb[Clicked]:
                        need_resource = (HerbCost[10] - ownHerb[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+481))    
                    if PotteryCost[10] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[10] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+510))  
                    if CrystalCost[10] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[10] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+452))    
                    if WoodCost[10] > ownWood[Clicked]:
                        need_resource = (WoodCost[10] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+484))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 140):                        
                    text_cost = font6.render(str(AdobeCost[7]), 1,(black)) # <--- ScrollY < 140 and #7 House
                    window.blit(text_cost,(resLocaX+175, resLocaY+42))
                    text_cost = font6.render(str(GoldCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+75))                            
                    text_cost = font6.render(str(StoneCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+103))
                    text_cost = font6.render(str(WoodCost[7]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+42))
                    if AdobeCost[7] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[7] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+58))
                    if GoldCost[7] > ownGold[Clicked]:
                        need_resource = (GoldCost[7] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+89))  
                    if StoneCost[7] > ownStone[Clicked]:
                        need_resource = (StoneCost[7] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+116))    
                    if WoodCost[7] > ownWood[Clicked]:
                        need_resource = (WoodCost[7] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+58))

                    text_cost = font6.render(str(MeatCost[8]), 1,(black)) # <--- ScrollY < 140 and #8 Meeting Tent
                    window.blit(text_cost,(resLocaX+175, resLocaY+171))
                    text_cost = font6.render(str(PotteryCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+203))                            
                    text_cost = font6.render(str(StoneCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+235))
                    text_cost = font6.render(str(WoodCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+171))
                    if MeatCost[8] > ownMeat[Clicked]:
                        need_resource = (MeatCost[8] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+188))
                    if PotteryCost[8] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[8] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+219))  
                    if StoneCost[8] > ownStone[Clicked]:
                        need_resource = (StoneCost[8] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+250))    
                    if WoodCost[8] > ownWood[Clicked]:
                        need_resource = (WoodCost[8] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+188))
                        
                    text_cost = font6.render(str(MeatCost[10]), 1,(black)) # <--- ScrollY < 140 and #10 Shamanic Tipi
                    window.blit(text_cost,(resLocaX+175, resLocaY+307))
                    text_cost = font6.render(str(HerbCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+337))                            
                    text_cost = font6.render(str(PotteryCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+367))
                    text_cost = font6.render(str(CrystalCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+310))
                    text_cost = font6.render(str(WoodCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+337))
                    if MeatCost[10] > ownMeat[Clicked]:
                        need_resource = (MeatCost[10] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+320))
                    if HerbCost[10] > ownHerb[Clicked]:
                        need_resource = (HerbCost[10] - ownHerb[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+350))    
                    if PotteryCost[10] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[10] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+380))  
                    if CrystalCost[10] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[10] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+323))    
                    if WoodCost[10] > ownWood[Clicked]:
                        need_resource = (WoodCost[10] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+350))
                        
                    text_cost = font6.render(str(GrainCost[11]), 1,(black)) # <--- ScrollY < 140 and #11 Farm
                    window.blit(text_cost,(resLocaX+175, resLocaY+438))
                    text_cost = font6.render(str(WoodCost[11]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+471))  
                    if GrainCost[11] > ownGrain[Clicked]:
                        need_resource = (GrainCost[11] - ownGrain[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+453))
                    if WoodCost[11] > ownWood[Clicked]:
                        need_resource = (WoodCost[11] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+484))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 180):                          
                    text_cost = font6.render(str(MeatCost[8]), 1,(black)) # <--- ScrollY < 180 and #8 Meeting Tent
                    window.blit(text_cost,(resLocaX+175, resLocaY+42))
                    text_cost = font6.render(str(PotteryCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+75))                            
                    text_cost = font6.render(str(StoneCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+103))
                    text_cost = font6.render(str(WoodCost[8]), 1,(black))
                    window.blit(text_cost,(resLocaX+242, resLocaY+42))
                    if MeatCost[8] > ownMeat[Clicked]:
                        need_resource = (MeatCost[8] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+58))
                    if PotteryCost[8] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[8] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+89))  
                    if StoneCost[8] > ownStone[Clicked]:
                        need_resource = (StoneCost[8] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+116))    
                    if WoodCost[8] > ownWood[Clicked]:
                        need_resource = (WoodCost[8] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+58))
                        
                    text_cost = font6.render(str(MeatCost[10]), 1,(black)) # <--- ScrollY < 180 and #10 Shamanic Tipi
                    window.blit(text_cost,(resLocaX+175, resLocaY+171))
                    text_cost = font6.render(str(HerbCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+203))                            
                    text_cost = font6.render(str(PotteryCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+235))
                    text_cost = font6.render(str(CrystalCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+171))
                    text_cost = font6.render(str(WoodCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+203))
                    if MeatCost[10] > ownMeat[Clicked]:
                        need_resource = (MeatCost[10] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+188))
                    if HerbCost[10] > ownHerb[Clicked]:
                        need_resource = (HerbCost[10] - ownHerb[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+219))    
                    if PotteryCost[10] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[10] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+250))  
                    if CrystalCost[10] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[10] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+188))    
                    if WoodCost[10] > ownWood[Clicked]:
                        need_resource = (WoodCost[10] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+219))

                    text_cost = font6.render(str(GrainCost[11]), 1,(black)) # <--- ScrollY < 140 and #11 Farm
                    window.blit(text_cost,(resLocaX+175, resLocaY+310))
                    text_cost = font6.render(str(WoodCost[11]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+342))  
                    if GrainCost[11] > ownGrain[Clicked]:
                        need_resource = (GrainCost[11] - ownGrain[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+323))
                    if WoodCost[11] > ownWood[Clicked]:
                        need_resource = (WoodCost[11] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+355))

                    text_cost = font6.render(str(ForageCost[12]), 1,(black)) # <--- ScrollY < 140 and #12 Hunter's Tipi
                    window.blit(text_cost,(resLocaX+183, resLocaY+438))
                    text_cost = font6.render(str(StoneCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+468))  
                    text_cost = font6.render(str(WoodCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+497))
                    if ForageCost[12] > ownForage[Clicked]:
                        need_resource = (ForageCost[12] - ownForage[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+453))
                    if StoneCost[12] > ownStone[Clicked]:
                        need_resource = (StoneCost[12] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+482))
                    if WoodCost[12] > ownWood[Clicked]:
                        need_resource = (WoodCost[12] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+510))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 220):
                    text_cost = font6.render(str(MeatCost[10]), 1,(black)) # <--- ScrollY < 220 and #10 Shamanic Tipi
                    window.blit(text_cost,(resLocaX+175, resLocaY+42))
                    text_cost = font6.render(str(HerbCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+75))                            
                    text_cost = font6.render(str(PotteryCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+103))
                    text_cost = font6.render(str(CrystalCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+42))
                    text_cost = font6.render(str(WoodCost[10]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+75))
                    if MeatCost[10] > ownMeat[Clicked]:
                        need_resource = (MeatCost[10] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+58))
                    if HerbCost[10] > ownHerb[Clicked]:
                        need_resource = (HerbCost[10] - ownHerb[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+89))    
                    if PotteryCost[10] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[10] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+116))  
                    if CrystalCost[10] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[10] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+58))    
                    if WoodCost[10] > ownWood[Clicked]:
                        need_resource = (WoodCost[10] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+89))
                        
                    text_cost = font6.render(str(GrainCost[11]), 1,(black)) # <--- ScrollY < 220 and #11 Farm
                    window.blit(text_cost,(resLocaX+175, resLocaY+171))
                    text_cost = font6.render(str(WoodCost[11]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+203))  
                    if GrainCost[11] > ownGrain[Clicked]:
                        need_resource = (GrainCost[11] - ownGrain[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+188))
                    if WoodCost[11] > ownWood[Clicked]:
                        need_resource = (WoodCost[11] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+219))
                        
                    text_cost = font6.render(str(ForageCost[12]), 1,(black)) # <--- ScrollY < 220 and #12 Hunter's Tipi
                    window.blit(text_cost,(resLocaX+183, resLocaY+307))
                    text_cost = font6.render(str(StoneCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+337))  
                    text_cost = font6.render(str(WoodCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+367))
                    if ForageCost[12] > ownForage[Clicked]:
                        need_resource = (ForageCost[12] - ownForage[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+320))
                    if StoneCost[12] > ownStone[Clicked]:
                        need_resource = (StoneCost[12] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+350))
                    if WoodCost[12] > ownWood[Clicked]:
                        need_resource = (WoodCost[12] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+380))

                    text_cost = font6.render(str(AdobeCost[13]), 1,(black)) # <--- ScrollY < 220 and #13 Furnace
                    window.blit(text_cost,(resLocaX+178, resLocaY+436))
                    text_cost = font6.render(str(StoneCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+465))  
                    text_cost = font6.render(str(WoodCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+495))
                    if AdobeCost[13] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[13] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+450))
                    if StoneCost[13] > ownStone[Clicked]:
                        need_resource = (StoneCost[13] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+478))
                    if WoodCost[13] > ownWood[Clicked]:
                        need_resource = (WoodCost[13] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+507))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 260):
                    text_cost = font6.render(str(GrainCost[11]), 1,(black)) # <--- ScrollY < 260 and #11 Farm
                    window.blit(text_cost,(resLocaX+175, resLocaY+42))
                    text_cost = font6.render(str(WoodCost[11]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+75))  
                    if GrainCost[11] > ownGrain[Clicked]:
                        need_resource = (GrainCost[11] - ownGrain[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+58))
                    if WoodCost[11] > ownWood[Clicked]:
                        need_resource = (WoodCost[11] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+89))
                        
                    text_cost = font6.render(str(ForageCost[12]), 1,(black)) # <--- ScrollY < 260 and #12 Hunter's Tipi
                    window.blit(text_cost,(resLocaX+183, resLocaY+171))
                    text_cost = font6.render(str(StoneCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+203))  
                    text_cost = font6.render(str(WoodCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+235))
                    if ForageCost[12] > ownForage[Clicked]:
                        need_resource = (ForageCost[12] - ownForage[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+188))
                    if StoneCost[12] > ownStone[Clicked]:
                        need_resource = (StoneCost[12] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+219))
                    if WoodCost[12] > ownWood[Clicked]:
                        need_resource = (WoodCost[12] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+250))
                    
                    text_cost = font6.render(str(AdobeCost[13]), 1,(black)) # <--- ScrollY < 260 and #13 Furnace
                    window.blit(text_cost,(resLocaX+178, resLocaY+307))
                    text_cost = font6.render(str(StoneCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+337))  
                    text_cost = font6.render(str(WoodCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+367))
                    if AdobeCost[13] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[13] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+320))
                    if StoneCost[13] > ownStone[Clicked]:
                        need_resource = (StoneCost[13] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+350))
                    if WoodCost[13] > ownWood[Clicked]:
                        need_resource = (WoodCost[13] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+380))

                    text_cost = font6.render(str(StoneCost[14]), 1,(black)) # <--- ScrollY < 260 and #14 Pottery Kiln
                    window.blit(text_cost,(resLocaX+178, resLocaY+438))
                    text_cost = font6.render(str(WoodCost[14]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+470))
                    if StoneCost[14] > ownStone[Clicked]:
                        need_resource = (StoneCost[14] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+452))
                    if WoodCost[14] > ownWood[Clicked]:
                        need_resource = (WoodCost[14] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+485))
                        
                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 300):
                    text_cost = font6.render(str(ForageCost[12]), 1,(black)) # <--- ScrollY < 300 and #12 Hunter's Tipi
                    window.blit(text_cost,(resLocaX+183, resLocaY+42))
                    text_cost = font6.render(str(StoneCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+75))  
                    text_cost = font6.render(str(WoodCost[12]), 1,(black))
                    window.blit(text_cost,(resLocaX+183, resLocaY+103))
                    if ForageCost[12] > ownForage[Clicked]:
                        need_resource = (ForageCost[12] - ownForage[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+58))
                    if StoneCost[12] > ownStone[Clicked]:
                        need_resource = (StoneCost[12] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+89))
                    if WoodCost[12] > ownWood[Clicked]:
                        need_resource = (WoodCost[12] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+116))
                        
                    text_cost = font6.render(str(AdobeCost[13]), 1,(black)) # <--- ScrollY < 300 and #13 Furnace
                    window.blit(text_cost,(resLocaX+178, resLocaY+171))
                    text_cost = font6.render(str(StoneCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+203))  
                    text_cost = font6.render(str(WoodCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+235))
                    if AdobeCost[13] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[13] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+188))
                    if StoneCost[13] > ownStone[Clicked]:
                        need_resource = (StoneCost[13] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+219))
                    if WoodCost[13] > ownWood[Clicked]:
                        need_resource = (WoodCost[13] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+248))
                        
                    text_cost = font6.render(str(StoneCost[14]), 1,(black)) # <--- ScrollY < 300 and #14 Pottery Kiln
                    window.blit(text_cost,(resLocaX+178, resLocaY+310))
                    text_cost = font6.render(str(WoodCost[14]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+340))
                    if StoneCost[14] > ownStone[Clicked]:
                        need_resource = (StoneCost[14] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+325))
                    if WoodCost[14] > ownWood[Clicked]:
                        need_resource = (WoodCost[14] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+355))
                        
                    text_cost = font6.render(str(PotteryCost[15]), 1,(black)) # <--- ScrollY < 300 and #15 Storage
                    window.blit(text_cost,(resLocaX+178, resLocaY+438))
                    text_cost = font6.render(str(StoneCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+470))  
                    text_cost = font6.render(str(WoodCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+500))
                    if PotteryCost[15] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[15] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+453))
                    if StoneCost[15] > ownStone[Clicked]:
                        need_resource = (StoneCost[15] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+484))
                    if WoodCost[15] > ownWood[Clicked]:
                        need_resource = (WoodCost[15] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+513))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 340):                        
                    text_cost = font6.render(str(AdobeCost[13]), 1,(black)) # <--- ScrollY < 340 and #13 Furnace
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(StoneCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))  
                    text_cost = font6.render(str(WoodCost[13]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+103))
                    if AdobeCost[13] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[13] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+58))
                    if StoneCost[13] > ownStone[Clicked]:
                        need_resource = (StoneCost[13] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+89))
                    if WoodCost[13] > ownWood[Clicked]:
                        need_resource = (WoodCost[13] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+116))
                        
                    text_cost = font6.render(str(StoneCost[14]), 1,(black)) # <--- ScrollY < 340 and #14 Pottery Kiln
                    window.blit(text_cost,(resLocaX+178, resLocaY+171))
                    text_cost = font6.render(str(WoodCost[14]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+203))
                    if StoneCost[14] > ownStone[Clicked]:
                        need_resource = (StoneCost[14] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+188))
                    if WoodCost[14] > ownWood[Clicked]:
                        need_resource = (WoodCost[14] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+219))
                        
                    text_cost = font6.render(str(PotteryCost[15]), 1,(black)) # <--- ScrollY < 340 and #15 Storage
                    window.blit(text_cost,(resLocaX+178, resLocaY+307))
                    text_cost = font6.render(str(StoneCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+337))  
                    text_cost = font6.render(str(WoodCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+367))
                    if PotteryCost[15] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[15] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+321))
                    if StoneCost[15] > ownStone[Clicked]:
                        need_resource = (StoneCost[15] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+351))
                    if WoodCost[15] > ownWood[Clicked]:
                        need_resource = (WoodCost[15] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+381))
                        
                    text_cost = font6.render(str(ClayCost[16]), 1,(black)) # <--- ScrollY < 340 and #16 Wooden Wall
                    window.blit(text_cost,(resLocaX+178, resLocaY+438))
                    text_cost = font6.render(str(WoodCost[16]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+470))
                    if ClayCost[16] > ownClay[Clicked]:
                        need_resource = (ClayCost[16] - ownClay[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+453))
                    if WoodCost[16] > ownWood[Clicked]:
                        need_resource = (WoodCost[16] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+484))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 380):                           
                    text_cost = font6.render(str(StoneCost[14]), 1,(black)) # <--- ScrollY < 380 and #14 Pottery Kiln
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(WoodCost[14]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))
                    if StoneCost[14] > ownStone[Clicked]:
                        need_resource = (StoneCost[14] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+58))
                    if WoodCost[14] > ownWood[Clicked]:
                        need_resource = (WoodCost[14] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+89))
                        
                    text_cost = font6.render(str(PotteryCost[15]), 1,(black)) # <--- ScrollY < 380 and #15 Storage
                    window.blit(text_cost,(resLocaX+178, resLocaY+171))
                    text_cost = font6.render(str(StoneCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+203))  
                    text_cost = font6.render(str(WoodCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+235))
                    if PotteryCost[15] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[15] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+188))
                    if StoneCost[15] > ownStone[Clicked]:
                        need_resource = (StoneCost[15] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+219))
                    if WoodCost[15] > ownWood[Clicked]:
                        need_resource = (WoodCost[15] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+250))
                        
                    text_cost = font6.render(str(ClayCost[16]), 1,(black)) # <--- ScrollY < 380 and #16 Wooden Wall
                    window.blit(text_cost,(resLocaX+178, resLocaY+307))
                    text_cost = font6.render(str(WoodCost[16]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+337))
                    if ClayCost[16] > ownClay[Clicked]:
                        need_resource = (ClayCost[16] - ownClay[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+323))
                    if WoodCost[16] > ownWood[Clicked]:
                        need_resource = (WoodCost[16] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+354))

                    text_cost = font6.render(str(MeatCost[19]), 1,(black)) # <--- ScrollY < 380 and #19 Wooden Tower
                    window.blit(text_cost,(resLocaX+178, resLocaY+438))
                    text_cost = font6.render(str(WoodCost[19]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+470))
                    if MeatCost[19] > ownMeat[Clicked]:
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+453))
                    if WoodCost[19] > ownWood[Clicked]:
                        need_resource = (WoodCost[19] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+484))
                        
                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 420):
                    text_cost = font6.render(str(PotteryCost[15]), 1,(black)) # <--- ScrollY < 420 and #15 Storage
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(StoneCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))  
                    text_cost = font6.render(str(WoodCost[15]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+105))
                    if PotteryCost[15] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[15] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+58))
                    if StoneCost[15] > ownStone[Clicked]:
                        need_resource = (StoneCost[15] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+89))
                    if WoodCost[15] > ownWood[Clicked]:
                        need_resource = (WoodCost[15] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+118))
                        
                    text_cost = font6.render(str(ClayCost[16]), 1,(black)) # <--- ScrollY < 420 and #16 Wooden Wall
                    window.blit(text_cost,(resLocaX+178, resLocaY+171))
                    text_cost = font6.render(str(WoodCost[16]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+205))
                    if ClayCost[16] > ownClay[Clicked]:
                        need_resource = (ClayCost[16] - ownClay[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+188))
                    if WoodCost[16] > ownWood[Clicked]:
                        need_resource = (WoodCost[16] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+221))
                        
                    text_cost = font6.render(str(MeatCost[19]), 1,(black)) # <--- ScrollY < 420 and #19 Wooden Tower
                    window.blit(text_cost,(resLocaX+178, resLocaY+307))
                    text_cost = font6.render(str(WoodCost[19]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+339))
                    if MeatCost[19] > ownMeat[Clicked]:
                        need_resource = (MeatCost[19] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+323))
                    if WoodCost[19] > ownWood[Clicked]:
                        need_resource = (WoodCost[19] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+356))
                        
                    text_cost = font6.render(str(MeatCost[21]), 1,(black)) # <--- ScrollY < 420 and #21 War Lodge
                    window.blit(text_cost,(resLocaX+180, resLocaY+438))
                    text_cost = font6.render(str(CopperCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+470)) 
                    text_cost = font6.render(str(StoneCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+497))  
                    text_cost = font6.render(str(WoodCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+245, resLocaY+438))
                    if MeatCost[21] > ownMeat[Clicked]:
                        need_resource = (MeatCost[21] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+453))
                    if CopperCost[21] > ownCopper[Clicked]:
                        need_resource = (CopperCost[21] - ownCopper[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+484))
                    if StoneCost[21] > ownStone[Clicked]:
                        need_resource = (StoneCost[21] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+514))
                    if WoodCost[21] > ownWood[Clicked]:
                        need_resource = (WoodCost[21] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+453))
                        
                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY < 450):
                    text_cost = font6.render(str(ClayCost[16]), 1,(black)) # <--- ScrollY < 450 and #16 Wooden Wall
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(WoodCost[16]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))
                    if ClayCost[16] > ownClay[Clicked]:
                        need_resource = (ClayCost[16] - ownClay[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+58))
                    if WoodCost[16] > ownWood[Clicked]:
                        need_resource = (WoodCost[16] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+89))
                        
                    text_cost = font6.render(str(MeatCost[19]), 1,(black)) # <--- ScrollY < 450 and #19 Wooden Tower
                    window.blit(text_cost,(resLocaX+178, resLocaY+171))
                    text_cost = font6.render(str(WoodCost[19]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+203))
                    if MeatCost[19] > ownMeat[Clicked]:
                        need_resource = (MeatCost[19] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+188))
                    if WoodCost[19] > ownWood[Clicked]:
                        need_resource = (WoodCost[19] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+219))
                        
                    text_cost = font6.render(str(MeatCost[21]), 1,(black)) # <--- ScrollY < 450 and #21 War Lodge
                    window.blit(text_cost,(resLocaX+180, resLocaY+307))
                    text_cost = font6.render(str(CopperCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+337)) 
                    text_cost = font6.render(str(StoneCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+367))  
                    text_cost = font6.render(str(WoodCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+245, resLocaY+307))
                    if MeatCost[21] > ownMeat[Clicked]:
                        need_resource = (MeatCost[21] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+323))
                    if CopperCost[21] > ownCopper[Clicked]:
                        need_resource = (CopperCost[21] - ownCopper[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+354))
                    if StoneCost[21] > ownStone[Clicked]:
                        need_resource = (StoneCost[21] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+382))
                    if WoodCost[21] > ownWood[Clicked]:
                        need_resource = (WoodCost[21] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+323)) 
                        
                    text_cost = font6.render(str(HerbCost[22]), 1,(black)) # <--- ScrollY < 450 and #22 Temple
                    window.blit(text_cost,(resLocaX+175, resLocaY+438))
                    text_cost = font6.render(str(PotteryCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+470))                            
                    text_cost = font6.render(str(AdobeCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+497))
                    text_cost = font6.render(str(GoldCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+438))
                    text_cost = font6.render(str(CrystalCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+470))
                    text_cost = font6.render(str(StoneCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+497))
                    if HerbCost[22] > ownHerb[Clicked]:
                        need_resource = (HerbCost[22] - ownHerb[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+453))   
                    if PotteryCost[22] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[22] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+484))
                    if AdobeCost[22] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[22] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+514))  
                    if GoldCost[22] > ownGold[Clicked]:
                        need_resource = (GoldCost[22] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+453))
                    if CrystalCost[22] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[22] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+484))    
                    if StoneCost[22] > ownStone[Clicked]:
                        need_resource = (StoneCost[22] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+514))

                elif (ZoomTerra[ZoomSector] != 5) and (ScrollY-resLocaY > 449):                        
                    text_cost = font6.render(str(MeatCost[19]), 1,(black)) # <--- ScrollY > 449 and #19 Wooden Tower
                    window.blit(text_cost,(resLocaX+178, resLocaY+42))
                    text_cost = font6.render(str(WoodCost[19]), 1,(black))
                    window.blit(text_cost,(resLocaX+178, resLocaY+75))
                    if MeatCost[19] > ownMeat[Clicked]:
                        need_resource = (MeatCost[19] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+58))
                    if WoodCost[19] > ownWood[Clicked]:
                        need_resource = (WoodCost[19] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+159, resLocaY+89))
                        
                    text_cost = font6.render(str(MeatCost[21]), 1,(black)) # <--- ScrollY > 449 and #21 War Lodge
                    window.blit(text_cost,(resLocaX+180, resLocaY+171))
                    text_cost = font6.render(str(CopperCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+203)) 
                    text_cost = font6.render(str(StoneCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+180, resLocaY+235))  
                    text_cost = font6.render(str(WoodCost[21]), 1,(black))
                    window.blit(text_cost,(resLocaX+245, resLocaY+171))
                    if MeatCost[21] > ownMeat[Clicked]:
                        need_resource = (MeatCost[21] - ownMeat[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+188))
                    if CopperCost[21] > ownCopper[Clicked]:
                        need_resource = (CopperCost[21] - ownCopper[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+219))
                    if StoneCost[21] > ownStone[Clicked]:
                        need_resource = (StoneCost[21] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+250))
                    if WoodCost[21] > ownWood[Clicked]:
                        need_resource = (WoodCost[21] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+188)) 
                        
                    text_cost = font6.render(str(HerbCost[22]), 1,(black)) # <--- ScrollY > 449 and #22 Temple
                    window.blit(text_cost,(resLocaX+175, resLocaY+307))
                    text_cost = font6.render(str(PotteryCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+337))                            
                    text_cost = font6.render(str(AdobeCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+367))
                    text_cost = font6.render(str(GoldCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+307))
                    text_cost = font6.render(str(CrystalCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+337))
                    text_cost = font6.render(str(StoneCost[22]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+367))
                    if HerbCost[22] > ownHerb[Clicked]:
                        need_resource = (HerbCost[22] - ownHerb[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+323))   
                    if PotteryCost[22] > ownPottery[Clicked]:
                        need_resource = (PotteryCost[22] - ownPottery[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+354))
                    if AdobeCost[22] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[22] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+155, resLocaY+384))  
                    if GoldCost[22] > ownGold[Clicked]:
                        need_resource = (GoldCost[22] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+323))
                    if CrystalCost[22] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[22] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+354))  
                    if StoneCost[22] > ownStone[Clicked]:
                        need_resource = (StoneCost[22] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+384))
                        
                    text_cost = font6.render(str(AdobeCost[23]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+438))
                    text_cost = font6.render(str(GoldCost[23]), 1,(black))
                    window.blit(text_cost,(resLocaX+175, resLocaY+470))
                    text_cost = font6.render(str(BronzeCost[23]), 1,(black)) # <--- ScrollY > 449 and #22 Temple
                    window.blit(text_cost,(resLocaX+175, resLocaY+497))
                    text_cost = font6.render(str(CrystalCost[23]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+438))
                    text_cost = font6.render(str(StoneCost[23]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+470))
                    text_cost = font6.render(str(WoodCost[23]), 1,(black))
                    window.blit(text_cost,(resLocaX+240, resLocaY+497))                            
                    if AdobeCost[23] > ownAdobe[Clicked]:
                        need_resource = (AdobeCost[23] - ownAdobe[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+152, resLocaY+455))  
                    if GoldCost[23] > ownGold[Clicked]:
                        need_resource = (GoldCost[23] - ownGold[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+152, resLocaY+486))
                    if BronzeCost[23] > ownBronze[Clicked]:
                        need_resource = (BronzeCost[23] - ownBronze[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+152, resLocaY+514))   
                    if CrystalCost[23] > ownCrystal[Clicked]:
                        need_resource = (CrystalCost[23] - ownCrystal[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+453))  
                    if StoneCost[23] > ownStone[Clicked]:
                        need_resource = (StoneCost[23] - ownStone[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+484))          
                    if WoodCost[23] > ownWood[Clicked]:
                        need_resource = (WoodCost[23] - ownWood[Clicked])
                        text_cost = font11.render("need " + str(need_resource), 1,(red))
                        window.blit(text_cost,(resLocaX+220, resLocaY+514))
                      
# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Scrollbar Window for Cancelling and Upgrading Buildings-- Y axis for Scrollbar is from 18 to 455                
            elif (BuildBox == True) and (ZoomBuild[ZoomSector] > -1 or ZoomConstruct[ZoomSector] > 0):
                ResToggle1 = False
                ResToggle2 = False
                window.blit(boxSCROLL,(resLocaX, resLocaY))
                window.blit(scroller,(ScrollX, ScrollY))
                  
                if ZoomBuild[ZoomSector] == 8:
                    window.blit(scrollCANCEL,(resLocaX+15, resLocaY+10))
                    window.blit(scrollCIVUS,(resLocaX+10, resLocaY+145))
                    ScrollSelect = [24, 9, 0, 0]
                elif ZoomBuild[ZoomSector] == 16:
                    window.blit(scrollCANCEL,(resLocaX+15, resLocaY+10))
                    window.blit(scrollWALL2,(resLocaX+10, resLocaY+145))
                    ScrollSelect = [24, 17, 0, 0]
                elif ZoomBuild[ZoomSector] == 17:
                    window.blit(scrollCANCEL,(resLocaX+15, resLocaY+10))
                    window.blit(scrollWALL3,(resLocaX+10, resLocaY+145))
                    ScrollSelect = [24, 18, 0, 0]
                elif ZoomBuild[ZoomSector] == 19:
                    window.blit(scrollCANCEL,(resLocaX+15, resLocaY+10))
                    window.blit(scrollTOWER2,(resLocaX+10, resLocaY+145))
                    ScrollSelect = [24, 20, 0, 0]
                elif ScrollY-resLocaY < 456:
                    window.blit(scrollCANCEL,(resLocaX+15, resLocaY+10))
                    ScrollSelect = [24, 0, 0, 0]

# --- LABOR SCROLL BOX --- LABOR Scrollbar Window for Allocating Labor            
            if (ZoomBuild[ZoomSector] in range(2, 8)) or (ZoomBuild[ZoomSector] in range(15, 21)) or secPop[Clicked] < 1:   #  If homes are there, then no labor is allowed 
                LaborBox = False    #  ..if there are homes or certain building there, then no labor is allowed

            if (LaborBox == True):   # Conditions for the Labor Box
                laboring = 0
                local_count = 0
                if pygame.mouse.get_pressed()[0] and (resMouseX > 360):   # <-- If player LEFT clicks outside of laborbox..
                    LaborClick = -1
                if pygame.mouse.get_pressed()[2]:        # <-- Reset labor task if player right clicks
                    LaborClick = -1
                if LaborClick == -1:
                    LaborScroll = (resLocaY + 440)
                ResToggle1 = False
                ResToggle2 = False
                window.blit(laborSCROLLbox,(resLocaX, resLocaY))  # <-- Draws labor scroll box if laborbox toggle is true
                window.blit(scroller,(ScrollX, LaborScroll))
                total_labor = secPop[Clicked]
                available = total_labor
                local_labor = 0

# --- LABOR SCROLL BOX --- Player Clicks INSIDE BOX to Choose Labor Task
                if pygame.mouse.get_pressed()[0] and (resMouseX > 15 and resMouseX < 280):
                    if ZoomTerra[ZoomSector] != 5:
                        if (ZoomBuild[ZoomSector] == -1):           # <---- The standard labor tasks on empty land.. 
                            if (resMouseY > 14 and resMouseY < 75):  
                                LaborClick = 0                      # <-- 0 = Forage for Food
                            elif (resMouseY > 93 and resMouseY < 148):
                                LaborClick = 1                      # <-- 1 = Minerals
                            elif (resMouseY > 168 and resMouseY < 224):
                                LaborClick = 2                      # <-- 2 = Stone
                            elif (resMouseY > 243 and resMouseY < 298):
                                LaborClick = 3                      # <-- 3 = Clay
                            elif (resMouseY > 317 and resMouseY < 379):
                                LaborClick = 4                      # <-- 4 = Wood
                            elif (resMouseY > 397 and resMouseY < 461):
                                LaborClick = 21                     # <-- 21 = Herbs
                            else:
                                LaborClick = -1                     # <-- -1 = NO labor task
                            #elif (resMouseY > 478 and resMouseY < 538):
                                    #LaborClick = ?
                        elif (ZoomBuild[ZoomSector] == 11): # <---- The FARMING labor task on FARMS..
                            if (resMouseY > 14 and resMouseY < 75):
                                LaborClick = 6
                            if (IrrigateCheck[ZoomSector] > 0) and (resMouseY > 93 and resMouseY < 148):  # <-- construct irrigation on farms
                                LaborClick = 20 # <-- construct irrigation on farms
                        elif (ZoomBuild[ZoomSector] == 25): # <---- The FARMING labor task on IRRIGATED FARMS..
                            if (resMouseY > 14 and resMouseY < 75):
                                LaborClick = 6

                        elif (ZoomBuild[ZoomSector] == 8) or (ZoomBuild[ZoomSector] == 9): # <---- The COUNCIL OF ELDERS work..
                            if (resMouseY > 14 and resMouseY < 75):
                                LaborClick = 7 # <---- The COUNCIL

                        elif (ZoomBuild[ZoomSector] == 10):
                            if (resMouseY > 14 and resMouseY < 75): # <---- The SHAMANIC HEALING labor task..
                                LaborClick = 8
                            if (resMouseY > 93 and resMouseY < 148): # <---- Train SHAMANIC HEALER labor task..
                                LaborClick = 9

                        elif (ZoomBuild[ZoomSector] == 13):
                            if (resMouseY > 14 and resMouseY < 75): # <---- The BRONZE TOOLS AND WEAPONS task
                                LaborClick = 11
                                
                        elif (ZoomBuild[ZoomSector] == 12): # <---- The HUNTING labor task on HUNTERS' TIPI..
                            if (resMouseY > 14 and resMouseY < 75):
                                LaborClick = 10 # <---- The HUNTING labor task
                                
                        elif (ZoomBuild[ZoomSector] == 14): # <---- The POTTERY or ADOBE labor task on the POTTERY KILN..
                            if (resMouseY > 14 and resMouseY < 75):
                                LaborClick = 12 # <---- The POTTERY labor task
                            if (resMouseY > 93 and resMouseY < 148):
                                LaborClick = 22 # <---- The ADOBE labor task

                        elif (ZoomConstruct[ZoomSector] > 0):
                            if (resMouseY > 14 and resMouseY < 75):
                                LaborClick = 20

                    elif (ZoomTerra[ZoomSector] == 5 and ZoomBuild[ZoomSector] != 1):  # <---- The WATER BASED labor tasks..
                        if (resMouseY > 14 and resMouseY < 75): # <---- The FISHING labor task..
                            LaborClick = 5
                    elif (ZoomTerra[ZoomSector] == 5 and ZoomBuild[ZoomSector] == 1):
                        if (resMouseY > 14 and resMouseY < 75): # <---- The WILD RICE FARMING labor task..
                            LaborClick = 6

                    else:
                        LaborClick = -1

# --- LABOR SCROLL BOX --- Allocates labor when player LEFT CLICKS ON THE SCROLL BAR 
                if pygame.mouse.get_pressed()[0] and (LaborClick > -1):
                    if (resMouseX > 279 and resMouseX < 360): # <-- Left click on scroll bar
                        StatTimer = 5
                        LaborScroll = mouseY - 40                                      
                        if LaborScroll > resLocaY + 420:
                            ZoomLabor[ZoomSector][LaborClick] = 0
                        elif LaborScroll > resLocaY + 380:
                            ZoomLabor[ZoomSector][LaborClick] = 1
                        elif LaborScroll > resLocaY + 340:
                            ZoomLabor[ZoomSector][LaborClick] = 2
                        elif LaborScroll > resLocaY + 300:
                            ZoomLabor[ZoomSector][LaborClick] = 3
                        elif LaborScroll > resLocaY + 260:
                            ZoomLabor[ZoomSector][LaborClick] = 4
                        elif LaborScroll > resLocaY + 220:
                            ZoomLabor[ZoomSector][LaborClick] = 5
                        elif LaborScroll > resLocaY + 180:
                            ZoomLabor[ZoomSector][LaborClick] = 6
                        elif LaborScroll > resLocaY + 140:
                            ZoomLabor[ZoomSector][LaborClick] = 7
                        elif LaborScroll > resLocaY + 100:
                            ZoomLabor[ZoomSector][LaborClick] = 8
                        elif LaborScroll > resLocaY + 60:
                            ZoomLabor[ZoomSector][LaborClick] = 9
                        elif LaborScroll > resLocaY + 20:               
                            ZoomLabor[ZoomSector][LaborClick] = 10
                        if LaborScroll < resLocaY + 20:
                            LaborScroll = resLocaY + 20
                        if LaborScroll > resLocaY + 440:
                            LaborScroll = resLocaY + 440

# --- LABOR SCROLL BOX --- Allocates Labor when player LEFT CLICKS INSIDE the scroll box                       
                    elif (resMouseX > 15 and resMouseX < 280): # <-- Left click inside scroll box
                        Current = ZoomLabor[ZoomSector][LaborClick]
                        AvailWork = (secPop[Clicked] - LocalWorkers)
                        StatTimer = 5
                        LaborScroll = (resLocaY + 440) - ((ZoomLabor[ZoomSector][LaborClick]) * 40) # <-- Moves scroller with labor amount
                        if (resMouseX < 85):
                            ZoomLabor[ZoomSector][LaborClick] = 0
                        elif (resMouseX in range(85, 100)) and (AvailWork > 0 or 1 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 1
                        elif (resMouseX in range(100, 115)) and (AvailWork > 0 or 2 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 2
                        elif (resMouseX in range(115, 130)) and (AvailWork > 0 or 3 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 3
                        elif (resMouseX in range(130, 145)) and (AvailWork > 0 or 4 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 4
                        elif (resMouseX in range(145, 160)) and (AvailWork > 0 or 5 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 5
                        elif (resMouseX in range(160, 175)) and (AvailWork > 0 or 6 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 6
                        elif (resMouseX in range(175, 190)) and (AvailWork > 0 or 7 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 7
                        elif (resMouseX in range(190, 205)) and (AvailWork > 0 or 8 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 8
                        elif (resMouseX in range(205, 220)) and (AvailWork > 0 or 9 < Current):
                            ZoomLabor[ZoomSector][LaborClick] = 9
                        elif (resMouseX in range(220, 235)) and (AvailWork > 0):
                            ZoomLabor[ZoomSector][LaborClick] = 10
                        LaborClick = -1

# --- LABOR SCROLL BOX --- Draws the LABOR TASK DESCRIPTIVE IMAGES
                if ZoomTerra[ZoomSector] != 5:                
                    if (ZoomBuild[ZoomSector] in range(2,4)) or (ZoomBuild[ZoomSector] == -1):
                        window.blit(workFORAGE,(resLocaX, resLocaY+1))         # <--- Draws Standard Labor Task Images
                        window.blit(workMINERAL,(resLocaX, resLocaY+75))
                        window.blit(workSTONE,(resLocaX, resLocaY+152))
                        window.blit(workCLAY,(resLocaX, resLocaY+226))
                        window.blit(workWOOD,(resLocaX, resLocaY+302))
                        window.blit(workHERBS,(resLocaX, resLocaY+382))

                    elif (ZoomBuild[ZoomSector] == 10):
                        window.blit(workHEALING,(resLocaX, resLocaY+1))         # <--- Draws HEALING Labor Task Image
                        window.blit(workHEALING,(resLocaX, resLocaY+75))         # <--- Draws SHAMANIC HEALER Labor Task Image
                          
                    elif (ZoomBuild[ZoomSector] == 11): # <---- DRAWS The FARMING LABOR IMAGE
                        window.blit(workFARMING,(resLocaX, resLocaY+1))         # <--- Draws FARMING Labor Task Image
                        if IrrigateCheck[ZoomSector] > 0:
                            window.blit(workIRRIGATE,(resLocaX, resLocaY+75))         # <--- Draws IRRIGATION Labor Task Image
                    elif (ZoomBuild[ZoomSector] == 25): # <---- DRAWS The FARMING (with irrigation) LABOR IMAGE
                        window.blit(workFARMING,(resLocaX, resLocaY+1))         # <--- Draws FARMING Labor Task Image
                        
                    elif (ZoomBuild[ZoomSector] == 11):
                        window.blit(workBRONZE,(resLocaX, resLocaY+1))         # <--- Draws BRONZE MAKING labor task

                    elif (ZoomBuild[ZoomSector] == 12):
                        window.blit(workHUNTING,(resLocaX, resLocaY+1))         # <--- Draws HUNTING Labor Task Image

                    elif (ZoomBuild[ZoomSector] == 14):
                        window.blit(workPOTTERY,(resLocaX, resLocaY+1))         # <--- Draws POTTERY Labor Task Image
                        window.blit(workADOBE,(resLocaX, resLocaY+75))         # <--- Draws POTTERY Labor Task Image
                        build_info = font7.render("5 workers max", 1,(black))
                        window.blit(build_info,(resLocaX+20, resLocaY+170))

                    elif (ZoomConstruct[ZoomSector] > 0):
                        window.blit(workCONSTRUCT,(resLocaX, resLocaY+1))         # <--- Draws CONSTRUCTION Labor Task Image
                        if ZoomConstruct[ZoomSector] in range(1, 24):
                            building = ZoomConstruct[ZoomSector]
                            window.blit(build.edi[building],(resLocaX+80, resLocaY+111)) # <-- It will draw the post-constructed building
                    '''        
                    window.blit(boxSQUARE,(SecLocaX-145, SecLocaY-53)) 
                    building_num = ZoomConstruct[ZoomSector]
                    if building_num == 23:
                        window.blit(infoPYRAMID,(SecLocaX-15, SecLocaY+30))
                    elif building_num in range(1, 8) or building_num in range(10, 15) or building_num in range(16, 21):
                        side_pic = build.edi[building_num]
                        window.blit(side_pic,(SecLocaX-100, SecLocaY-20))
                    else:                    
                        side_pic = build.edi[building_num]
                        window.blit(side_pic,(SecLocaX-140, SecLocaY-40))
                        '''

                elif (ZoomTerra[ZoomSector] == 5 and ZoomBuild[ZoomSector] != 1): # <-- Draws Water-Based Task Images
                    window.blit(workFISHING,(resLocaX, resLocaY+1))         # <--- Draws FISHING Labor Task Image
                elif (ZoomTerra[ZoomSector] == 5 and ZoomBuild[ZoomSector] == 1):
                    window.blit(workFARMING,(resLocaX, resLocaY+1))         # <--- Draws FARMING Labor Task Image
                    
# --- LABOR SCROLL BOX --- Draws the WORKERS INSIDE the Labor Scroll Box
                for num in range(0, 23):    # <---- All of the labor tasks..
                    laborers = ZoomLabor[ZoomSector][num]
                    local_labor += laborers
                    available -= laborers
                    for peons in range(0, laborers):
                        loca = 15 * peons
                        if num == 0 or (num in range (5,9)) or (num == 10):
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+35))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+37))
                        elif num == 1:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+111))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+105))                        
                        elif num == 2:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+185))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+188))       
                        elif num == 3:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+260))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+258))     
                        elif num == 4:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+339))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+338))
                        elif num == 9:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+111))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+105))
                            window.blit(box_info,(resLocaX+255, resLocaY+338))
                        elif num == 12:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+35))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+37))
                        elif num == 20 and (ZoomBuild[ZoomSector] != 11 and ZoomBuild[ZoomSector] != -1):  # <--- All other construction 
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+35))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+37))                                                        
                        elif num == 20 and (ZoomBuild[ZoomSector] == 11):    # <--- Construct irrigation on farms
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+111))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+105))
                        elif num == 21:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+418))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+417))
                        elif num == 22:
                            window.blit(workDEFAULT,(resLocaX+80+loca, resLocaY+111))
                            box_info = font8.render(str(ZoomLabor[ZoomSector][num]), 1,(black))
                            window.blit(box_info,(resLocaX+255, resLocaY+105))
                                
# --- LABOR SCROLL BOX --- Animates a FLASHING BLUE BOX when player LEFT CLICKS on a labor task assignment
                '''
                if LaborClick in range(0, 5):
                    flashY = resLocaY+17+((LaborClick)* 75)
                elif LaborClick > 4:
                    flashY = resLocaY+((LaborClick)* 76)                    
                if LaborClick in range(0, 4):
                    if LaborClick == 3:                                           
                        flashY += 2
                    if frames < 40:
                        window.blit(boxFLASHlabor,(resLocaX+15, flashY))
                    elif frames < 70:
                        window.blit(boxFLASHlabor2,(resLocaX+15, flashY))
                    elif frames < 101:
                        window.blit(boxFLASHlabor3,(resLocaX+15, flashY))
                elif LaborClick in range(4, 6):
                    if frames < 40:
                        window.blit(FLASHlabor,(resLocaX+10, flashY))
                    elif frames < 70:
                        window.blit(FLASHlabor2,(resLocaX+10, flashY))
                    elif frames < 101:
                        window.blit(FLASHlabor3,(resLocaX+10, flashY))
                        '''                

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Resource Costs for the Buildings -- PREVENTS A BUILDING FROM BEING BUILT IF LACKING RESOURCES
            for scrolls in range(1, 26):
                if ScrollClick == scrolls and ownGrain[Clicked] < GrainCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownMeat[Clicked] < MeatCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownForage[Clicked] < ForageCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownHerb[Clicked] < HerbCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownPottery[Clicked] < PotteryCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownAdobe[Clicked] < AdobeCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownGold[Clicked] < GoldCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownCopper[Clicked] < CopperCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownBronze[Clicked] < BronzeCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownCrystal[Clicked] < CrystalCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownStone[Clicked] < StoneCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownClay[Clicked] < ClayCost[scrolls]:
                    ScrollClick = 0
                if ScrollClick == scrolls and ownWood[Clicked] < WoodCost[scrolls]:
                    ScrollClick = 0

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- After player clicks on something in the Scrollbar Window --- Y axis for Scrollbar is from 18 to 455  
            if ScrollClick == 24:
                window.blit(smallAXE,(mouseX-20, mouseY-20)) # <-- It will change the cursor into the building clicked..
            elif ScrollClick == 23:   # <--- If player has clicked PYRAMID in the scrollbox
                window.blit(build.edi[ScrollClick],(mouseX-250, mouseY-200)) # <-- It will change the cursor into the building clicked..        
            elif ScrollClick == 15:
                window.blit(build.edi[ScrollClick],(mouseX-90, mouseY-60)) # <-- It will change the cursor into the building clicked..                 
            elif ScrollClick == 8 or ScrollClick == 21 or ScrollClick == 22:   # <--- If player has clicked PYRAMID in the scrollbox
                window.blit(build.edi[ScrollClick],(mouseX-100, mouseY-100)) # <-- It will change the cursor into the building clicked..
            elif ScrollClick == 9:
                if ZoomBuild[ZoomSector] == 8:
                    ZoomBuild[ZoomSector] = ScrollClick
            elif ScrollClick == 17:
                if ZoomBuild[ZoomSector] == 16:
                    ZoomBuild[ZoomSector] = ScrollClick
            elif ScrollClick == 18:
                if ZoomBuild[ZoomSector] == 17:
                    ZoomBuild[ZoomSector] = ScrollClick
            elif ScrollClick == 20:
                if ZoomBuild[ZoomSector] == 19:
                    ZoomBuild[ZoomSector] = ScrollClick
            elif ScrollClick > 0:
                window.blit(build.edi[ScrollClick],(mouseX-30, mouseY-50)) # <-- It will change the cursor into the building clicked..

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- After player clicks inside the Zoomed Sector Box they can build..
            if (mouseX-SecLocaX > 75) and (mouseX-SecLocaX < 520) and (mouseY-SecLocaY > 10) and (mouseY-SecLocaY < 451):
                if ScrollClick > 0:   # <---- Run a labor check if the player trys to build anything 
                    StatTimer = 4
                if ScrollClick == 9 or ScrollClick in range(17, 19) or ScrollClick == 20:
                    ScrollClick = 0 
                elif pygame.mouse.get_pressed()[0] and BuildBox == True and ScrollClick > 0 and ZoomTerra[ZoomSector] == 5:                    
                    if ScrollClick == 1 and ZoomBuild[ZoomSector] < 0:
                        ZoomWait[ZoomSector] = 0 
                        ZoomBuild[ZoomSector] = 1  # <--- if player clicks "rice farm"..
                    if ScrollClick == 24 and ZoomBuild[ZoomSector] == 1:
                        ZoomBuild[ZoomSector] = -1
                    ScrollClick = 0
                    #ZoomSector += 1

                elif pygame.mouse.get_pressed()[0] and BuildBox == True and ScrollClick > 0 and ZoomTerra[ZoomSector] != 5:
                    if ScrollClick == 1:
                        ScrollClick = 0
                    if (ScrollClick == 8 or ScrollClick == 21 or ScrollClick == 22):
                        if SectX == 1 or SectY == 0:
                            ScrollClick = 0
                        elif ZoomTerra[ZoomSector-1] == 5 or ZoomTerra[ZoomSector-6] == 5 or ZoomTerra[ZoomSector-7] == 5:
                            ScrollClick = 0
                        elif (ZoomBuild[ZoomSector-1] > -1) or (ZoomBuild[ZoomSector-6] > -1) or (ZoomBuild[ZoomSector-7] > -1):
                            ScrollClick = 0
                        else:
                            ZoomConstruct[ZoomSector] == ScrollClick
                            ZoomBuild[ZoomSector] == 0
                    
                    if ScrollClick == 23:                     # <---- Building a pyramid
                        if SectX < 4 or SectY < 2:
                            ScrollClick = 0                            
                        else:
                            for Space in range(ZoomSector-3, ZoomSector+1):                                
                                if ZoomTerra[Space] == 5 or ZoomBuild[Space] > -1:                                    
                                    ScrollClick = 0
                            for Space in range(ZoomSector-9, ZoomSector-5):                                
                                if ZoomTerra[Space] == 5 or ZoomBuild[Space] > -1:
                                    ScrollClick = 0
                            for Space in range(ZoomSector-15, ZoomSector-11):                                
                                if ZoomTerra[Space] == 5 or ZoomBuild[Space] > -1:
                                    ScrollClick = 0                                   

                    if ScrollClick == 15:    # <------------------------------------------ 2 x 1 Storage Lodge
                        if ZoomTerra[ZoomSector-1] == 5 or ZoomBuild[ZoomSector-1] > -1 or SectX < 2:
                            ScrollClick = 0
                        else:
                            ZoomWait[ZoomSector] = 10
                    if (ScrollClick == 6 and ZoomTerra[ZoomSector] == 3) or (ScrollClick == 4 and ZoomTerra[ZoomSector] != 3):
                        ScrollClick = 0
                    if (ScrollClick == 11) and (ZoomWater[ZoomSector] < 1):
                        ScrollClick = 0
                        #if ScrollClick > 0 and ZoomBuild[ZoomSector] == -1:

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Use up the resources for buildings
                    for scrolls in range(1, 26):
                        if ScrollClick == scrolls and ScrollClick > 0:
                            ownGrain[Clicked] -= GrainCost[scrolls]
                            ownMeat[Clicked] -= MeatCost[scrolls]
                            ownForage[Clicked] -= ForageCost[scrolls]
                            ownHerb[Clicked] -= HerbCost[scrolls]
                            ownPottery[Clicked] -= PotteryCost[scrolls]
                            ownAdobe[Clicked] -= AdobeCost[scrolls]
                            ownGold[Clicked] -= GoldCost[scrolls]
                            ownCopper[Clicked] -= CopperCost[scrolls]
                            ownBronze[Clicked] -= BronzeCost[scrolls]
                            ownCrystal[Clicked] -= CrystalCost[scrolls]
                            ownStone[Clicked] -= StoneCost[scrolls]
                            ownClay[Clicked] -= ClayCost[scrolls]
                            ownWood[Clicked] -= WoodCost[scrolls]

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Buildings that DON'T REQUIRE construction labor                        
                    if (ScrollClick == 1 or ScrollClick == 2 or ScrollClick == 11 or ScrollClick == 12) and ZoomBuild[ZoomSector] == -1:
                        if ScrollClick == 11:
                            CropPotential[ZoomSector] = 10       # <-- Build a NEW FARM and give it CROP POTENTIAL     
                        ZoomBuild[ZoomSector] = ScrollClick
                        ZoomWait[ZoomSector] = 0
                        
# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX ---IF player builds a construction site then calculate how much labor is needed
                    if ScrollClick > 1 and ZoomBuild[ZoomSector] < 0 and ZoomTerra[ZoomSector] != 5 and ZoomConstruct[ZoomSector] < 1:  # <-- Won't build if something's already there, otherwise..
                        ZoomConstruct[ZoomSector] = ScrollClick
                        if ZoomConstruct[ZoomSector] == 3:   # <-- TIPI needs this many workers to build..
                            BuildLabor[ZoomSector] = 5
                        elif ZoomConstruct[ZoomSector] == 4: # <-- ADOBE HOME needs this many workers to build..
                            BuildLabor[ZoomSector] = 10
                        elif ZoomConstruct[ZoomSector] == 6: # <-- WOOD LONGHOUSE needs this many workers to build..
                            BuildLabor[ZoomSector] = 10
                        elif ZoomConstruct[ZoomSector] == 7:   # <-- HOUSE needs this many workers to build..
                            BuildLabor[ZoomSector] = 15
                        elif ZoomConstruct[ZoomSector] == 8:   # <-- MEETING TENT needs this many workers to build..
                            BuildLabor[ZoomSector] = 1
                        elif ZoomConstruct[ZoomSector] == 10:   # <-- SHAMANIC TIPI needs this many workers to build..
                            BuildLabor[ZoomSector] = 8
                        elif ZoomConstruct[ZoomSector] == 13:  # <-- FURNACE needs this many workers to build..
                            BuildLabor[ZoomSector] = 20
                        elif ZoomConstruct[ZoomSector] == 14:  # <-- POTTERY KILN needs this many workers to build..
                            BuildLabor[ZoomSector] = 20
                        elif ZoomConstruct[ZoomSector] == 15:  # <-- STORAGE LODGE needs this many workers to build..
                            BuildLabor[ZoomSector] = 15
                        ZoomBuild[ZoomSector] = 0
                    elif ScrollClick > 1 and ZoomBuild[ZoomSector] == 11 and IrrigateCheck[ZoomSector] > 0: # <-- IRRIGATED FARM needs this many workers to upgrade..
                        BuildLabor[ZoomSector] = 1
                    #elif ScrollClick > 1 and ZoomBuild[ZoomSector] > 0:
                        #if ZoomBuild[ZoomSector] == 8

                    if ScrollClick == 24 and (ZoomConstruct[ZoomSector] != 23 and ZoomBuild[ZoomSector] != 23): # <-- Don't allow for PYRAMIDS to be destroyed
                        for scrolls in range(1, 26):                            # <---- Get back half of your resources..
                            if (ZoomConstruct[ZoomSector] == scrolls or ZoomBuild[ZoomSector] == scrolls):
                                ownGrain[Clicked] += int(GrainCost[scrolls]/2)    
                                ownMeat[Clicked] += int(MeatCost[scrolls]/2)
                                ownForage[Clicked] += int(ForageCost[scrolls]/2)
                                ownHerb[Clicked] += int(HerbCost[scrolls]/2)
                                ownPottery[Clicked] += int(PotteryCost[scrolls]/2)
                                ownAdobe[Clicked] += int(AdobeCost[scrolls]/2)
                                ownGold[Clicked] += int(GoldCost[scrolls]/2)
                                ownCopper[Clicked] += int(CopperCost[scrolls]/2)
                                ownBronze[Clicked] += int(BronzeCost[scrolls]/2)
                                ownCrystal[Clicked] += int(CrystalCost[scrolls]/2)
                                ownStone[Clicked] += int(StoneCost[scrolls]/2)
                                ownClay[Clicked] += int(ClayCost[scrolls]/2)
                                ownWood[Clicked] += int(WoodCost[scrolls]/2)                       
                        
                        ZoomConstruct[ZoomSector] = -1
                        ZoomBuild[ZoomSector] = -1
                    else:
                        ScrollClick = 0
                    ScrollClick = 0
                    ZoomSector += 1
                    

# --- SCROLL BUILD BOX --- ZOOMED SECTOR BOX --- Left Mouse Click Scrollbox/Scrollbar
            if pygame.mouse.get_pressed()[0]:
                if (BuildBox == True) and (resMouseX > 280 and resMouseX < 360): # <-- Left click on scroll bar
                    ScrollY = mouseY - 40
                    ScrollSelect = [0, 0, 0, 0]
                    ScrollClick = 0
                    
                    if ScrollY > resLocaY + 450:
                        ScrollY = resLocaY + 450
                    if ScrollY < resLocaY + 18:
                        ScrollY = resLocaY + 18                        
                    pygame.mouse.set_visible(True)
                    if SectorZoom == False:
                        BuildBox = False
                        LaborBox = False

                elif (BuildBox == True) and (resMouseX > 20 and resMouseX < 280): # <-- Left click inside scroll box
                    if (resMouseY > 15 and resMouseY < 145):
                        window.blit(boxFLASH,(resLocaX+12, resLocaY+17))
                        ScrollClick = ScrollSelect[0]
                    elif (resMouseY > 150 and resMouseY < 275):
                        window.blit(boxFLASH,(resLocaX+12, resLocaY+145))
                        ScrollClick = ScrollSelect[1]
                    elif (resMouseY > 280 and resMouseY < 405):
                        window.blit(boxFLASH,(resLocaX+12, resLocaY+275))
                        ScrollClick = ScrollSelect[2]
                    elif (resMouseY > 415 and resMouseY < 540):
                        window.blit(boxFLASH,(resLocaX+12, resLocaY+407))
                        ScrollClick = ScrollSelect[3]
                    TickPause += 1

# --- RESOURCE INFORMATION BOX --- Animates and Draws Resource Boxes
        if (secExplored[Clicked] != 1):
            ResToggle1 = False
            ResToggle2 = False 
        if ResToggle1 == True and (secExplored[Clicked] == 1):           
            window.blit(boxRESOURCE1, (resLocaX, resLocaY))
        elif ResToggle2 == True and (secExplored[Clicked] == 1):
            window.blit(boxRESOURCE2, (resLocaX, resLocaY))            
        elif (ResToggle1 == False and ResToggle2 == False) and (BuildBox == True or LaborBox == True):
            resLocaX = 0
        elif (ResToggle1 == False and ResToggle2 == False) and (BuildBox == False and LaborBox == False):
            if resLocaX > -330:
                resLocaX -= 20
            if resLocaX < -300:
                window.blit(boxRESOURCEedge, (resLocaX+325, resLocaY-5))
        if (ResToggle1 == True or ResToggle2 == True):
            if resLocaX < -10:
                resLocaX += 20
        if (ResToggle1 == True and range_clicks > 0) or (ResToggle1 == True and (SectorZoom == True or MapToggle == True)):
            EscapeToggle = False

# --- RESOURCE INFORMATION BOX --- Resource 1 Information --- Resource 1 - Food and Grains
            LocalFood = ownGrain[Clicked] + ownMeat[Clicked] + ownForage[Clicked]
            MoveFood = movGrain[Clicked] + movMeat[Clicked] + movForage[Clicked]            
            box_info = font9.render(str(LocalFood), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+15))
            box_info = font9.render(str(TotalAllFood), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+15))            
            TotalFoodWork = ForageWork + FarmWork + HuntWork
            box_info = font9.render(str(TotalFoodWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+15))
            if MoveFood > 0:
                box_info = font3.render("+" + str(MoveFood), 1,(darkGRN))
                window.blit(box_info,(resLocaX+87, resLocaY+45))
            
            box_info = font9.render(str(ownGrain[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+93))
            box_info = font9.render(str(TotalGrain), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+93))
            box_info = font9.render(str(FarmWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+93))
            Resource = NewResources[Clicked][0] - OldResources[Clicked][0]
            if movGrain[Clicked] > 0:
                box_info = font3.render("+" + str(movGrain[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+125))
                box_info = font6.render(str(waitGrain[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+127))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+125))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+125))
            
            box_info = font9.render(str(ownMeat[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+171))
            box_info = font9.render(str(TotalMeat), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+171))
            box_info = font9.render(str(HuntWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+171))
            Resource = NewResources[Clicked][1] - OldResources[Clicked][1]
            if movMeat[Clicked] > 0:
                box_info = font3.render("+" + str(movMeat[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+205))
                box_info = font6.render(str(waitMeat[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+207))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+205))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+205))
            
            box_info = font9.render(str(ownForage[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+246))
            box_info = font9.render(str(TotalForage), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+246))
            box_info = font9.render(str(ForageWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+246))
            Resource = NewResources[Clicked][2] - OldResources[Clicked][2]
            if movForage[Clicked] > 0:
                box_info = font3.render("+" + str(movForage[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+280))
                box_info = font6.render(str(waitForage[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+282))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+280))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+280))

            box_info = font9.render(str(ownHerb[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+325))
            box_info = font9.render(str(TotalHerb), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+325))
            box_info = font9.render(str(HerbWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+325))
            Resource = NewResources[Clicked][3] - OldResources[Clicked][3]
            if movHerb[Clicked] > 0:
                box_info = font3.render("+" + str(movHerb[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+355))
                box_info = font6.render(str(waitHerb[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+357))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+355))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+355))
            
            box_info = font9.render(str(ownPottery[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+401))
            box_info = font9.render(str(TotalPottery), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+401))
            box_info = font9.render(str(PotteryWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+401))
            Resource = NewResources[Clicked][4] - OldResources[Clicked][4]
            if movPottery[Clicked] > 0:
                box_info = font3.render("+" + str(movPottery[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+430))
                box_info = font6.render(str(waitPottery[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+432))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+430))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+430))
            
            box_info = font9.render(str(ownAdobe[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+478))
            box_info = font9.render(str(TotalAdobe), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+478))
            box_info = font9.render(str(AdobeWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+478))
            Resource = NewResources[Clicked][5] - OldResources[Clicked][5]
            if movAdobe[Clicked] > 0:
                box_info = font3.render("+" + str(movAdobe[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+510))
                box_info = font6.render(str(waitAdobe[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+512))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+510))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+510))

            box_info = font9.render(str(secPop[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+553))
            box_info = font9.render(str(TotalPop), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+553))
            Resource = NewResources[Clicked][13] - OldResources[Clicked][13]
            if movPop[Clicked][0] > 0:
                box_info = font3.render("+" + str(movPop[Clicked][0]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+583))            
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+583))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+583))


# --- RESOURCE INFORMATION BOX --- Help Information
            if InfoToggle == True:
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 16 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 78:
                    window.blit(infoFOOD, (mouseX+55, mouseY+50))     # <------- Info FOOD Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_food1,(mouseX+305, mouseY+80))
                    window.blit(msg_food2,(mouseX+305, mouseY+110))
                    window.blit(msg_food3,(mouseX+305, mouseY+140))
                    window.blit(msg_food4,(mouseX+305, mouseY+170))
                    window.blit(msg_food5,(mouseX+305, mouseY+200))
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 94 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 157:
                    window.blit(infoGRAIN, (mouseX+70, mouseY+50))     # <------- Info Grain Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_grain1,(mouseX+305, mouseY+80))
                    window.blit(msg_grain2,(mouseX+305, mouseY+110))
                    window.blit(msg_grain3,(mouseX+305, mouseY+140))
                    window.blit(msg_grain4,(mouseX+305, mouseY+170))
                    window.blit(msg_grain5,(mouseX+305, mouseY+200))
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 171 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 235:
                    window.blit(infoMEAT, (mouseX+70, mouseY+50))     # <------- Info MEAT Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_meat1,(mouseX+305, mouseY+80))
                    window.blit(msg_meat2,(mouseX+305, mouseY+110))
                    window.blit(msg_meat3,(mouseX+305, mouseY+140))
                    window.blit(msg_meat4,(mouseX+305, mouseY+170))
                    window.blit(msg_meat5,(mouseX+305, mouseY+200))                    
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 250 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 313:
                    window.blit(infoFORAGE, (mouseX+70, mouseY+50))  # <------- Info Forage Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_forage1,(mouseX+305, mouseY+80))
                    window.blit(msg_forage2,(mouseX+305, mouseY+110))
                    window.blit(msg_forage3,(mouseX+305, mouseY+140))
                    window.blit(msg_forage4,(mouseX+305, mouseY+170))
                    window.blit(msg_forage5,(mouseX+305, mouseY+200))                    
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 325 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 390:
                    window.blit(infoHERB, (mouseX+70, mouseY+50))    # <------- Info Herb Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_herb1,(mouseX+305, mouseY+80))
                    window.blit(msg_herb2,(mouseX+305, mouseY+110))
                    window.blit(msg_herb3,(mouseX+305, mouseY+140))
                    window.blit(msg_herb4,(mouseX+305, mouseY+170))
                    window.blit(msg_herb5,(mouseX+305, mouseY+200))
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 403 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 467:
                    window.blit(infoPOTTERY, (mouseX+70, mouseY-180))    # <------- Info Pottery Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY-180)) # <------- Info Box
                    window.blit(msg_pot1,(mouseX+305, mouseY-150))
                    window.blit(msg_pot2,(mouseX+305, mouseY-120))
                    window.blit(msg_pot3,(mouseX+305, mouseY-90))
                    window.blit(msg_pot4,(mouseX+305, mouseY-60))
                    window.blit(msg_pot5,(mouseX+305, mouseY-15))                    
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 480 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 543:
                    window.blit(infoADOBE, (mouseX+70, mouseY-180))    # <------- Info Bronze Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY-180)) # <------- Info Box
                    window.blit(msg_adobe1,(mouseX+305, mouseY-150))
                    window.blit(msg_adobe2,(mouseX+305, mouseY-120))
                    window.blit(msg_adobe3,(mouseX+305, mouseY-90))
                    window.blit(msg_adobe4,(mouseX+305, mouseY-60))
                    window.blit(msg_adobe5,(mouseX+305, mouseY-15))         


# --- Resource 2 Information --- Resource Box Numbers
        if (ResToggle2 == True and range_clicks > 0) or (ResToggle2 == True and (SectorZoom == True or MapToggle == True)):
            if resLocaX < -10:
                resLocaX += 20
            EscapeToggle = False

            box_info = font9.render(str(ownGold[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+15))
            box_info = font9.render(str(TotalGold), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+15))
            box_info = font9.render(str(MineralWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+15))
            Resource = NewResources[Clicked][6] - OldResources[Clicked][6]
            if movGold[Clicked] > 0:
                box_info = font3.render("+" + str(movGold[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+45))
                box_info = font6.render(str(waitGold[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+47))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+45))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+45))

            box_info = font9.render(str(ownCopper[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+93))
            box_info = font9.render(str(TotalCopper), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+93))
            box_info = font9.render(str(MineralWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+93))
            Resource = NewResources[Clicked][7] - OldResources[Clicked][7]
            if movCopper[Clicked] > 0:
                box_info = font3.render("+" + str(movCopper[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+125))
                box_info = font6.render(str(waitCopper[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+127))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+125))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+125))
            
            box_info = font9.render(str(ownBronze[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+171))
            box_info = font9.render(str(TotalBronze), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+171))
            box_info = font9.render(str(BronzeWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+171))
            Resource = NewResources[Clicked][8] - OldResources[Clicked][8]
            if movBronze[Clicked] > 0:
                box_info = font3.render("+" + str(movBronze[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+205))
                box_info = font6.render(str(waitBronze[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+207))
            elif Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+205))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+205))
            
            box_info = font9.render(str(ownCrystal[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+246))
            box_info = font9.render(str(TotalCrystal), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+246))
            box_info = font9.render(str(MineralWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+246))
            Resource = NewResources[Clicked][9] - OldResources[Clicked][9]
            if movCrystal[Clicked] > 0:
                box_info = font3.render("+" + str(movCrystal[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+280))
                box_info = font6.render(str(waitCrystal[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+282))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+280))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+280))

            box_info = font9.render(str(ownStone[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+325))
            box_info = font9.render(str(TotalStone), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+325))
            box_info = font9.render(str(StoneWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+325))
            Resource = NewResources[Clicked][10] - OldResources[Clicked][10]
            if movStone[Clicked] > 0:
                box_info = font3.render("+" + str(movStone[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+355))
                box_info = font6.render(str(waitStone[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+357))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+355))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+355))
            
            box_info = font9.render(str(ownClay[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+401))
            box_info = font9.render(str(TotalClay), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+401))
            box_info = font9.render(str(ClayWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+401))
            Resource = NewResources[Clicked][11] - OldResources[Clicked][11]
            if movClay[Clicked] > 0:
                box_info = font3.render("+" + str(movClay[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+431))
                box_info = font6.render(str(waitClay[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+433))
            elif Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+431))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+431))
            
            box_info = font9.render(str(ownWood[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+478))
            box_info = font9.render(str(TotalWood), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+478))
            box_info = font9.render(str(WoodWork), 1,(black))
            window.blit(box_info,(resLocaX+290, resLocaY+478))
            Resource = NewResources[Clicked][12] - OldResources[Clicked][12]
            if movWood[Clicked] > 0:
                box_info = font3.render("+" + str(movWood[Clicked]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+510))
                box_info = font6.render(str(waitWood[Clicked]) + " turns", 1,(darkGRN))
                window.blit(box_info,(resLocaX+210, resLocaY+512))
            elif Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+510))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+510))
                
            box_info = font9.render(str(secPop[Clicked]), 1,(black))
            window.blit(box_info,(resLocaX+87, resLocaY+553))
            box_info = font9.render(str(TotalPop), 1,(black))
            window.blit(box_info,(resLocaX+165, resLocaY+553))
            Resource = NewResources[Clicked][13] - OldResources[Clicked][13]
            if movPop[Clicked][0] > 0:
                box_info = font3.render("+" + str(movPop[Clicked][0]), 1,(darkGRN))
                window.blit(box_info,(resLocaX+160, resLocaY+583))
            if Resource > 0  and (MoonCycle != 1 or MoonPhase != 1):                 
                box_info = font3.render("+" + str(Resource), 1,(black))
                window.blit(box_info,(resLocaX+85, resLocaY+583))
            elif Resource < 0  and (MoonCycle != 1 or MoonPhase != 1):
                box_info = font3.render(str(Resource), 1,(red))
                window.blit(box_info,(resLocaX+85, resLocaY+583))
                            

    # --- RESOURCE BOXES --- Resource 2 - Stones and Minerals
            if InfoToggle == True:
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 16 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 78:
                    window.blit(infoGOLD, (mouseX+55, mouseY+50))     # <------- Info Gold Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_gold1,(mouseX+305, mouseY+80))
                    window.blit(msg_gold2,(mouseX+305, mouseY+110))
                    window.blit(msg_gold3,(mouseX+305, mouseY+140))
                    window.blit(msg_gold4,(mouseX+305, mouseY+170))
                    window.blit(msg_gold5,(mouseX+305, mouseY+200)) 
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 94 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 157:
                    window.blit(infoCOPPER, (mouseX+70, mouseY+50))     # <------- Info Copper Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_copp1,(mouseX+305, mouseY+80))
                    window.blit(msg_copp2,(mouseX+305, mouseY+110))
                    window.blit(msg_copp3,(mouseX+305, mouseY+140))
                    window.blit(msg_copp4,(mouseX+305, mouseY+170))
                    window.blit(msg_copp5,(mouseX+305, mouseY+200))          
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 171 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 235:
                    window.blit(infoBRONZE, (mouseX+70, mouseY+50))     # <------- Info Bronze Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_bronze1,(mouseX+305, mouseY+80))
                    window.blit(msg_bronze2,(mouseX+305, mouseY+110))
                    window.blit(msg_bronze3,(mouseX+305, mouseY+140))
                    window.blit(msg_bronze4,(mouseX+305, mouseY+170))
                    window.blit(msg_bronze5,(mouseX+305, mouseY+200))
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 250 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 313:
                    window.blit(infoCRYSTAL, (mouseX+70, mouseY+50))  # <------- Info Crystal Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_crys1,(mouseX+305, mouseY+80))
                    window.blit(msg_crys2,(mouseX+305, mouseY+110))
                    window.blit(msg_crys3,(mouseX+305, mouseY+140))
                    window.blit(msg_crys4,(mouseX+305, mouseY+170))
                    window.blit(msg_crys5,(mouseX+305, mouseY+200))
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 325 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 390:
                    window.blit(infoSTONE, (mouseX+70, mouseY+50))    # <------- Info Stone Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY+50)) # <------- Info Box
                    window.blit(msg_stone1,(mouseX+305, mouseY+80))
                    window.blit(msg_stone2,(mouseX+305, mouseY+110))
                    window.blit(msg_stone3,(mouseX+305, mouseY+140))
                    window.blit(msg_stone4,(mouseX+305, mouseY+170))
                    window.blit(msg_stone5,(mouseX+305, mouseY+200))
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 403 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 467:
                    window.blit(infoCLAY, (mouseX+70, mouseY-180))    # <------- Info Clay Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY-180)) # <------- Info Box
                    window.blit(msg_clay1,(mouseX+305, mouseY-150))
                    window.blit(msg_clay2,(mouseX+305, mouseY-120))
                    window.blit(msg_clay3,(mouseX+305, mouseY-90))
                    window.blit(msg_clay4,(mouseX+305, mouseY-60))
                    window.blit(msg_clay5,(mouseX+305, mouseY-15))             
                if (mouseX - resLocaX) > 14 and (mouseY - resLocaY) > 480 and (mouseX - resLocaX) < 84 and (mouseY - resLocaY) < 543:
                    window.blit(infoWOOD, (mouseX+70, mouseY-180))    # <------- Info Wood Pic
                    window.blit(boxINFOlarge, (mouseX+50, mouseY-180)) # <------- Info Box
                    window.blit(msg_wood1,(mouseX+305, mouseY-150))
                    window.blit(msg_wood2,(mouseX+305, mouseY-120))
                    window.blit(msg_wood3,(mouseX+305, mouseY-90))
                    window.blit(msg_wood4,(mouseX+305, mouseY-60))
                    window.blit(msg_wood5,(mouseX+305, mouseY-15))
                    
    # --- END OF MAIN LOOP --- Flip and Draw Images           
        if MoveResource == 1:
            window.blit(moveGRAIN,(mouseX, mouseY))                
        elif MoveResource == 2:
            window.blit(moveMEAT,(mouseX, mouseY))
        elif MoveResource == 3:
            window.blit(moveFORAGE,(mouseX, mouseY))
        elif MoveResource == 4:
            window.blit(moveHERB,(mouseX, mouseY))
        elif MoveResource == 5:
            window.blit(movePOTTERY,(mouseX, mouseY))
        elif MoveResource == 6:
            window.blit(moveADOBE,(mouseX, mouseY))
        elif MoveResource == 7:
            window.blit(moveGOLD,(mouseX, mouseY))
        elif MoveResource == 8:
            window.blit(moveCOPPER,(mouseX, mouseY))
        elif MoveResource == 9:
            window.blit(moveBRONZE,(mouseX, mouseY))
        elif MoveResource == 10:
            window.blit(moveCRYSTAL,(mouseX, mouseY))
        elif MoveResource == 11:
            window.blit(moveSTONE,(mouseX, mouseY))
        elif MoveResource == 12:
            window.blit(moveCLAY,(mouseX, mouseY))
        elif MoveResource == 13:
            window.blit(moveWOOD,(mouseX, mouseY))
        elif MoveResource == 14:
            window.blit(smallPOP,(mouseX, mouseY))
                        
        if MiniBoxSector != BoxSector and (mouseX < MapLocaX+20 or mouseX > MapLocaX+500) and (mouseY < MapLocaY or mouseY > MapLocaX+500):
            MiniBoxSector = BoxSector
            MiniX = SelectX
            MiniY = SelectY
            
        #box_info = font1.render(str(resMouseX) + " " + str(resMouseY), 1,(black))
        #window.blit(box_info,(mouseX, mouseY+20))

        #if SectorZoom == True:
            #test_info = font1.render(str(mouseX-resLocaX) + " " + str(mouseY-resLocaY), 1,(white))
            #window.blit(test_info,(mouseX+50, mouseY+80))

        #test_info = font1.render(str(mouseX - SecLocaX) + " " + str(mouseY - SecLocaY), 1,(black))
        #window.blit(test_info,(mouseX-50, mouseY-50))
        
        #test_info = font1.render(str(ZoomPosX) + " " + str(ZoomPosY), 1,(black))
        #window.blit(test_info,(mouseX-50, mouseY-50))

        #test_info = font1.render(str(ZoomConstruct[ZoomSector]) + " " + str(ZoomBuild[ZoomSector]) + " " + str(LaborClick), 1,(black))
        #window.blit(test_info,(mouseX-50, mouseY-50))

        #test_info = font1.render(str(mouseX - MapLocaX) + " " + str(mouseY - MapLocaY), 1,(black))
        #window.blit(test_info,(mouseX-50, mouseY-50))
        
        #test_info = font1.render(str(ScrollY-resLocaY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY+20))
        
        #if ZoomConstruct[ZoomSector] > -1:
            #test_info = font1.render(str(BuildLabor[ZoomSector]), 1,(black))
            #window.blit(test_info,(mouseX, mouseY+20)) 

        #test_info = font1.render(str(secStorage[Clicked]), 1,(black))
        #window.blit(test_info,(mouseX, mouseY+20))        

        #test_info = font1.render(str(SectorX) + " " + str(SectorY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY-40))
        
        #test_info = font9.render(str(SelectX) + " " + str(SelectY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY+40))
        
        #test_info = font9.render(str(mouseX) + " " + str(mouseY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY-180))
               
        #test_info = font9.render(str(mouseX-SecLocaX) + " " + str(mouseY-SecLocaY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY+40))
        
        #test_info = font1.render(str(SectX) + " " + str(SectY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY+40))
        
        #test_info = font9.render(str(mouseX) + " " + str(mouseY), 1,(black))
        #window.blit(test_info,(mouseX, mouseY+40))
        
        #if Viewed > 1:
            #test_info = font1.render(str(ZoomSector) + " " + str(zoom_sector[Clicked]), 1,(black))
            #window.blit(test_info,(mouseX-40, mouseY+40))
        
        #if Storage > 0:
            #test_info = font6.render(str(Storage), 1,(black))
            #window.blit(test_info,(mouseX-20, mouseY-40))
        '''    
        if secBuilding[Clicked][0] > 0:
            test_info = font6.render(str(secBuilding[Clicked][0]), 1,(black))
            window.blit(test_info,(mouseX-40, mouseY-40))
        if secBuilding[Clicked][1] > 0:
            test_info = font6.render(str(secBuilding[Clicked][1]), 1,(black))
            window.blit(test_info,(mouseX-20, mouseY-40))
        if secBuilding[Clicked][2] > 0:
            test_info = font6.render(str(secBuilding[Clicked][2]), 1,(black))
            window.blit(test_info,(mouseX, mouseY-40))
            '''
        
        #pygame.draw.polygon(window, black, ((0, 700), (1370, 700), (1370, 1400), (0, 1400))) # <-- black bottom edge    
        pygame.display.flip()
        window.fill(black)
        while TickPause > 0:
            TickPause -= 1
            clock.tick(scroll_speed/2)            

    # --- MENU LOOP --- PICKLE SAVE ------------------- Saving a map -------------------------
        if SaveToggle == True:
            if SaveFile == 1:
                file_loca = "C:\Tribes\save\save1"
            if SaveFile == 2:
                file_loca = "C:\Tribes\save\save2"
            if SaveFile == 3:
                file_loca = "C:\Tribes\save\save3"
        # Resource1 Ownership Variables
            pickle.dump(ownGrain, open(file_loca + own_file[1], "wb" ))
            pickle.dump(ownMeat, open(file_loca + own_file[2], "wb" ))
            pickle.dump(ownForage, open(file_loca + own_file[3], "wb" ))
            pickle.dump(ownHerb, open(file_loca + own_file[4], "wb" ))
            pickle.dump(ownPottery, open(file_loca + own_file[5], "wb" ))
            pickle.dump(ownAdobe, open(file_loca + own_file[6], "wb" ))
        # Resource1 Transfer Move Variables
            pickle.dump(movGrain, open(file_loca + mov_file[1], "wb" ))
            pickle.dump(movMeat, open(file_loca + mov_file[2], "wb" ))
            pickle.dump(movForage, open(file_loca + mov_file[3], "wb" ))
            pickle.dump(movHerb, open(file_loca + mov_file[4], "wb" ))
            pickle.dump(movPottery, open(file_loca + mov_file[5], "wb" ))
            pickle.dump(movAdobe, open(file_loca + mov_file[6], "wb" ))
        # Resource1 Wait Variables
            pickle.dump(waitGrain, open(file_loca + wait_file[1], "wb" ))
            pickle.dump(waitMeat, open(file_loca + wait_file[2], "wb" ))
            pickle.dump(waitForage, open(file_loca + wait_file[3], "wb" ))
            pickle.dump(waitHerb, open(file_loca + wait_file[4], "wb" ))
            pickle.dump(waitPottery, open(file_loca + wait_file[5], "wb" ))
            pickle.dump(waitAdobe, open(file_loca + wait_file[6], "wb" ))

        # Resource2 Ownership Variables
            pickle.dump(ownGold, open(file_loca + own_file[7], "wb" ))
            pickle.dump(ownCopper, open(file_loca + own_file[8], "wb" ))
            pickle.dump(ownBronze, open(file_loca + own_file[9], "wb" ))
            pickle.dump(ownCrystal, open(file_loca + own_file[10], "wb" ))
            pickle.dump(ownStone, open(file_loca + own_file[11], "wb" ))
            pickle.dump(ownClay, open(file_loca + own_file[12], "wb" ))
            pickle.dump(ownWood, open(file_loca + own_file[13], "wb" ))
            pickle.dump(ownTools, open(file_loca + own_file[14], "wb" ))
            pickle.dump(OldResources, open(file_loca + own_file[15], "wb" ))
            pickle.dump(NewResources, open(file_loca + own_file[16], "wb" ))
            pickle.dump(CropPotential, open(file_loca + own_file[17], "wb" ))
        # Resource2 Transfer Move Variables
            pickle.dump(movGold, open(file_loca + mov_file[7], "wb" ))
            pickle.dump(movCopper, open(file_loca + mov_file[8], "wb" ))
            pickle.dump(movBronze, open(file_loca + mov_file[9], "wb" ))
            pickle.dump(movCrystal, open(file_loca + mov_file[10], "wb" ))
            pickle.dump(movStone, open(file_loca + mov_file[11], "wb" ))
            pickle.dump(movClay, open(file_loca + mov_file[12], "wb" ))
            pickle.dump(movWood, open(file_loca + mov_file[13], "wb" ))
            pickle.dump(movPop, open(file_loca + mov_file[14], "wb" ))
            pickle.dump(movTools, open(file_loca + mov_file[15], "wb" ))
        # Resource2 Wait Variables
            pickle.dump(waitGold, open(file_loca + wait_file[7], "wb" ))
            pickle.dump(waitCopper, open(file_loca + wait_file[8], "wb" ))
            pickle.dump(waitBronze, open(file_loca + wait_file[9], "wb" ))
            pickle.dump(waitCrystal, open(file_loca + wait_file[10], "wb" ))
            pickle.dump(waitStone, open(file_loca + wait_file[11], "wb" ))
            pickle.dump(waitClay, open(file_loca + wait_file[12], "wb" ))
            pickle.dump(waitWood, open(file_loca + wait_file[13], "wb" ))
            pickle.dump(waitPop, open(file_loca + wait_file[14], "wb" ))
            pickle.dump(waitTools, open(file_loca + wait_file[15], "wb" ))
            pickle.dump(ZoomWait, open(file_loca + wait_file[16], "wb" ))

        # Sector Attribute Variables
            pickle.dump(secTerra, open(file_loca + sec_file[1], "wb" ))
            pickle.dump(secRoad, open(file_loca + sec_file[2], "wb" ))
            pickle.dump(secWater, open(file_loca + sec_file[3], "wb" ))
            pickle.dump(secMineral, open(file_loca + sec_file[4], "wb" ))
            pickle.dump(secHealth, open(file_loca + sec_file[5], "wb" ))
            pickle.dump(secHerb, open(file_loca + sec_file[6], "wb" ))
            pickle.dump(ZoomTerra, open(file_loca + sec_file[7], "wb" ))
            pickle.dump(ZoomBuild, open(file_loca + sec_file[8], "wb" ))
            pickle.dump(zoom_sector, open(file_loca + sec_file[9], "wb" ))
            pickle.dump(Viewed, open(file_loca + sec_file[10], "wb" ))
            pickle.dump(secDescribe, open(file_loca + sec_file[11], "wb" ))
            pickle.dump(secOwn, open(file_loca + sec_file[12], "wb" ))
            pickle.dump(secPop, open(file_loca + sec_file[13], "wb" ))
            pickle.dump(secMaxPop, open(file_loca + sec_file[14], "wb" ))
            pickle.dump(MoonCycle, open(file_loca + sec_file[15], "wb" ))
            pickle.dump(ZoomTrees, open(file_loca + sec_file[16], "wb" ))
            pickle.dump(secBuilding, open(file_loca + sec_file[17], "wb" ))
            pickle.dump(ZoomConstruct, open(file_loca + sec_file[18], "wb" ))
            pickle.dump(ZoomWater, open(file_loca + sec_file[19], "wb" ))
            pickle.dump(ZoomMineral, open(file_loca + sec_file[20], "wb" ))
            pickle.dump(ZoomLabor, open(file_loca + sec_file[21], "wb" ))
            pickle.dump(ZoomHerb, open(file_loca + sec_file[22], "wb" ))
            pickle.dump(MoonPhase, open(file_loca + sec_file[23], "wb" ))
            pickle.dump(secHappy, open(file_loca + sec_file[24], "wb" ))
            pickle.dump(BuildLabor, open(file_loca + sec_file[25], "wb" ))
            pickle.dump(secExplored, open(file_loca + sec_file[26], "wb" ))
            pickle.dump(EnemyBuild, open(file_loca + sec_file[27], "wb" ))
                        
        # Box/Window Location Variables
            pickle.dump(StartSector, open(file_loca + loca_file[1], "wb" ))
            pickle.dump(MapLocaX, open(file_loca + loca_file[2], "wb" ))
            pickle.dump(MapLocaY, open(file_loca + loca_file[3], "wb" ))
            pickle.dump(SecLocaX, open(file_loca + loca_file[4], "wb" ))
            pickle.dump(SecLocaY, open(file_loca + loca_file[5], "wb" ))
            pickle.dump(infLocaX, open(file_loca + loca_file[6], "wb" ))
            pickle.dump(infLocaY, open(file_loca + loca_file[7], "wb" ))
            pickle.dump(SelectX, open(file_loca + loca_file[8], "wb" ))
            pickle.dump(SelectX, open(file_loca + loca_file[9], "wb" ))
            pickle.dump(StartX, open(file_loca + loca_file[10], "wb" ))
            pickle.dump(StartY, open(file_loca + loca_file[11], "wb" ))
            pickle.dump(ConvoyBlu, open(file_loca + loca_file[12], "wb" ))  
            SaveToggle = False

    # --- MENU LOOP --- PICKLE LOAD ------------------- Loading a saved map -------------------------
        if LoadToggle == True:
            StatTimer = 5
            if SaveFile == 1:
                file_loca = "C:\Tribes\save\save1"
            if SaveFile == 2:
                file_loca = "C:\Tribes\save\save2"
            if SaveFile == 3:
                file_loca = "C:\Tribes\save\save3"
            MoveResource = 0
        # Resource1 Ownership Variables
            ownGrain = pickle.load(open(file_loca + own_file[1], "rb" ))
            ownMeat = pickle.load(open(file_loca + own_file[2], "rb" ))
            ownForage = pickle.load(open(file_loca + own_file[3], "rb" ))
            ownHerb = pickle.load(open(file_loca + own_file[4], "rb" ))
            ownPottery = pickle.load(open(file_loca + own_file[5], "rb" ))
            ownAdobe = pickle.load(open(file_loca + own_file[6], "rb" ))
        # Resource1 Transfer Move Variables
            movGrain = pickle.load(open(file_loca + mov_file[1], "rb" ))
            movMeat = pickle.load(open(file_loca + mov_file[2], "rb" ))
            movForage = pickle.load(open(file_loca + mov_file[3], "rb" ))
            movHerb = pickle.load(open(file_loca + mov_file[4], "rb" ))
            movPottery = pickle.load(open(file_loca + mov_file[5], "rb" ))
            movAdobe = pickle.load(open(file_loca + mov_file[6], "rb" ))
        # Resource1 Wait Variables
            waitGrain = pickle.load(open(file_loca + wait_file[1], "rb" ))
            waitMeat = pickle.load(open(file_loca + wait_file[2], "rb" ))
            waitForage = pickle.load(open(file_loca + wait_file[3], "rb" ))
            waitHerb = pickle.load(open(file_loca + wait_file[4], "rb" ))
            waitPottery = pickle.load(open(file_loca + wait_file[5], "rb" ))
            waitAdobe = pickle.load(open(file_loca + wait_file[6], "rb" ))
        # Resource2 Ownership Variables        
            ownGold = pickle.load(open(file_loca + own_file[7], "rb" ))
            ownCopper = pickle.load(open(file_loca + own_file[8], "rb" ))
            ownBronze = pickle.load(open(file_loca + own_file[9], "rb" ))
            ownCrystal = pickle.load(open(file_loca + own_file[10], "rb" ))
            ownStone = pickle.load(open(file_loca + own_file[11], "rb" ))
            ownClay = pickle.load(open(file_loca + own_file[12], "rb" ))
            ownWood = pickle.load(open(file_loca + own_file[13], "rb" ))
            ownTools = pickle.load(open(file_loca + own_file[14], "rb" ))
            OldResources = pickle.load(open(file_loca + own_file[15], "rb" ))
            NewResources = pickle.load(open(file_loca + own_file[16], "rb" ))  
            CropPotential = pickle.load(open(file_loca + own_file[17], "rb" ))
        # Resource2 Move Transfer Variables        
            movGold = pickle.load(open(file_loca + mov_file[7], "rb" ))
            movCopper = pickle.load(open(file_loca + mov_file[8], "rb" ))
            movBronze = pickle.load(open(file_loca + mov_file[9], "rb" ))
            movCrystal = pickle.load(open(file_loca + mov_file[10], "rb" ))
            movStone = pickle.load(open(file_loca + mov_file[11], "rb" ))
            movClay = pickle.load(open(file_loca + mov_file[12], "rb" ))
            movWood = pickle.load(open(file_loca + mov_file[13], "rb" ))
            movPop = pickle.load(open(file_loca + mov_file[14], "rb" ))
            movTools = pickle.load(open(file_loca + mov_file[15], "rb" ))
        # Resource2 Wait Variables        
            waitGold = pickle.load(open(file_loca + wait_file[7], "rb" ))
            waitCopper = pickle.load(open(file_loca + wait_file[8], "rb" ))
            waitBronze = pickle.load(open(file_loca + wait_file[9], "rb" ))
            waitCrystal = pickle.load(open(file_loca + wait_file[10], "rb" ))
            waitStone = pickle.load(open(file_loca + wait_file[11], "rb" ))
            waitClay = pickle.load(open(file_loca + wait_file[12], "rb" ))
            waitWood = pickle.load(open(file_loca + wait_file[13], "rb" ))
            waitPop = pickle.load(open(file_loca + wait_file[14], "rb" ))
            waitTools = pickle.load(open(file_loca + wait_file[15], "rb" ))
            ZoomWait = pickle.load(open(file_loca + wait_file[16], "rb" ))
        # Sector Attribute Variables
            secTerra = pickle.load(open(file_loca + sec_file[1], "rb" ))
            secRoad = pickle.load(open(file_loca + sec_file[2], "rb" ))
            secWater = pickle.load(open(file_loca + sec_file[3], "rb" ))
            secMineral = pickle.load(open(file_loca + sec_file[4], "rb" ))
            secHealth = pickle.load(open(file_loca + sec_file[5], "rb" ))
            secHerb = pickle.load(open(file_loca + sec_file[6], "rb" ))
            ZoomTerra = pickle.load(open(file_loca + sec_file[7], "rb" ))
            ZoomBuild = pickle.load(open(file_loca + sec_file[8], "rb" ))
            zoom_sector = pickle.load(open(file_loca + sec_file[9], "rb" ))
            Viewed = pickle.load(open(file_loca + sec_file[10], "rb" ))
            secDescribe = pickle.load(open(file_loca + sec_file[11], "rb" ))
            secOwn = pickle.load(open(file_loca + sec_file[12], "rb" ))
            secPop = pickle.load(open(file_loca + sec_file[13], "rb" ))
            secMaxPop = pickle.load(open(file_loca + sec_file[14], "rb" ))
            MoonCycle = pickle.load(open(file_loca + sec_file[15], "rb" ))
            ZoomTrees = pickle.load(open(file_loca + sec_file[16], "rb" ))
            secBuilding = pickle.load(open(file_loca + sec_file[17], "rb" ))
            ZoomConstruct = pickle.load(open(file_loca + sec_file[18], "rb" ))
            ZoomWater = pickle.load(open(file_loca + sec_file[19], "rb" ))
            ZoomMineral = pickle.load(open(file_loca + sec_file[20], "rb" ))
            ZoomLabor = pickle.load(open(file_loca + sec_file[21], "rb" ))
            ZoomHerb = pickle.load(open(file_loca + sec_file[22], "rb" ))
            MoonPhase = pickle.load(open(file_loca + sec_file[23], "rb" ))
            secHappy = pickle.load(open(file_loca + sec_file[24], "rb" ))
            BuildLabor = pickle.load(open(file_loca + sec_file[25], "rb" ))
            secExplored = pickle.load(open(file_loca + sec_file[26], "rb" ))
            EnemyBuild = pickle.load(open(file_loca + sec_file[27], "rb" ))
        # Box/Window Location Variables
            StartSector = pickle.load(open(file_loca + loca_file[1], "rb" ))
            MapLocaX = pickle.load(open(file_loca + loca_file[2], "rb" ))
            MapLocaY = pickle.load(open(file_loca + loca_file[3], "rb" ))
            SecLocaX = pickle.load(open(file_loca + loca_file[4], "rb" ))
            SecLocaY = pickle.load(open(file_loca + loca_file[5], "rb" ))
            infLocaX = pickle.load(open(file_loca + loca_file[6], "rb" ))
            infLocaY = pickle.load(open(file_loca + loca_file[7], "rb" ))
            SelectX = pickle.load(open(file_loca + loca_file[8], "rb" ))
            SelectX = pickle.load(open(file_loca + loca_file[9], "rb" ))
            StartX = pickle.load(open(file_loca + loca_file[10], "rb" ))
            StartY = pickle.load(open(file_loca + loca_file[11], "rb" ))
            ConvoyBlu = pickle.load(open(file_loca + loca_file[12], "rb" ))
        # When the new map loads, this will bring player to start position
            SelectX = StartX-10
            SelectY = StartY-5
            LoadToggle = False

    # --- MENU LOOP --- Keyboard and Mouse Events
        if MenuLoop == True:
            pygame.mouse.set_visible(True)        
            MenuClick = False
        while MenuLoop:
            (mouseX, mouseY) = pygame.mouse.get_pos()       
          
            window.blit(background,(1, 1))
            text_loca = font2.render(str(mouseX) + "  " + str(mouseY), 1,(white))
            window.blit(text_loca,(100, 100))

            SectorZoom = False
            MapToggle = False
            for event in pygame.event.get():
                if (event.type==pygame.QUIT):
                    MainLoop = False
                    NewMap = False
                    MenuLoop = False
                elif (event.type == KEYDOWN):
                    if (event.key == K_ESCAPE):
                        MenuLoop = False
                        MainLoop = True
                elif pygame.mouse.get_pressed()[0]:
                    # SAVE BUTTON -------->
                    if (mouseX > 363 and mouseX < 513) and (mouseY > 74 and mouseY < 144):
                        SaveFile = 1
                        SaveToggle = True
                        LoadToggle = False
                        MenuClick = True
                        window.blit(boxMENU,(300, 10))
                        window.blit(menu_select,(360, 69))
                        clock.tick(scroll_speed/2)
                    # LOAD BUTTON -------->
                    if (mouseX > 363 and mouseX < 513) and (mouseY > 156 and mouseY < 228):
                        SaveFile = 1
                        LoadToggle = True
                        MenuClick = True
                        window.blit(boxMENU,(300, 10))
                        window.blit(menu_select,(360, 151))
                        clock.tick(scroll_speed/2)
                    # NEW BUTTON -------->                        
                    if (mouseX > 363 and mouseX < 513) and (mouseY > 240 and mouseY < 311):
                        NewMap = True
                        MenuClick = True
                        window.blit(boxMENU,(300, 10))
                        window.blit(menu_select,(360, 235))
                        clock.tick(scroll_speed/2)
                    # QUIT BUTTON -------->                        
                    if (mouseX > 363 and mouseX < 513) and (mouseY > 325 and mouseY < 395):
                        window.blit(boxMENU,(300, 10))
                        window.blit(menu_select,(360, 320))
                        MainLoop = False
                        NewMap = False
                        MenuLoop = False
                        
            if MenuClick == False:
                window.blit(boxMENU,(300, 10))
                menu_msg = font2.render("Press [ESC] to return to the game.", 1,(white))
                window.blit(menu_msg,(350, 600))
                pygame.display.flip()
                window.fill(black)
            
            if MenuClick == True:
                pygame.display.flip()
                window.fill(black)
                clock.tick(scroll_speed/4)
                if NewMap != True:
                    MainLoop = True
                else:
                    MainLoop = False
                MenuLoop = False
